2006-12-31 17:57  edwin

	* src/vm/jit/inline/inline.c (test_inlining): Deactivated typechecking
	of inlined result.

2006-12-28 21:21  twisti

	* src/vm/jit/alpha/disass.c (regs): Removed.
	* src/vm/jit/alpha/md-abi.c (regs): Added.

2006-12-28 20:56  twisti

	* src/vm/jit/i386/disass.c (regs): Removed.
	* src/vm/jit/i386/md-abi.c (regs): Added.

2006-12-28 20:50  twisti

	* src/vm/jit/x86_64/disass.c (regs): Removed.
	* src/vm/jit/x86_64/md-abi.c (regs): Added.

2006-12-28 15:38  twisti

	* src/native/include/Makefile.am (NO_GEN_JAVASE_HEADER_FILES): Removed
	java_lang_Object.h.
	(JAVASE_HEADER_FILES): Added java_lang_Object.h.
	* src/native/include/.cvsignore: Likewise.
	* src/native/include/java_lang_VMObject.h: Removed.

2006-12-28 13:43  twisti

	* tests/regression/Makefile.am,
	tests/regression/codepatching/Makefile.am,
	tests/regression/jasmin/Makefile.am,
	tests/regression/native/Makefile.am (JAVAFLAGS) [WITH_CLASSPATH_GNU]:
	Set differently for GNU Classpath.

2006-12-28 12:30  twisti

	* src/mm/memory.c (memory_mmap_anon): Fixed indentation and a debug
	typo.
	* src/vm/signal.c (signal_init): Removed unused variable.

2006-12-28 11:57  twisti

	* src/fdlibm/fdlibm.h (exception): Commented since it was already
	defined on
	IRIX (don't know where).

2006-12-28 00:19  twisti

	* src/threads/native/threads.c (threads_attach_current_thread): Fixed
	compiler warning.
	(threads_detach_thread): Likewise.
	(threads_find_non_daemon_thread): Fixed bug, we returned the wrong
	threads.

2006-12-27 23:54  twisti

	* src/threads/native/threads.c (threads_init): Fixed another typo.

2006-12-27 23:42  twisti

	* src/threads/native/threads.c (threads_init): Fixed typo.
	
	* src/native/jni.c (native/include/java_lang_ClassLoader.h): Added.
	* src/native/vm/gnu/java_lang_VMRuntime.c: Likewise.

2006-12-27 23:15  twisti

	* src/vm/class.c [ENABLE_JAVASE] (arrayclass_java_lang_Object): Added
	#ifdef.
	* src/vm/class.h: Likewise.
	
	* src/vm/loader.c: Java ME changes.
	
	* src/vm/finalizer.c (finalizer_start_thread): Set flags.
	* src/vm/jit/optimizing/recompile.c (recompile_start_thread):
	Likewise.
	
	* src/vm/jit/stacktrace.c [ENABLE_JAVASE] (stacktrace_getStack): Added
	#ifdef.
	
	* src/vm/jit/codegen-common.c (codegen_start_native_call)
	[ENABLE_JAVASE]: #ifdef'ed the local references table stuff (maybe we
	need to change that for cacao-gc).
	(codegen_finish_native_call): Likewise.
	
	* src/vm/exceptions.c (exceptions_asm_new_abstractmethoderror)
	[!ENABLE_JAVASE]: In the meantime we throw a VirtualMachineError.
	* src/vm/exceptions.h: Likewise.
	
	* src/vm/linker.c: Java ME changes.
	
	* src/native/native.c: Likewise.
	* src/native/native.h: Likewise.
	
	* src/threads/native/threads.h (THREAD_FLAG_DAEMON): Added.
	(threadobject): Changed flags to u4.
	* src/threads/native/threads.c: A lot of Java ME changes.

2006-12-27 23:05  twisti

	* src/vm/jit/powerpc/emit.c (emit_verbosecall_enter) [!NDEBUG]: We
	also define the function with NDEBUG, but empty.
	(emit_verbosecall_exit): Likewise.
	* src/vm/jit/powerpc/codegen.c (codegen): Removed
	JITDATA_HAS_FLAG_VERBOSECALL from emit_verbosecall calls.

2006-12-27 23:00  twisti

	* src/vm/properties.c (properties_init) [ENABLE_JAVAME_CLDC1_1]: Set
	values as Sun's JVM does.

2006-12-27 22:39  twisti

	* src/vm/jit/stacktrace.c: Java ME changes.
	* src/vm/jit/stacktrace.h: Likewise.

2006-12-27 22:31  twisti

	* tests/regression/Makefile.am: Renamed CLASSPATH_GLIBJ_ZIP to
	CLASSPATH_CLASSES.
	* tests/regression/codepatching/Makefile.am: Likewise.
	* tests/regression/jasmin/Makefile.am: Likewise.
	* tests/regression/native/Makefile.am: Likewise.

2006-12-27 21:13  ajordan

	* src/vm/jit/sparc64/asmpart.S: Some fixes for exception handling.
	* src/vm/jit/sparc64/codegen.c: Likewise.

2006-12-27 15:22  twisti

	* contrib/setenvinstalled.in: Renamed CLASSPATH_GLIBJ_ZIP to
	CLASSPATH_CLASSES.
	* contrib/setenvsource.in: Likewise.

2006-12-27 15:15  twisti

	* src/vm/class.c: Java ME changes.
	* src/vm/class.h: Likewise.
	* src/vm/exceptions.c: Likewise.
	(exceptions_new_virtualmachineerror): New function.
	(exceptions_throw_virtualmachineerror):
	* src/vm/exceptions.h: Likewise.
	* src/vm/resolve.c: Likewise.
	* src/vm/utf8.c: Likewise.
	* src/vm/utf8.h: Likewise.
	* src/cacaoh/headers.c: Likewise.

2006-12-27 13:56  twisti

	* configure.ac (--with-classpath-glibj-zip): Renamed to
	--with-classpath-classes.
	
	* m4/ac_prog_javac.m4 (AC_PROG_JAVAC): Renamed CLASSPATH_GLIBJ_ZIP to
	CLASSPATH_CLASSES.
	
	* src/Makefile.am (VM_DIR): Added.
	(SUBDIRS): Use VM_DIR.
	
	* src/native/include/Makefile.am [WITH_CLASSPATH_GNU] (CLASSPATH): Set
	differently for non-gnu classpaths.
	
	* src/cacaoh/cacaoh.c (main) [WITH_CLASSPATH_GNU]: Likewise.
	* src/vm/vm.c (vm_create): Likewise.

2006-12-27 00:08  twisti

	* src/fdlibm/fdlibm.h [!MAXFLOAT] (MAXFLOAT): Only define if not
	already defined.
	* src/fdlibm/k_tan.c: Commented pragma.

2006-12-26 23:42  twisti

	* src/vm/resolve.h (vm/class.h): Added.
	(vm/method.h): Likewise.

2006-12-26 23:41  twisti

	* src/vm/exceptions.c (native/jni.h): Added.
	(exceptions_init): Java ME changes.
	(exceptions_print_exception): Likewise.
	* src/vm/exceptions.h (native/jni.h): Added.

2006-12-26 23:39  twisti

	* src/vm/properties.c [ENABLE_JAVASE]
	(native/include/java_util_Properties.h): Include conditionally.
	* src/vm/properties.h: Likewise.

2006-12-26 23:34  twisti

	* src/native/include/Makefile.am (CLEANFILES): Added
	JAVASE_HEADER_FILES and JAVAME_CLDC1_1_HEADER_FILES.
	(cleanall): New target to clean all header files.

2006-12-26 23:26  twisti

	* src/native/include/Makefile.am: Java ME changes.
	* src/native/include/.cvsignore: Likewise.

2006-12-26 23:21  twisti

	* src/native/Makefile.am [ENABLE_JAVASE] (JNI_SOURCES): Added.
	(libnative_la_SOURCES): Added JNI_SOURCES.

2006-12-26 23:16  twisti

	* configure.ac (--with-classpath): Added cldc1.1 target.
	(AC_CONFIG_FILES): Added src/native/vm/cldc1.1/Makefile.

2006-12-26 23:14  twisti

	* src/native/vm/java_lang_Thread.h,
	src/native/vm/java_lang_Class.c,
	src/native/vm/java_lang_Object.c,
	src/native/vm/java_lang_Thread.c,
	src/native/vm/java_lang_Class.h,
	src/native/vm/java_lang_Object.h: Java ME changes.

2006-12-26 23:13  twisti

	* src/native/vm/Makefile.am (DIST_SUBDIRS): Added cldc1.1.
	(NATIVEVM_LIB): Renamed to libnativevmcore.
	* src/native/vm/gnu/Makefile.am (noinst_LTLIBRARIES): Likewise.
	(libnativevmgnu_la_SOURCES): Renamed to libnativevmcore_la_SOURCES.

2006-12-26 23:09  twisti

	* src/native/vm/cldc1.1/.cvsignore: Added.
	* src/native/vm/cldc1.1/com_sun_cldchi_io_ConsoleOutputStream.c,
	src/native/vm/cldc1.1/java_lang_Runtime.c,
	src/native/vm/cldc1.1/java_lang_System.c,
	src/native/vm/cldc1.1/java_lang_Class.c,
	src/native/vm/cldc1.1/java_lang_Float.c,
	src/native/vm/cldc1.1/java_lang_Object.c,
	src/native/vm/cldc1.1/java_lang_String.c,
	src/native/vm/cldc1.1/Makefile.am,
	src/native/vm/cldc1.1/java_lang_Thread.c,
	src/native/vm/cldc1.1/java_lang_Throwable.c,
	src/native/vm/cldc1.1/java_lang_Math.c,
	src/native/vm/cldc1.1/java_lang_Double.c: New file.

2006-12-26 23:05  twisti

	* src/fdlibm/Makefile.am [ENABLE_JAVAME_CLDC1_1]
	(libfdlibm_la_SOURCES): Added the following files.
	
	* src/fdlibm/k_cos.c,
	src/fdlibm/s_ceil.c,
	src/fdlibm/k_sin.c,
	src/fdlibm/s_floor.c,
	src/fdlibm/s_tan.c,
	src/fdlibm/s_cos.c,
	src/fdlibm/s_sin.c,
	src/fdlibm/w_sqrt.c,
	src/fdlibm/e_rem_pio2.c,
	src/fdlibm/k_rem_pio2.c,
	src/fdlibm/k_tan.c,
	src/fdlibm/e_sqrt.c: New file.

2006-12-26 22:33  twisti

	* src/fdlibm/s_finite.c,
	src/fdlibm/fdlibm.h,
	src/fdlibm/ieeefp.h,
	src/fdlibm/e_fmod.c,
	src/fdlibm/mprec.h,
	src/fdlibm/w_fmod.c,
	src/fdlibm/s_copysign.c: Updated from GNU Classpath.

2006-12-26 19:56  twisti

	* src/threads/native/threads.c: Rewritten such that threadobject
	extends a java.lang.Thread object instead of java.lang.VMThread.
	* src/threads/native/threads.h: Likewise.
	
	* src/vm/finalizer.c (finalizer_vmthread): Renamed to thread_finalizer
	and changed type to threadobject*.
	(lock_finalizer_thread): Renamed to lock_thread_finalizer.
	(finalizer_init): Changed variable names.
	(finalizer_start_thread): Thread-code changes.
	
	* src/vm/jit/optimizing/recompile.c (recompile_vmthread): Renamed to
	thread_recompile and changed type to threadobject*.
	(lock_recompile_thread): Renamed to lock_thread_recompile.
	(recompile_init): Changed variable names.
	(recompile_thread): Likewise.
	(recompile_queue_method): Likewise.
	(recompile_start_thread): Thread-code changes.
	
	* src/vm/utf8.c (utf_addThread): Added.
	* src/vm/utf8.h: Likewise.
	
	* src/lib/vm/reference/java/lang/VMThread.java (create): Set vmThread
	before calling start.
	
	* src/native/vm/gnu/java_lang_VMThread.c: Call _Jv_java_lang_Thread
	functions.
	
	* src/native/vm/Makefile.am (libnativevm_la_SOURCES): Added
	java_lang_Thread.[ch].
	* src/native/vm/java_lang_Thread.c: New file.
	* src/native/vm/java_lang_Thread.h: Likewise.

2006-12-26 19:41  twisti

	* src/vm/annotation.c
	(annotation_load_attribute_runtimevisibleannotations): Renamed aev to
	element_value.

2006-12-26 19:40  twisti

	* src/native/include/java_lang_Thread.h: Updated to current GNU
	Classpath head.
	* src/native/include/java_lang_VMThread.h: Likewise.

2006-12-26 19:30  twisti

	* src/threads/native/lock.c (lock_wait_for_object): Renamed t to
	thread.
	(lock_notify_object): Likewise.
	(lock_notify_all_object): Likewise.

2006-12-23 23:52  twisti

	* configure.ac (--with-classpath): Added.

2006-12-21 15:59  twisti

	* src/native/vm/java_lang_Object.c (wait): Removed debugging output.

2006-12-21 15:56  twisti

	* src/native/vm/Makefile.am (libnativevm_la_SOURCES): Added
	java_lang_Class.h and java_lang_Object.[ch].
	
	* src/native/vm/java_lang_Object.c: New file.
	* src/native/vm/java_lang_Object.h: Likewise.
	
	* src/native/vm/gnu/java_lang_VMObject.c: Call _Jv_java_lang_Object
	functions.

2006-12-19 19:20  twisti

	* src/mm/memory.c (memory_mmap_anon): New function.
	(memory_cnew): Use memory_mmap_anon.
	* src/mm/memory.h (memory_mmap_anon): Added.
	* src/vm/signal.c (signal_init): Use memory_mmap_anon.

2006-12-19 19:12  twisti

	* src/native/vm/java_lang_Class.h
	(_Jv_java_lang_Class_getEnclosingConstructor): Removed #if 0.

2006-12-18 18:21  twisti

	* src/vm/class.c (vm/suck.h): Added.
	(class_load_attribute_sourcefile): New function.
	(class_load_attribute_enclosingmethod): Likewise.
	(class_load_attributes): Likewise.
	
	* src/vm/loader.c [ENABLE_JAVASE] (vm/annotation.h, vm/stackmap.h):
	Added.
	(skipattributebody): Renamed to loader_skip_attribute_body, made
	non-static.
	(skipattributes): Removed.
	(loader_load_attribute_signature): New function.
	(load_field): Use loader_load_attribute_signature.
	(load_method): Renamed to loader_load_method, call
	stackmap_load_attribute_stackmaptable and
	loader_load_attribute_signature.
	(load_attributes): Removed.
	(load_class_from_classbuffer): Renamed load_method to
	loader_load_method and load_attributes to class_load_attributes.
	* src/vm/loader.h (loader_skip_attribute_body): Added.
	[ENABLE_JAVASE] (loader_load_attribute_signature): Likewise.
	
	* src/vm/method.h [ENABLE_JAVASE] (vm/stackmap.h): Added.
	(methodinfo) [ENABLE_JAVASE]: Added signature and stack_map.
	
	* src/vm/statistics.c (size_stack_map): Added.
	(print_stats): Print stack_map size.
	* src/vm/statistics.h (size_stack_map): Likewise.
	
	* src/vm/global.h (JAVA_VERSION): Changed to "1.5.0".
	(CLASS_VERSION): Changed to "50.0".
	(MAJOR_VERSION): Changed to 50.
	
	* src/vm/utf8.c [ENABLE_JAVASE] (utf_EnclosingMethod)
	(utf_RuntimeVisibleAnnotations, utf_StackMapTable): Added.
	(utf8_init) [ENABLE_JAVASE]: Init utf_EnclosingMethod,
	utf_RuntimeVisibleAnnotations and utf_StackMapTable.
	* src/vm/utf8.h [ENABLE_JAVASE] (utf_EnclosingMethod)
	(utf_RuntimeVisibleAnnotations, utf_StackMapTable): Added.
	
	* src/vm/properties.c (properties_init): Changed
	java.specification.version to 1.5.
	
	* src/vm/Makefile.am [ENABLE_JAVASE] (ANNOTATION_OBJ): Renamed to
	ANNOTATION_SOURCES.
	[ENABLE_JAVASE] (STACKMAP_SOURCES): Added.
	[ENABLE_STATISTICS] (STATISTICS_OBJ): Renamed to STATISTICS_SOURCES.
	(libvmcore_la_SOURCES): Added STACKMAP_SOURCES.
	* src/vm/stackmap.c: New file.
	* src/vm/stackmap.h: Likewise.

2006-12-18 18:04  twisti

	* src/native/vm/gnu/.cvsignore: New file.

2006-12-18 17:36  twisti

	* src/vm/class.h (vm/loader.h): Added.
	(classinfo): Added enclosingclass and enclosingmethod.
	
	* configure.ac (AC_CONFIG_FILES): Added src/native/vm/gnu/Makefile.
	
	* src/native/native.c (native_class_getname): Removed.
	* src/native/native.h: Likewise.
	
	* src/native/vm/Makefile.am
	
	* src/native/vm/java_lang_Class.c: New file, contains the
	implementation for java.lang.Class functions.
	* src/native/vm/java_lang_Class.h: Likewise.
	
	* src/native/vm/java_security_VMAccessController.c,
	src/native/vm/VMjdwp.c,
	src/native/vm/java_lang_VMClass.c,
	src/native/vm/gnu_java_lang_management_VMRuntimeMXBeanImpl.c,
	src/native/vm/java_lang_VMThread.c,
	src/native/vm/VMjdwp.h,
	src/native/vm/gnu_classpath_jdwp_VMVirtualMachine.c,
	src/native/vm/gnu_classpath_jdwp_VMMethod.c,
	src/native/vm/java_lang_VMRuntime.c,
	src/native/vm/java_lang_reflect_Field.c,
	src/native/vm/gnu_java_lang_management_VMClassLoadingMXBeanImpl.c,
	src/native/vm/java_lang_VMThrowable.c,
	src/native/vm/gnu_java_lang_management_VMThreadMXBeanImpl.c,
	src/native/vm/gnu_java_lang_management_VMMemoryMXBeanImpl.c,
	src/native/vm/java_lang_VMClassLoader.c,
	src/native/vm/java_lang_management_VMManagementFactory.c,
	src/native/vm/java_lang_VMString.c,
	src/native/vm/java_lang_VMObject.c,
	src/native/vm/gnu_classpath_VMSystemProperties.c,
	src/native/vm/sun_misc_Unsafe.c,
	src/native/vm/java_lang_reflect_Method.c,
	src/native/vm/gnu_classpath_VMStackWalker.c,
	src/native/vm/java_lang_VMSystem.c,
	src/native/vm/java_lang_reflect_VMProxy.c,
	src/native/vm/java_lang_reflect_Constructor.c,
	src/native/vm/gnu_classpath_jdwp_VMFrame.c: Moved to
	src/native/vm/gnu.
	
	* src/native/vm/gnu/gnu_java_lang_management_VMThreadMXBeanImpl.c,
	src/native/vm/gnu/gnu_java_lang_management_VMMemoryMXBeanImpl.c,
	src/native/vm/gnu/java_security_VMAccessController.c,
	src/native/vm/gnu/java_lang_VMClassLoader.c,
	src/native/vm/gnu/java_lang_management_VMManagementFactory.c,
	src/native/vm/gnu/VMjdwp.c,
	src/native/vm/gnu/gnu_java_lang_management_VMRuntimeMXBeanImpl.c,
	src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/gnu/java_lang_VMString.c,
	src/native/vm/gnu/java_lang_VMObject.c,
	src/native/vm/gnu/VMjdwp.h,
	src/native/vm/gnu/java_lang_VMThread.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMVirtualMachine.c,
	src/native/vm/gnu/gnu_classpath_VMSystemProperties.c,
	src/native/vm/gnu/sun_misc_Unsafe.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMMethod.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/java_lang_VMRuntime.c,
	src/native/vm/gnu/Makefile.am,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/gnu_classpath_VMStackWalker.c,
	src/native/vm/gnu/java_lang_VMSystem.c,
	src/native/vm/gnu/gnu_java_lang_management_VMClassLoadingMXBeanImpl.c,
	src/native/vm/gnu/java_lang_reflect_VMProxy.c,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMFrame.c,
	src/native/vm/gnu/java_lang_VMThrowable.c: Moved from src/native/vm.

2006-12-18 16:27  twisti

	* src/vm/exceptions.c (exceptions_throw_internalerror): New function.
	* src/vm/exceptions.h (exceptions_throw_internalerror): Added.

2006-12-16 22:53  edwin

	* src/vm/jit/jit.c (jit_compile_intern): Perform inlining if
	JITDATA_FLAG_INLINE is set.
	
	* src/vm/jit/inline/inline.c: Put the result of inlining into
	the passed jitdata, instead of using a new one. Do not translate
	returnAddresses in javalocals. It makes no sense.
	
	* src/vm/jit/i386/codegen.h (M_BS): New macro.
	
	* src/vm/jit/replace.h (RPLPOINT_FLAG_COUNTDOWN): New constant.
	(Preparation for count-down replacement).
	
	* src/vm/jit/jit.h (JITDATA_FLAG_COUNTDOWN): New flag.
	(JITDATA_HAS_FLAG_COUNTDOWN): New macro.

2006-12-16 21:16  edwin

	* src/vm/jit/replace.c (replace_patch_class): New function.
	(replace_patch_class_hierarchy): New function.
	(replace_patch_future_calls): Fall back to iterating over all loaded
	classes if the instance of a call is not known.

2006-12-16 21:14  edwin

	* src/vm/classcache.c (classcache_foreach_loaded_class): New function.
	
	* src/vm/classcache.h (classcache_foreach_loaded_class): Likewise.
	(classcache_foreach_functionptr_t): New typedef.

2006-12-16 21:12  edwin

	* src/vm/jit/replace.c (replace_read_executionstate): Fix: Initialize
	the javalocaltype array for NDEBUG.

2006-12-16 21:11  edwin

	* src/vm/jit/inline/inline.c: Relocate returnAddresses in javalocals
	and in the s2 operand of ASTORE. Fix handling of in/out variables
	of TYPE_RET.
	
	* src/vm/jit/allocator/simplereg.c (simplereg_new_temp): Assert that
	constants (currently only TYPE_RET) are not allocated.
	(simplereg_new_free): Assert that constants (currently only TYPE_RET)
	are not freed.

2006-12-16 20:59  edwin

	* src/vm/jit/stack.c (stack_reanalyse_block): Zero line and flags of
	the appended NOP.

2006-12-16 20:57  edwin

	* src/vm/jit/replace.c: Prepared for native frames.
	
	* src/vm/jit/replace.h: Likewise.
	(REPLACEMENT_POINTS_RESET): Added.

2006-12-16 20:51  edwin

	* src/vm/jit/intrp/intrp.h: #include codegen-common.h

2006-12-16 20:50  edwin

	* src/vm/jit/inline/inline.c (create_body_block): Copy bitflags.
	(test_inlining): Copy code->optlevel. This is a quick fix for a more
	general problem: inline_inline should not swap the jitdata, but
	instead
	modify it in-place.
	(inline_inline_intern): Activated speculative inlining code.

2006-12-16 13:04  twisti

	* src/vm/annotation.c
	(annotation_load_attribute_runtimevisibleannotations): Extended
	comment, removed #ifdef ENABLE_JAVASE.

2006-12-15 23:54  twisti

	* autogen.sh: Check for automake-1.1x.

2006-12-15 23:53  twisti

	* autogen.sh: Check for automake-1.1x.

2006-12-13 23:04  twisti

	* src/vm/signal.c (errno.h): Added.
	(unistd.h): Likewise.
	(sys/mman.h): Likewise.
	[__DARWIN__] (sys/types.h): Likewise.
	(signal_init): mmap a page at 0x0.

2006-12-12 21:12  twisti

	* src/vm/jit/powerpc/darwin/md-asm.h (replace_build_execution_state):
	Defined.
	(replace_free_safestack): Likewise.
	
	* src/vm/jit/powerpc/asmpart.S (L_replace_build_execution_state$stub):
	Added.
	(L_replace_free_safestack$stub): Likewise.

2006-12-11 23:29  twisti

	* src/vm/jit/mips/mips/emit.c (emit_arithmetic_check): Added iptr and
	check INSTRUCTION_MUST_CHECK.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_arraystore_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	(emit_exception_check): Likewise.
	(emit_patcher_stubs): Likewise.
	
	* src/vm/jit/mips/mips/md.c (vm/exceptions.h): Added.
	
	* src/vm/jit/mips/mips/codegen.c (codegen): Pass iptr to
	exception-emit functions.
	
	* src/vm/jit/mips/mips/irix/md-os.c (vm/jit/codegen-common.h): Added.
	(md_signal_handler_sigsegv): Call codegen_get_pv_from_pc in
	error-case.

2006-12-11 20:31  twisti

	* tests/regression/fp.output: Updated to classpath-0.93.
	* tests/regression/fptest.output: Likewise.

2006-12-11 20:16  twisti

	* src/vm/jit/parse.c (MULTIANEWARRAY): Set check-flag.

2006-12-11 19:55  twisti

	* src/vm/jit/parse.c (CHECKCAST): Set check-flag.
	[!SUPPORT_HARDWARE_DIVIDE_BY_ZERO] (IDIV, IREM, LDIV, LREM): Set
	check-flag.

2006-12-11 19:43  twisti

	* src/vm/signal.c (signal_init): Use SUPPORT_HARDWARE_DIVIDE_BY_ZERO.
	* src/vm/signallocal.h: Likewise.
	
	* src/vm/jit/alpha/arch.h (SUPPORT_HARDWARE_DIVIDE_BY_ZERO): Defined.
	* src/vm/jit/i386/arch.h: Likewise.
	* src/vm/jit/mips/arch.h: Likewise.
	* src/vm/jit/powerpc/arch.h: Likewise.
	* src/vm/jit/powerpc64/arch.h: Likewise.
	* src/vm/jit/sparc64/arch.h: Likewise.
	* src/vm/jit/x86_64/arch.h: Likewise.

2006-12-11 04:25  ajordan

	* src/vm/jit/sparc64/asmpart.S: Fixed some exception handling.
	
	* src/vm/jit/sparc64/patcher.c: Fixed order of patch words.
	
	* src/vm/jit/sparc64/md.c: Disp mask in branch patch was wrong.
	
	* src/vm/jit/sparc64/codegen.c: Put in ICMD_CHECKNULL.

2006-12-11 00:28  twisti

	* src/native/vm/java_lang_reflect_Constructor.c (getSignature):
	Implemented.

2006-12-10 23:20  twisti

	* src/native/jni.h (_Jv_JavaVM): Renamed total_started_thread_count to
	java_lang_management_ThreadMXBean_ThreadCount, added
	java_lang_management_ThreadMXBean_PeakThreadCount,
	java_lang_management_ThreadMXBean_TotalStartedThreadCount.
	
	* src/vm/vm.c (vm_run): Set ThreadMXBean variables.
	* src/threads/native/threads.c (threads_startup_thread): Likewise.
	
	* src/native/vm/gnu_java_lang_management_VMThreadMXBeanImpl.c
	(getPeakThreadCount): Implemented.
	(getTotalStartedThreadCount): Use renamed variable.
	(resetPeakThreadCount): Implemented.

2006-12-10 22:17  twisti

	* src/vm/jit/powerpc/emit.c (emit_arrayindexoutofbounds_check): Added
	iptr and check INSTRUCTION_MUST_CHECK.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Pass iptr to exception-emit
	functions.

2006-12-10 22:07  twisti

	* src/vm/jit/alpha/emit.c (emit_arithmetic_check): Added iptr and
	check INSTRUCTION_MUST_CHECK.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/alpha/codegen.c (codegen): Pass iptr to exception-emit
	functions.

2006-12-10 21:50  twisti

	* src/vm/jit/x86_64/emit.c (emit_arithmetic_check): Added iptr and
	check INSTRUCTION_MUST_CHECK.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/x86_64/codegen.c (codegen): Pass iptr to exception-emit
	functions.

2006-12-10 21:35  twisti

	* src/vm/jit/emit-common.c (emit_array_checks): Pass iptr to emit
	functions.
	
	* src/vm/jit/emit-common.h (emit_arithmetic_check): Added iptr.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_arraystore_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	(emit_exception_check): Likewise.
	
	* src/vm/jit/i386/emit.c (emit_arithmetic_check): Added iptr and check
	INSTRUCTION_MUST_CHECK.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Pass iptr to exception-emit
	functions.

2006-12-10 21:27  twisti

	* src/vm/jit/parse.c (ICMD_CHECKNULL): Use OP_CHECK_EXCEPTION.
	* src/vm/jit/parse.h (OP_CHECK_EXCEPTION): New macro.

2006-12-10 17:19  ajordan

	* src/vm/jit/sparc64/codegen.h: Fixed float register mapping and
	compare macros.
	* src/vm/jit/sparc64/emit.c: Likewise.
	
	* src/vm/jit/sparc64/md.c: Fixed branch backpatching, was off by one.
	* src/vm/jit/sparc64/codegen.c: replaced codegen_addreference() with
	codegen_add_branch_ref().
	
	* src/vm/jit/sparc64/patcher.c: Tested and activated invokevirtual
	patcher.

2006-12-09 23:20  ajordan

	* src/vm/jit/sparc64/codegen.h: Reworked float handling, single
	precision floats are now stored in the upper half of the double pair.
	
	* src/vm/jit/sparc64/codegen.c: Fixes for argument handling and
	get/put-static.
	* src/vm/jit/sparc64/emit.c: Likewise.
	* src/vm/jit/sparc64/md-abi.c: Likewise.
	
	* src/vm/jit/sparc64/asmpart.S(asm_call_jit_compiler): Fixed float
	arg saving.

2006-12-09 00:25  twisti

	* src/vm/jit/powerpc/emit.c (emit_arrayindexoutofbounds_check):
	Removed hardware-exception code.

2006-12-08 00:39  edwin

	* src/vm/jit/jit.h (JITDATA_FLAG_INLINE): Added.

2006-12-08 00:20  edwin

	* src/vm/jit/powerpc/codegen.c: Ported replacement.

2006-12-08 00:17  edwin

	* src/vm/jit/i386/asmpart.S: Adapted to new execution state layout.

2006-12-08 00:16  edwin

	* src/vm/jit/replace.h: Use a type union replace_val_t for all source
	state values. Give the registers in the execution state meaningful
	types. Properly convert float/double values.
	* src/vm/jit/replace.c: Likewise.
	
	* src/vm/jit/powerpc/asmpart.S: Adapted to new execution state layout.
	* src/vm/jit/i386/asmpart.S: Likewise.

2006-12-08 00:07  edwin

	* src/vm/jit/replace.c: Small cleanups.

2006-12-08 00:06  edwin

	* src/vm/jit/replace.c: Implemented support for linkage area.

2006-12-08 00:04  edwin

	* src/vm/jit/replace.c: Implement alpha-style stack frames (ra is at
	top of frame, in leaf methods the ra register is used).

2006-12-07 23:59  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Fix: Put the
	REPLACEMENT_POINT_INVOKE_RETURN macro in the right place.

2006-12-07 23:58  edwin

	* src/vm/jit/alpha/codegen.c: Ported replacement.

2006-12-07 23:57  edwin

	* src/vm/jit/x86_64/codegen.c: Ported replacement.

2006-12-07 23:54  edwin

	* src/vm/jit/replace.h: Added macros for codegens.
	
	* src/vm/jit/replace.c: Architecture-independent patching of future
	calls. Use a safe stack area for the final phase of replacement.
	
	* src/vm/jit/asmpart.h (asm_replacement_in): Got an additional
	argument for the safe stack area.
	
	* src/vm/jit/powerpc/asmpart.S: Ported.
	* src/vm/jit/alpha/asmpart.S: Likewise.
	* src/vm/jit/i386/asmpart.S: Likewise.
	* src/vm/jit/x86_64/asmpart.S: Likewise.

2006-12-07 23:44  edwin

	* src/vm/jit/replace.h (replace_safestack_t): Prepared declarations
	for the safe stack area (not used, yet).
	(sourceframe_t): Added from/to members.
	
	* src/vm/jit/replace.c: Major refactoring.

2006-12-07 23:32  edwin

	* src/vm/jit/replace.h (rplpoint): Removed members outcode, code,
	mcode. Fixed bitwidth of regalloccount.
	(replace_activate_replacement_points): Activate rplpoints per
	codeinfo.
	(replace_deactivate_replacement_points): Deactivate --''--.
	* src/vm/jit/replace.c: Likewise.
	* src/vm/jit/jit.c: Likewise.

2006-12-07 23:17  edwin

	* src/vm/jit/replace.h (rplpoint): Removed `target` member.
	* src/vm/jit/replace.c: Likewise.
	* src/vm/jit/jit.c: Likewise.

2006-12-07 23:13  edwin

	* src/vm/jit/codegen-common.c (codegen_finish): Relocate
	code->replacementstubs, do not use rplpoint.outcode.

2006-12-07 23:02  edwin

	* src/vm/jit/powerpc/md.c (md_patch_replacement_point): Changed to use
	an external array for saving machine code.
	* src/vm/jit/sparc64/md.c: Likewise.
	* src/vm/jit/alpha/md.c: Likewise.
	* src/vm/jit/mips/md.c: Likewise.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/i386/md.c: Likewise.
	* src/vm/jit/x86_64/md.c: Likewise.
	
	* src/vm/jit/replace.h (md_patch_replacement_point): Added arguments.
	* src/vm/jit/replace.c: Likewise.

2006-12-07 22:48  edwin

	* src/vm/jit/powerpc/md.c (md_patch_replacement_point): Deactivate
	debug print.
	* src/vm/jit/alpha/md.c: Likewise.

2006-12-07 22:45  edwin

	* src/vm/jit/powerpc/md.c (md_get_method_patch_address): Return NULL
	if no mptr was specified and the call is dynamically dispatched.
	* src/vm/jit/sparc64/md.c: Likewise.
	* src/vm/jit/alpha/md.c: Likewise.
	* src/vm/jit/mips/md.c: Likewise.
	* src/vm/jit/i386/md.c: Likewise.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/x86_64/md.c: Likewise.

2006-12-07 22:30  edwin

	* src/vm/jit/mips/emit.c: #include <assert.h>

2006-12-07 22:29  edwin

	* src/vm/jit/alpha/emit.c: #include <assert.h>
	* src/vm/jit/x86_64/emit.c (emit_replacement_stubs): Ported.

2006-12-07 22:25  edwin

	* src/vm/jit/powerpc/emit.c (emit_replacement_stubs): Prepared for
	removal of rplpoint.mcode.
	* src/vm/jit/alpha/emit.c: Likewise.
	* src/vm/jit/mips/emit.c: Likewise.
	* src/vm/jit/i386/emit.c: Likewise.
	* src/vm/jit/x86_64/emit.c: Likewise.

2006-12-07 22:19  edwin

	* src/vm/jit/powerpc/emit.c (emit_replacement_stubs): Do not
	set rplp->outcode.
	* src/vm/jit/alpha/emit.c: Likewise.
	* src/vm/jit/mips/emit.c: Likewise.
	* src/vm/jit/i386/emit.c: Likewise.
	* src/vm/jit/x86_64/emit.c: Likewise.

2006-12-07 20:39  edwin

	* src/vm/jit/code.c (code_find_codeinfo_for_pc): New function.
	* src/vm/jit/code.h (codeinfo): Added codeinfo flags,
	replacementstubs,
	and savedmcode.
	
	* src/vm/jit/jit.c (jit_invalidate_code): Use codeinfo flags.
	(jit_get_current_code): Likewise.

2006-12-07 20:14  edwin

	* src/vm/jit/powerpc/arch.h (REPLACEMENT_PATCH_SIZE): Added.
	(REPLACEMENT_STUB_SIZE): Added.
	* src/vm/jit/sparc64/arch.h: Likewise.
	* src/vm/jit/alpha/arch.h: Likewise.
	* src/vm/jit/mips/arch.h: Likewise.
	* src/vm/jit/parisc/arch.h: Likewise.
	* src/vm/jit/powerpc64/arch.h: Likewise.
	* src/vm/jit/i386/arch.h: Likewise.
	* src/vm/jit/x86_64/arch.h: Likewise.

2006-12-07 19:57  ajordan

	* scr/vm/jit/sparc64/emit.c: Fixed M_XOR and iconst, lconst.
	* src/vm/jit/sparc64/codegen.h: Likewise
	
	* src/vm/jit/sparc64/codegen.c: Allocating (ABI defined) param array
	on stack before builtin call.

2006-12-07 10:59  twisti

	* src/vm/jit/x86_64/emit.c (vm/options.h): Added.
	(emit_arithmetic_check): New function.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/x86_64/codegen.c (codegen): Use emit_*_check functions
	for exception checks.
	(IDIV, IREM, LDIV, LREM): Use emit_{load,store} functions.
	
	* src/vm/jit/x86_64/codegen.h (gen_nullptr_check): Removed.
	(gen_bound_check): Likewise.
	(gen_resolvebranch): Likewise.

2006-12-06 22:15  twisti

	* src/native/vm/java_lang_VMClass.c (forName): Throw NPE if null is
	passed.

2006-12-06 10:49  twisti

	* src/vm/jit/i386/emit.c (vm/options.h): Added.
	(emit_arithmetic_check): New function.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Use emit_*_check functions for
	exception checks.
	
	* src/vm/jit/i386/codegen.h (gen_nullptr_check): Removed.
	(gen_bound_check): Likewise.

2006-12-06 10:37  twisti

	* src/vm/jit/emit-common.c [__ALPHA__ || __POWERPC__]
	(emit_array_checks): Removed #ifdef's.

2006-12-06 09:53  twisti

	* src/vm/jit/i386/emit.c (emit_verbosecall_enter): Check for
	JITDATA_HAS_FLAG_VERBOSECALL.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Removed
	JITDATA_HAS_FLAG_VERBOSECALL check.
	(createnativestub): Likewise.

2006-12-06 09:47  twisti

	* src/vm/builtin.c [ENABLE_JIT] (builtintable_replace_function):
	#ifdef'ed.

2006-12-05 23:58  ajordan

	* src/vm/jit/sparc64/emit.c: stack bias used in emit_load and
	emit_store.
	
	* src/vm/jit/sparc64/md.c (md_stacktrace_get_returnaddress): let it
	return the original ra (address of the call instruction).
	
	* src/vm/jit/sparc64/codegen.h: fixed M_RESTORE instruction.
	
	* src/vm/jit/sparc64/codegen.c: fixed datasp argument for
	codegen_finish_native_call.

2006-12-05 21:10  twisti

	* src/vm/exceptions.h (EXCEPTION_LOAD_DISP_NULLPOINTER)
	(EXCEPTION_LOAD_DISP_ARITHMETIC)
	(EXCEPTION_LOAD_DISP_ARRAYINDEXOUTOFBOUNDS)
	(EXCEPTION_LOAD_DISP_CLASSCAST, EXCEPTION_LOAD_DISP_PATCHER): Defined.
	
	* src/vm/signal.c (signal_init): Removed checknull-check.
	
	* src/vm/jit/powerpc/emit.c (vm/exceptions.h): Added.
	(emit_arrayindexoutofbounds_check): Added hardware-exception version.
	
	* src/vm/jit/powerpc/darwin/md-os.c (md_signal_handler_sigsegv):
	Started to handle other hardware-exceptions.

2006-12-04 23:48  twisti

	* src/vm/jit/x86_64/codegen.c (createcompilerstub): Don't generate a
	codeinfo.

2006-12-04 23:39  twisti

	* src/vm/jit/powerpc64/codegen.c (createcompilerstub): Don't generate
	a codeinfo.

2006-12-04 23:36  twisti

	* src/vm/jit/powerpc64/linux/md-os.c (vm/jit/profile/profile.h):
	Changed to vm/jit/optimizing/profile.h.

2006-12-04 23:30  twisti

	* src/vm/jit/alpha/codegen.c (createcompilerstub): Don't generate a
	codeinfo.

2006-12-04 23:16  twisti

	* src/vm/jit/i386/codegen.c (createcompilerstub): Don't generate a
	codeinfo.

2006-12-04 22:51  twisti

	* src/vm/jit/powerpc/codegen.c (createcompilerstub): Don't generate a
	codeinfo.

2006-12-04 22:21  twisti

	* src/vm/jit/code.c (code_init): New function.
	* src/vm/jit/code.h (code_init): Added.
	* src/vm/jit/jit.c (jit_init): Added code_init call.

2006-12-04 22:18  twisti

	* src/vm/jit/code.h (vm/global.h): Added.

2006-12-04 14:46  ajordan

	* src/vm/jit/sparc64/codegen.h: updated code to new dseg functions.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/sparc64/emit.c: Likewise.

2006-12-04 11:20  twisti

	* src/vm/vm.c (vm_create): Moved properties_postinit after jar-file
	handling. This fixes an eclipse bug found by mjw and neugens.

2006-12-04 02:05  michi

	* src/mm/cacao-gc/compact.c: Now uses regioninfo; Added
	compact_thread_classes
	Fixed compact_move; Disabled some logging.
	* src/mm/cacao-gc/compact.h: Now uses regioninfo.

2006-12-03 22:45  twisti

	* src/vm/vm.c (version): Print classpath variable.

2006-12-03 17:55  michi

	* src/mm/cacao-gc/compact.c: Added.
	* src/mm/cacao-gc/compact.h: Added.

2006-12-02 15:01  tbfg

	* configure.ac: Added m68k host_cpu support. Added uclinux host_os
	support.

2006-12-02 14:54  tbfg

	* src/native/tools/gennativetable.c (main): Renamed nogc_init
	to gc_init in DISABLE_GC path.
	
	* src/native/Makefile.am: Introduced GENNATIVETABLE to
	make crosscompilation a friendlier experience. Rewrote
	rule for nativetable.inc accordingly.
	
	* src/threads/native/threads.c (threads_cast_stopworld) [!DISABLE_GC]:
	Depends on GC_signum1 and GC_signum2 which are undefined without
	garbage collector.
	(threads_cast_startworld): Likewise.
	(threads_sigsuspend_handler): Likewise.

2006-12-02 12:22  twisti

	* src/vm/builtin.c (builtin_trace_args): Added missing + for
	logtextlen, thanks to --enable-memcheck.

2006-12-01 16:51  twisti

	* src/vm/jit/x86_64/codegen.h (vm/jit/x86_64/emit.h): Added.

2006-12-01 11:38  tbfg

	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method):
	Fixed a bug in argument handling when using lwz instead
	of lwa zeroed out sign extension bits which lead to wrong
	int->string conversion in exception handling path.

2006-11-29 22:33  edwin

	* tests/regression/jasmin/test_verify_fail_merge_init_nullpointer.j:
	New test.
	
	* tests/regression/jasmin/test_verify_fail_init_nullpointer.j: Pass
	null pointer without merging.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-11-29 20:44  twisti

	* src/vm/jit/dseg.h (jumpref, dataref, exceptionref, patchref)
	(linenumberref): Moved to codegen-common.h.
	* src/vm/jit/codegen-common.h: Likewise.

2006-11-29 20:34  twisti

	* src/vm/jit/emit-common.c (emit_bc): Commented emit_branch call.

2006-11-29 20:15  twisti

	* src/vm/jit/x86_64/emit.h (config.h): Added.
	(vm/jit/codegen-common.h): Likewise.
	(vm/jit/jit.h): Likewise.

2006-11-29 17:08  twisti

	* src/vm/class.h [ENABLE_JAVASE] (vm/annotation.h): Added.
	[ENABLE_JAVASE] (classinfo): Added runtimevisibleannotationscount,
	runtimevisibleannotations.

2006-11-29 17:04  twisti

	* src/vm/annotation.c: New file.
	* src/vm/annotation.h: Likewise.
	* src/vm/Makefile.am [ENABLE_JAVASE] (ANNOTATION_OBJ): Added.

2006-11-29 17:00  twisti

	* src/vm/resolve.h (vm/field.h): Added.

2006-11-28 22:36  twisti

	* src/vm/jit/emit-common.c (emit_bc): Temporary compile fix

2006-11-28 22:32  twisti

	* src/vm/jit/i386/codegen.h (vm/jit/i386/emit.h): Added.

2006-11-28 22:28  twisti

	* src/vm/statistics.c (count_branches_resolved)
	(count_branches_unresolved): New variable.
	(print_stats): Print new variables.
	
	* src/vm/statistics.h (count_branches_resolved)
	(count_branches_unresolved): Added.

2006-11-28 22:25  twisti

	* src/vm/jit/emit-common.c (codegen.h): Added.
	(vm/options.h): Likewise.
	[ENABLE_STATISTICS] (vm/statistics.h): Likewise.
	(emit_bc): New function.
	(emit_br): Likewise.
	
	* src/vm/jit/emit-common.h (emit_branch): Added.

2006-11-28 22:19  twisti

	* src/vm/jit/alpha/codegen.h (BRANCH_NOPS): Defined.
	* src/vm/jit/i386/codegen.h (BRANCH_NOPS, PATCHER_NOPS): Likewise.
	* src/vm/jit/mips/codegen.h (BRANCH_NOPS): Likewise.
	* src/vm/jit/powerpc/codegen.h (BRANCH_NOPS): Likewise.
	* src/vm/jit/powerpc64/codegen.h (BRANCH_NOPS, PATCHER_CALL_SIZE)
	(PATCHER_NOPS): Likewise.
	* src/vm/jit/x86_64/codegen.h (BRANCH_NOPS): Likewise.

2006-11-28 22:04  twisti

	* src/vm/jit/dseg.c (dseg_get_linenumber_from_pc_intern):
	Short-circuit the common case.

2006-11-28 21:50  twisti

	* src/native/tools/Makefile.am (GC_LIB): Removed.

2006-11-28 19:58  twisti

	* src/vm/jit/emit-common.c (emit_beq, emit_bne, emit_blt, emit_bge)
	(emit_bgt, emit_ble, emit_bnan): New functions.
	* src/vm/jit/emit-common.h (emit_beq, emit_bne, emit_blt, emit_bge)
	(emit_bgt, emit_ble, emit_bnan): Added.
	
	* src/vm/jit/codegen-common.h (BRANCH_UNCONDITIONAL, BRANCH_EQ)
	(BRANCH_NE, BRANCH_LT, BRANCH_GE, BRANCH_GT, BRANCH_LE, BRANCH_NAN):
	Added.

2006-11-28 19:24  edwin

	*
	tests/regression/jasmin/test_verify_fail_merge_different_new_objects.j:
	New test.
	
	* tests/regression/jasmin/test_verify_fail_init_nullpointer.j:
	Likewise.
	
	* tests/regression/jasmin/Makefile.am: Added new tests.
	* src/vm/jit/verify/typeinfo.c (typeinfo_merge_error): Moved debug
	print into #ifdef TYPEINFO_VERBOSE.

2006-11-28 19:14  twisti

	* src/vm/jit/alpha/codegen.h (PATCHER_CALL_SIZE): Defined.

2006-11-28 15:11  twisti

	* src/native/vm/java_lang_VMThrowable.c
	(native/include/java_lang_VMClass.h): Removed.
	(getStackTrace): Use native_class_getname.

2006-11-28 01:07  ajordan

	* src/vm/jit/sparc64/asmpart.S: fixed asm_patcher_wrapper
	* src/vm/jit/sparc64/patcher.c: updated some patchers and the wrapper
	* src/vm/jit/sparc64/emit.c: likewise
	
	* src/vm/jit/sparc64/codegen.h: fixed M_BRACC
	
	* src/vm/jit/sparc64/codegen.c: added reg window workaround for arg
	register copying.
	some patch ref updates
	
	* src/vm/jit/sparc64/md.c: updated md_codegen_patch_branch()

2006-11-27 20:05  twisti

	* src/vm/jit/powerpc/codegen.h (PATCHER_CALL_SIZE): Defined.

2006-11-27 16:53  edwin

	* src/vm/jit/replace.c: Lazy patching of virtual methods. Cleanup.
	* src/vm/jit/replace.h: Likewise.

2006-11-27 15:37  edwin

	* src/vm/jit/replace.h (sourceframe_t): Added normalized type
	of replacement point.
	
	* src/vm/jit/replace.c (replace_normalize_type_map): Added
	normalization table for replacement point types.
	(replace_read_executionstate): Set normalized type of rplpoint.
	(replace_find_replacement_point): Match normalized type of rplpoint.
	(replace_source_frame_println): Print it.

2006-11-27 15:29  edwin

	* src/vm/jit/i386/codegen.c (codegen): set marker in line number table
	_after_ inlining prolog (This fixes the stacktrace for the CHECKNULL
	in
	the prolog.)
	
	* src/vm/jit/dseg.c (dseg_addlinenumber_inline_start): Document that
	it is now called with the INLINE_BODY instruction.

2006-11-27 15:24  edwin

	* src/vm/jit/i386/codegen.cn (codegen): Use the new functions for
	setting replacement point addresses.

2006-11-27 15:23  edwin

	* src/vm/jit/codegen-common.c (codegen_set_replacement_point_notrap):
	New function.
	(codegen_set_replacement_point): Likewise.
	
	* src/vm/jit/codegen-common.h (codegendata): Added field
	`replacementpoint`.
	(codegen_set_replacement_point_notrap): Added prototype.
	(codegen_set_replacement_point): Likewise.
	
	* src/vm/jit/replace.h (RPLPOINT_CHECK): New macro.
	(RPLPOINT_CHECK_BB): Likewise.

2006-11-27 15:19  edwin

	* src/vm/jit/replace.c
	(replace_create_inline_start_replacement_point):
	New function.
	(replace_create_replacement_points): Cleaned up.

2006-11-27 15:15  edwin

	* src/vm/jit/stack.c (stack_javalocals_store): New function.
	* src/vm/jit/stack.h (stack_javalocals_store): Likewise.
	
	* src/vm/jit/inline/inline.c (inline_clone_instruction): Use
	stack_javalocals_store.
	
	* src/vm/jit/replace.c (replace_create_replacement_points): Use
	stack_javalocals_store. Other cleanups.

2006-11-27 15:11  edwin

	* src/vm/jit/replace.c (replace_create_replacement_points): Create
	non-trappable replacement point for INLINE_BODY.
	
	* src/vm/jit/i386/codegen.c (codegen): Handle replacement point
	for INLINE_BODY.

2006-11-27 15:06  edwin

	* src/vm/jit/replace.h (RPLPOINT_TYPE_BODY): Added.
	* src/vm/jit/replace.c: Likewise.

2006-11-27 15:03  edwin

	* src/vm/jit/inline/inline.c (emit_inlining_prolog): Do not emit
	CHECKNULL in prolog for <init> methods.

2006-11-27 15:02  edwin

	* src/vm/jit/inline/inline.c (emit_inlining_prolog): Emit INLINE_BODY
	instructions at end of prolog.

2006-11-27 14:58  edwin

	* src/vm/jit/icmdtable.inc (INLINE_GOTO): Removed.
	(INLINE_BODY): Added. This instruction will mark the start of the
	inlined method body after the prolog.
	
	* src/vm/jit/jit.h: Likewise.
	
	* src/vm/jit/show.c (show_icmd): Likewise.
	
	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_temporaries):
	Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Regenerated.

2006-11-27 14:48  edwin

	* src/vm/jit/i386/emit.c (emit_memabs): Removed.
	(emit_alu_imm_memabs): Use emit_mem.

2006-11-27 14:39  edwin

	* src/vm/jit/stack.c (stack_reanalyse_block): Removed bogus cases
	for INLINE_ instructions. They cannot occur here.
	(stack_analyse): Likewise.

2006-11-27 14:37  michi

	* src/mm/gc-common.h: Added prototype for heap_init_objectheader.
	* src/vm/builtin.c (builtin_clone): Object header gets initiated
	after cloning.

2006-11-27 14:35  edwin

	* src/vm/jit/jit.c (jit_invalidate_code): Do not trap non-trappable
	replacement points.
	(jit_request_optimization): New function.
	(jit_get_current_code): New function.
	
	* src/vm/jit/jit.h (jit_request_optimization): Added prototype.
	(jit_get_current_code): Likewise.
	
	* src/vm/jit/replace.h (RPLPOINT_FLAG_NOTRAP): New flag.
	
	* src/vm/jit/replace.c (replace_replacement_point_println): Prepared
	for new flag.

2006-11-27 14:27  edwin

	* src/vm/jit/jit.c (jit_invalidate_code): Do not activate RETURN
	rplpoints when invalidating code (they cannot be mapped to inlined
	versions of the code).

2006-11-27 14:26  edwin

	* src/vm/jit/replace.c (replace_create_replacement_points): Some fixes
	for inlining.

2006-11-27 14:24  edwin

	* src/vm/jit/replace.c (replace_find_replacement_point): Match parent
	of replacement point.
	(replace_me): Keep parent of rplpoint around.

2006-11-27 14:20  edwin

	* src/vm/jit/i386/emit.c (emit_memabs): New function.
	(emit_alu_imm_memabs): New function.
	
	* src/vm/jit/i386/emit.h (emit_alu_imm_memabs): Added prototype.
	
	* src/vm/jit/i386/codegen.h (M_ISUB_IMM_MEMABS): New macro.

2006-11-25 16:32  michi

	* src/mm/cacao-gc/gc.h: Added.
	* src/mm/cacao-gc/gc.c: Debugging with gc_call. Added some
	development breaks.
	Added gc_get_heap_size, gc_get_free_bytes, gc_get_total_bytes and
	gc_get_max_heap_size.

2006-11-22 21:19  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Use new dseg_add_* functions,
	replaced codegen_addreference with codegen_add_branch_ref.
	(createnativestub): Likewise.
	* src/vm/jit/x86_64/emit.c (emit_patcher_stubs): Likewise.

2006-11-22 20:24  twisti

	* src/vm/jit/stacktrace.c (linenumbertable_entry): Removed.
	(stacktrace_add_method_intern): Removed.
	(stacktrace_add_method): Call dseg_get_linenumber_from_pc.
	
	* src/vm/jit/dseg.c (vm/jit/methodheader.h): Added.
	(dseg_get_linenumber_from_pc_intern): New function.
	(dseg_get_linenumber_from_pc): Likewise.
	
	* src/vm/jit/dseg.h (linenumbertable_entry): Added.
	(dseg_get_linenumber_from_pc): Likewise.
	
	* src/vm/jit/show.c (show_method): Renamed u1ptr to pc.
	(show_basicblock): Use dseg_get_linenumber_from_pc to diplay line
	number in disassembly.

2006-11-22 19:00  twisti

	* src/mm/gc-common.h [DISABLE_GC] (nogc_init, nogc_realloc): Removed.

2006-11-22 18:22  edwin

	* src/vm/jit/x86_64/codegen.c (codegen): Do not generate code for
	ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:20  edwin

	* src/vm/jit/sparc64/codegen.c (codegen): Do not generate code for
	ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:18  edwin

	* src/vm/jit/powerpc64/codegen.c (codegen): Do not generate code for
	ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:16  edwin

	* src/vm/jit/mips/codegen.c (codegen): Do not generate code for ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:12  edwin

	* src/vm/jit/i386/codegen.c (codegen): Do not generate code for ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:09  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Do not generate code for
	ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 18:03  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Do not generate code for
	ASTORE
	storing a returnAddress, as 1) the store is dead, and 2) the dest.
	variable has no valid allocation.

2006-11-22 11:05  twisti

	* configure.ac: Added *kfreebsd*-gnu.
	* src/vm/suck.c (scandir_filter) [_DIRENT_HAVE_D_NAMLEN]: Bugfix.

2006-11-22 10:50  twisti

	* src/vm/jit/i386/codegen.c (codegen): Use new dseg_add_* functions.
	(createnativestub): Likewise.
	* src/vm/jit/i386/emit.c (emit_patcher_stubs): Likewise.

2006-11-21 23:21  twisti

	* native.c (native_class_getname): New function.
	* native.h (native_class_getname): Added.
	* vm/java_lang_VMClass.c (getName): Use native_class_getname.

2006-11-21 21:02  twisti

	* src/vm/builtin.c [DISABLE_GC] (builtin_idiv): Added.
	(builtin_f2i): Likewise.
	(builtin_d2i): Likewise.
	
	* src/vm/vm.c (vm_create): Removed nogc_init call.
	* src/cacaoh/cacaoh.c (main): Likewise.
	
	* src/mm/nogc.c (nogc_realloc): Removed.
	(nogc_init): Renamed to gc_init.
	(gc_init): Removed.
	(gc_get_total_bytes): Added.
	
	* src/mm/memory.h [DISABLE_GC] (NEW, FREE, MNEW, MFREE, MREALLOC):
	Removed.

2006-11-21 16:56  michi

	* src/vm/loader.c (load_class_from_classbuffer) [ENABLE_GC_CACAO]:
	Fieldinfos
	are no longer placed onto the heap.
	
	* src/vm/class.c (class_free) [ENABLE_GC_CACAO]: Fieldinfos are freed.

2006-11-20 18:57  tbfg

	* src/vm/jit/powerpc64/codegen.c (codegen): Replace dseg_add*
	by dseg_add_* functions.
	
	* src/vm/jit/powerpc64/emit.c: Likewise.

2006-11-20 16:18  twisti

	* src/vm/jit/dseg.h (dseg_adds4, dseg_adds8, dseg_addfloat)
	(dseg_adddouble, dseg_addaddress, dseg_addtarget): Removed.
	
	* src/vm/jit/alpha/codegen.c (codegen): Removed remaining old-dseg_add
	calls.
	* src/vm/jit/alpha/emit.c (emit_iconst): Replaced dseg_adds4 with
	dseg_add_s4.
	(emit_lconst): Replaced dseg_adds8 with dseg_add_s8.

2006-11-20 14:18  michi

	* src/vm/global.h: Added hdrflags to java_objectheader for exact
	Cacao-GC.
	* src/threads/native/lock.c: Now uses hdrflags to store the FLC bit.

2006-11-19 18:25  michi

	* src/mm/cacao-gc/Makefile.am: Added mark.c
	* src/mm/cacao-gc/mark.c: Added

2006-11-19 15:40  edwin

	* src/vm/jit/replace.c: Only recompile if necessary. Count
	re-compilations.

2006-11-19 15:39  edwin

	* src/vm/jit/replace.c: Added statistics code.

2006-11-19 15:36  edwin

	* src/vm/jit/replace.c (replace_me): Only turn off replacement
	points for self-replacement. Warn in this case.

2006-11-19 15:33  edwin

	* src/vm/jit/replace.c (replace_write_executionstate): Take
	synchronization slots from next frame for inline points.

2006-11-19 15:28  edwin

	* src/vm/jit/replace.c: Handle and match returnAddress variables on
	the java stack.

2006-11-19 15:22  edwin

	* src/vm/jit/stack.c (stack_analyse): Keep TYPE_RET for variables
	of returnAddress type. Do not create interfaces for this type.
	Mark block variables of TYPE_RET as PREALLOC to avoid subsequent
	allocation.
	
	* src/vm/jit/icmdtable.inc (ASTORE): Added TYPE_RET (R--) variant.
	(JSR): Changed destination type to TYPE_RET (R).
	
	* src/vm/jit/verify/icmds.c (ICMD_RET): Check local for type
	TYPE_RET.
	
	* src/vm/jit/verify/typeinfo.h (TYPE_IS_RETURNADDRESS): Check type
	for TYPE_RET.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: Regenerated.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Regenerated.

2006-11-19 15:10  edwin

	* src/vm/jit/jit.c (jit_invalidate_code): Activate replacement points
	in reverse order. This avoid creating invalid code when rplpoints
	within a block overlap each other. It is not a complete solution for
	overlapping replacement points, however.

2006-11-19 15:08  edwin

	* src/vm/jit/inline/inline.c (translate_javalocals): Adapted to
	returnAddress variables in javalocals.
	(inline_clone_instruction): Likewise.

2006-11-19 15:04  edwin

	* src/vm/jit/stack.c (stack_mark_reached): Fix: Do not compare basic
	block addresses. Compare numbers instead.
	(stack_mark_reached_from_outvars): Likewise.

2006-11-19 15:03  edwin

	* src/vm/jit/jit.h (INS_FLAG_CLASS): Comment that this flag is also
	used for PUTFIELDCONST and PUTSTATICCONST.
	
	* src/vm/jit/verify/icmds.c (ICMD_PUTFIELDCONST, ICMD_PUTSTATICCONST):
	Honor the INS_FLAG_CLASS flag and set the right type.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: Regenerated.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Regenerated.

2006-11-19 14:56  edwin

	* src/vm/jit/stack.c (stack_analyse): Show state after last ICMD in
	block.
	(stack_verbose_show_block): Use show_javalocals_array.
	(stack_verbose_show_state): Likewise. Accept iptr == NULL.

2006-11-19 14:51  edwin

	* src/vm/jit/replace.c (replace_source_frame_println): Fixed printing
	of source stack.

2006-11-19 14:50  edwin

	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_temporaries):
	Do not clear vv.regoff for ICMD_JSR (we need vv.retaddr later).

2006-11-18 22:16  twisti

	* src/vm/properties.c (properties_add): Use unsynced functions of
	list.
	(properties_get): Likewise.

2006-11-17 15:47  twisti

	* src/vm/properties.c (properties_add): Replace entry if it already
	exists.

2006-11-16 22:14  twisti

	* src/vm/builtin.c (native/native.h)
	(native/include/java_lang_Cloneable.h)
	(native/include/java_lang_Object.h)
	(native/include/java_lang_VMObject.h): Removed.
	(builtin_clone_array): Renamed to builtin_clone, reimplemented.
	
	* src/vm/builtin.h (builtin_clone_array): Renamed to builtin_clone.
	(BUILTIN_clone): Defined.
	
	* src/vm/loader.c (load_newly_created_array): Use BUILTIN_clone.
	
	* src/native/vm/java_lang_VMObject.c (clone): Removed implementation
	and call builtin_clone.

2006-11-16 19:45  twisti

	* src/vm/class.h (classinfo): Typedef added.
	* src/vm/descriptor.h (typedesc): Likewise.
	(methoddesc): Likewise.
	* src/vm/field.h (fieldinfo): Likewise.
	* src/vm/method.h (methodinfo): Likewise.
	
	* src/vm/references.h (config.h, vm/types.h, vm/class.h)
	(vm/descriptor.h, vm/field.h, vm/method.h): Likewise.
	(classinfo, methodinfo, fieldinfo, typedesc, methoddesc): Removed.
	(constant_classref, classref_or_classinfo, parseddesc): Moved.

2006-11-16 15:56  twisti

	* src/vm/vm.c (vm_createjvm): New function.
	* src/vm/vm.h (vm_createjvm): Added.
	
	* src/cacao/cacao.c (main): Resolve and call vm_createjvm instead of
	JNI_CreateJavaVM.
	
	* src/native/jni.c (jni_init_localref_table): Made non-static.
	(JNI_CreateJavaVM): Moved implementation into vm_createjvm.
	* src/native/jni.h (jni_init_localref_table): Added.

2006-11-16 00:02  edwin

	* src/vm/jit/stack.c (stack_analyse): Fix: Reset deadcode when
	re-analysing a block.

2006-11-15 23:45  edwin

	* src/vm/jit/verify/generate.pl: Prepared for LOAD instructions with
	multiple variants (will be needed for ASTORE).

2006-11-15 23:44  edwin

	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_temporaries):
	Ignore TYPE_RET interface variables. (Preparation.)
	
	* src/vm/jit/show.c (show_allocation): Prepared for TYPE_RET
	variables.
	(show_variable_intern): Likewise.
	
	* src/vm/jit/verify/typecheck.c (STORE_LOCAL): Made the macro safer.
	(STORE_LOCAL_2_WORD): Likewise.
	
	* src/vm/jit/verify/typeinfo.c (typeinfo_print_type): Prepared for
	TYPE_RET variables.
	
	* src/vm/jit/replace.c (replace_source_frame_println): Prepared for
	void stackslots.

2006-11-15 23:37  edwin

	* src/vm/jit/jit.c (jit_recompile): Set verbosecall flag.

2006-11-15 23:36  edwin

	* src/vm/jit/replace.c (replace_create_replacement_points): Fix: Only
	put a replacement point at a back branch target if the block does not
	contain any other replacement point.
	
	(replace_read_executionstate): Better debugging helpers.
	(replace_me): Likewise.
	
	* src/vm/jit/replace.h (sourceframe_t): Added a field for debugging.

2006-11-15 23:33  edwin

	* src/vm/jit/stack.c (stack_reanalyse_block): Encode returnAddresses
	in the javalocals array.
	(stack_analyse): Likewise.
	
	* src/vm/jit/replace.c (replace_create_replacement_point): Store
	returnAddresses in replacement points.
	(replace_create_replacement_points): Encode returnAddresses in
	javalocals.
	(replace_read_executionstate): Ignore returnAddresses.
	(replace_write_executionstate): Likewise.
	(replace_find_replacement_point): Match returnAddresses.

2006-11-15 23:30  edwin

	* src/vm/jit/show.h (show_javalocals_array): New function.
	
	* src/vm/jit/show.c (show_javalocals_array): New function.
	(show_icmd): Prepared for showing returnAddresses.
	
	* src/vm/jit/replace.c (replace_replacement_point_println): Prepared
	for showing constant returnAddresses.
	
	* src/vm/jit/replace.h (rplalloc): Made type unsigned, so it will be
	able to hold TYPE_RET (8).
	
	* src/vm/jit/jit.h (s2_operand_t): Added field `retaddrnr` that will
	be used by ASTORE with returnAddresses.

2006-11-15 23:24  edwin

	* src/vm/jit/inline/inline.c (inline_inline_intern): Removed some
	unused code.

2006-11-15 23:23  edwin

	* src/vm/jit/i386/codegen.c (codegen): Fix: Put RETURN replacement
	points before the emit_load. This code needs cleaning up.

2006-11-15 23:21  edwin

	* src/vm/jit/replace.c: Partial implementation of synchronization
	slot translation. Translating synchronized INLINE <-> CALL needs more
	work.

2006-11-15 23:19  edwin

	* src/vm/jit/replace.c (replace_find_replacement_poin): Fix: Compare
	both id and method when searching a replacement point.
	(replace_executionstate_println): Prettier printing.
	
	* src/vm/jit/replace.h (replace_pop_activation_record): Removed
	prototype.

2006-11-15 23:17  edwin

	* src/vm/jit/inline/inline.c (inline_instruction): New function.
	Factored code out of other functions generation instructions.

2006-11-15 23:15  edwin

	* src/vm/jit/jit.h (insinfo_inline): Added field `paramcount`.
	
	* src/vm/jit/inline/inline.c (inline_generate_sync_builtin): New
	function. Generate explicit MONITORENTER/EXIT instructions.
	(emit_inlining_prolog): Moved INLINE_START to the beginning of the
	prolog. Explicit synchronization.
	(emit_inlining_epilog): Explicit synchronization.
	(rewrite_method): Use epilog_instructioncount.
	(inline_analyse_callee): Explicit synchronization.
	
	* src/vm/jit/i386/codegen.c (ICMD_INLINE_START): Removed implicit
	synchronization.
	(ICMD_INLINE_END): Likewise.
	
	* src/vm/jit/replace.c (replace_create_replacement_point): Handle
	parameters for top frames.
	(replace_create_replacement_points): Likewise.
	(replace_read_executionstate): Likewise.
	(replace_write_executionstate): Likewise.
	(replace_me): Likewise.

2006-11-15 23:08  edwin

	* src/vm/jit/replace.h (RPLALLOC_STACK, RPLALLOC_PARAM,
	RPLALLOC_SYNC):
	New constants.
	
	* src/vm/jit/replace.c (replace_push_activation_record): Fix:
	Decrement
	SP _before_ writing the return address.
	(replace_me): More logging.
	(replace_replacement_point_println): More logging.
	(replace_executionstate_println): Prettier printing.

2006-11-15 23:02  edwin

	* src/vm/jit/code.h (codeinfo): Added field `invalid`. (Should become
	a flag, later.)
	* src/vm/jit/jit.c (jit_recompile): Fixed for first compilation. Do
	not
	refuse to recompile.

2006-11-15 22:59  edwin

	* src/vm/jit/inline/inline.c (inline_inline_intern): Do not inline
	abstract methods (need to search for single implementation).

2006-11-15 22:47  edwin

	* src/vm/jit/replace.c (replace_me): Small cleanup.
	* src/vm/jit/inline/inline.c (create_body_block): Do not translate
	javalocals for dead code.
	(inline_inline_intern): Fixed flag check.

2006-11-15 22:46  edwin

	* src/vm/method.c (method_printflags): Print MONOMORPHIC and
	IMPLEMENTED flags.

2006-11-15 18:26  twisti

	* src/vm/properties.c (properties_init) [ENABLE_JAVASE]: Allocate the
	utsname structure on the heap.

2006-11-15 18:09  twisti

	* src/vm/properties.c (properties_init) [ENABLE_JAVASE]: Don't free
	memory, we need it later.

2006-11-15 18:01  twisti

	* src/cacaoh/headers.c (cacao_prefix, classpath_libdir, _Jv_classpath)
	(_Jv_java_library_path): Added.

2006-11-15 17:58  twisti

	* src/vm/properties.c (properties_init): Also fill the internal
	property table.
	(properties_postinit): Re-set some properties that may have changed.
	(properties_system_add): Removed.
	[ENABLE_JAVASE] (properties_system_add_all): Rewritten.
	
	* src/vm/properties.h (properties_postinit): Changed signature.
	(properties_system_add): Removed.
	[ENABLE_JAVASE] (properties_system_add_all): Added.
	
	* src/native/vm/gnu_classpath_VMSystemProperties.c (preInit): Moved
	implementation to properties.
	
	* src/vm/vm.c (vm_create): Call properties_postinit.

2006-11-15 17:46  twisti

	* src/vm/vm.c (vm_create): Don't initialize java/lang/System
	explicitely.

2006-11-15 16:25  twisti

	* configure.ac (--enable-java): Added.

2006-11-15 15:52  twisti

	* src/vm/jit/parse.c (parse): Added missing semi-colon.

2006-11-15 15:47  edwin

	* src/vm/jit/icmdtable.inc (CHECKNULL_POP): Removed.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: Regenerated.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Likewise.

2006-11-15 15:42  twisti

	* src/vm/jit/jit.h (ICMD_CHECKNULL_POP): Removed.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/show.c: Likewise.

2006-11-15 15:30  twisti

	Reverted patch 5890.
	
	* src/vm/jit/jit.h: Reverted.
	
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/intrp/codegen.c: Likewise.
	
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: Likewise.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Likewise.

2006-11-15 13:44  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.c (md_param_alloc): Fixed
	preallocation.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method): Fixed
	argument handling.

2006-11-15 12:25  twisti

	* src/vm/jit/jit.h (ICMD_CHECKNULL): Renamed to ICMD_CHECKNULL_POP.
	
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/intrp/codegen.c: Likewise.
	
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/show.c: Likewise.
	
	* src/vm/jit/allocator/simplereg.c: Likewise.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc (ICMD_CHECKNULL):
	Removed.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Likewise.

2006-11-14 21:56  twisti

	* src/jit/verify/typecheck-stackbased.c (mm/memory.h): Added.
	* src/jit/powerpc/emit.c (mm/memory.h): Likewise.
	* src/signal.c (mm/memory.h): Likewise.

2006-11-13 21:43  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.c (md_param_alloc): Began
	fixing ABI issues. It is not correct now, but fptest runs now.
	Remaining issues in java<->native mainly stack offsets.
	
	* src/vm/jit/powerpc64/emit.c (emit_load): Removed M_ILD case.
	(emit_store): Removed M_FST case. There is no M_FST expect for
	accessing c structs, internally everything is done using M_DLD
	and M_DST, M_FST would convert the values.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Removed all M_FST and
	M_FLD.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method): Fixed
	argument passing on stack.

2006-11-12 15:42  edwin

	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Regenerated.

2006-11-12 15:41  edwin

	* src/vm/jit/icmdtable.inc: Activate INLINE_START and INLINE_END.

2006-11-12 15:33  edwin

	* src/vm/linker.c (inline_debug_log): Added variable reference.
	(linker_overwrite_method): Factored out overwriting into this
	function,
	update method flags and check assumptions when overwriting.
	(link_class_intern): Use linker_overwrite_method. Invalidate code of
	methods that makes broken assumptions.
	
	* src/vm/method.c (inline_debug_log): Only use for ENABLE_INLINING.
	(method_add_to_worklist): Allocate items with NEW.

2006-11-12 15:14  edwin

	* src/vm/method.h (method_assumption): New struct.
	(method_worklist): New struct.
	(methodinfo): Added fields `overwrites` and `assumptions`.
	(method_add_assumption_monomorphic): Added prototype.
	(method_break_assumption_monomorphic): Likewise.
	
	* src/vm/method.c (inline_debug_log): Added variable reference.
	(method_add_to_worklist): New function.
	(method_add_assumption_monomorphic): Likewise.
	(method_break_assumption_monomorphic): Likewise.

2006-11-12 15:01  edwin

	* src/cacaoh/headers.c (inline_debug_log): Added dummy variable.

2006-11-12 15:00  edwin

	* src/vm/loader.c (load_method): Set ACC_METHOD_MONOMORPHIC and
	ACC_METHOD_IMPLEMENTED flags.

2006-11-12 13:55  edwin

	* src/vm/jit/replace.c (replace_me): Recompile replacement methods.

2006-11-12 13:54  edwin

	* src/vm/jit/replace.c (replace_create_replacement_point): Use the
	ICMD id as id for replacement points.
	(replace_replacement_point_println): Print the rplpoint id.

2006-11-12 13:52  edwin

	* src/vm/jit/replace.c (replace_source_frame_println): Print position
	id.
	* src/vm/jit/replace.c (replace_pop_activation_record): Subtract one
	from the return address so we don't hit the following replacement
	point.

2006-11-12 13:51  edwin

	* src/vm/jit/replace.c (replace_write_executionstate): Added some
	asserts.

2006-11-12 13:50  edwin

	* src/vm/jit/replace.c: Cleaned up debugging prints.

2006-11-12 13:47  edwin

	* src/vm/jit/replace.c (replace_create_replacement_points): Handle
	javaindex == UNUSED.

2006-11-12 13:46  edwin

	* src/vm/jit/jit.h, src/vm/jit/jit.c (jit_invalidate_code):
	New function.

2006-11-12 13:40  edwin

	* src/vm/jit/jit.c (jit_recompile): Some cleanups.

2006-11-12 13:39  edwin

	* src/vm/jit/i386/md.c (md_patch_replacement_point): Deactivated
	debugging print.
	* src/cacaoh/headers.c (jit_invalidate_code): Added stub.

2006-11-12 13:38  edwin

	* src/vm/jit/inline/inline.c (emit_inlining_prolog): Set javaindex
	UNUSED for generated STOREs. Include local variables in stackvars
	for insinfo_inline. Copy instruction id to INLINE_START.
	(inline_clone_instruction): Check for javaindex == UNUSED.
	(rewrite_method): Set javaindex UNUSED for generated STOREs.
	(inline_inline_intern): Removed some testing code.

2006-11-12 13:31  edwin

	* src/vm/jit/parse.c, src/vm/jit/parse.h (Changes): Merged with
	Authors.

2006-11-12 13:21  edwin

	* src/vm/jit/jit.h (INS_FLAG_ID_SHIFT, INS_FLAG_ID_MASK): Added. We
	add
	an instruction id to the flags field. This is a first attempt to
	obtain
	an id for ICMDs that is not dependent on any optimizations or
	transformations in the compiler. The id is not the same as the
	bytecode
	PC, but it has a fixed relation to the bytecode PC, so it should be
	sufficient at least for replacement. This is an intermediate solution
	with serious shortcommings, and should be replaced by a true ICMD-to-
	bytecode-PC mapping in the future. (For example, the id uses up all
	the free bits in the flags field, and it is not protected against
	overflow.)
	
	* src/vm/jit/parse.h, src/vm/jit/parse.c: Set the instruction id, and
	do not overwrite it when setting other flags.
	
	* src/vm/jit/stack.c: Do not clear the instruction id.
	
	* src/vm/jit/show.c (show_basicblock): Display the instruction id.

2006-11-12 12:57  twisti

	* src/vm/jit/powerpc64/codegen.c (codegen): Fixed ICMD_BALOAD, use
	correct java_bytearray type.

2006-11-12 12:55  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Fixed ICMD_BALOAD, use
	correct java_bytearray type.

2006-11-12 12:54  edwin

	* src/vm/jit/parse.h: Fixed typos.

2006-11-11 19:26  ajordan

	* src/vm/jit/sparc64/*: implemented patching (partly), adherent fixes.

2006-11-11 18:45  twisti

	* src/vm/jit/alpha/codegen.c (codegen): Use emit_array_checks.

2006-11-11 18:34  twisti

	* src/vm/jit/alpha/codegen.c (codegen): Replaced gen_bound_check by
	emit_arrayindexoutofbounds_check.

2006-11-11 18:31  twisti

	* src/vm/jit/alpha/emit.c (vm/options.h): Added.
	(emit_arrayindexoutofbounds_check): New function.
	(emit_arraystore_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	
	* src/vm/jit/alpha/codegen.c (codegen): Removed patch-NOPs generation,
	replaced gen_nullptr_check with emit_nullpointer_check.
	(createnativestub): Removed patch-NOPs generation.
	
	* src/vm/jit/alpha/codegen.h (gen_nullptr_check): Removed.
	(PATCHER_NOPS): Added.
	
	* src/vm/jit/alpha/patcher.c (patcher_get_putfield): Use opt_shownops
	instead of opt_showdisassemble.
	(patcher_invokevirtual): Likewise.
	(patcher_invokeinterface): Likewise.
	(patcher_checkcast_instanceof_interface): Likewise.
	
	* src/vm/jit/emit-common.c (emit_array_checks): Added [__ALPHA__].
	* src/vm/jit/codegen-common.c (codegen_add_patch_ref): Likewise.

2006-11-11 17:08  edwin

	* src/vm/jit/tools/genoffsets.c (executionstate): Renamed to
	executionstate_t.
	* src/vm/jit/asmpart.h: Likewise.
	
	* src/vm/jit/show.c (show_variable_intern): New function. Does not
	append ' '. Regard variables above vartop as invalid.
	(show_method): Only show variables up to vartop.
	(show_inline_info): New function.
	(show_basicblock): Show right number of javalocals, show inlining
	info at the start of blocks.
	(show_variable): Moved body to show_variable_intern.
	(show_icmd): Use show_inline_info.
	
	* src/vm/jit/inline/inline.c: Handle javalocals.
	
	* src/vm/jit/i386/codegen.c (codegen): Handle replacement points
	for INLINE_START, RETURN and INVOKEs.
	
	* src/vm/jit/replace.c: Many changes for making replacement work
	over multiple stack frames.
	* src/vm/jit/replace.h: Likewise.
	
	* src/vm/jit/jit.h (insinfo_inline): Added fields.
	(basicblock): Added field `inlineinfo`.

2006-11-11 17:05  twisti

	* src/vm/jit/alpha/codegen.c (codegen): Renamed codegen_addpatchref to
	codegen_add_patch_ref and codegen_addreference to
	codegen_add_branch_ref.
	(createnativestub): Likewise.

2006-11-11 16:56  twisti

	* src/vm/jit/alpha/md.c (md_codegen_patch_branch): New function.
	* src/vm/jit/alpha/emit.c (emit_exception_stubs): Use
	md_codegen_patch_branch.
	* src/vm/jit/alpha/codegen.c (codegen): Use
	codegen_resolve_branchrefs.
	* src/vm/jit/alpha/codegen.h (gen_resolvebranch): Removed.

2006-11-11 16:44  twisti

	* configure.ac: Support mipsel architectures.

2006-11-11 14:28  twisti

	* src/vm/jit/codegen-common.c (codegen_add_patch_ref): Added
	[__X86_64__] for NOP-generation.

2006-11-10 16:41  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Use
	codegen_resolve_branchrefs, removed patcher NOP generation, renamed
	codegen_addpatchref to codegen_add_patch_ref.
	(createnativestub): Likewise.
	
	* src/vm/jit/x86_64/codegen.h (PATCHER_NOPS): Defined.
	
	* src/vm/jit/x86_64/patcher.c (patcher_get_putstatic): Use
	opt_shownops instead of opt_showdisassemble.
	(patcher_get_putfield): Likewise.
	(patcher_putfieldconst): Likewise.
	(patcher_aconst): Likewise.
	(patcher_builtin_multianewarray): Likewise.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_invokestatic_special): Likewise.
	(patcher_invokeinterface): Likewise.
	(patcher_checkcast_instanceof_flags): Likewise.
	(patcher_checkcast_instanceof_interface): Likewise.
	(patcher_checkcast_class): Likewise.
	(patcher_instanceof_class): Likewise.
	(patcher_resolve_native): Likewise.

2006-11-10 12:32  twisti

	* src/vm/jit/x86_64/md.c (md_codegen_patch_branch): New function.
	* src/vm/jit/x86_64/emit.c (emit_exception_stubs): Use
	md_codegen_patch_branch.

2006-11-09 15:27  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Use codegen_add_branch_ref,
	removed opt_shownops code.
	(createnativestub): Likewise.
	
	* src/vm/jit/powerpc/codegen.h (PATCHER_NOPS): Added.
	* src/vm/jit/mips/codegen.h (PATCHER_NOPS): Removed opt_shownops
	check.
	
	* src/vm/jit/codegen-common.c (codegen_add_patch_ref): Check for
	opt_shownops, added [__POWERPC__].

2006-11-09 10:52  twisti

	* src/vm/jit/powerpc/emit.c (vm/options.h): Added.
	(emit_nullpointer_check): New function.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_exception_stubs): Use md_codegen_patch_branch.
	
	* src/vm/jit/powerpc/md.c (vm/jit/powerpc/codegen.h): Added.
	(md_codegen_patch_branch): New function.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Use
	codegen_resolve_branchrefs, use opt_shownops, removed buggy ICMD_LCMP
	implementation (i'll add a new one if i find some time), use exception
	emit_* functions.
	(createnativestub): Use opt_shownops.
	
	* src/vm/jit/powerpc/patcher.c (patcher_get_putfield): Use
	opt_shownops.
	(patcher_invokevirtual): Likewise.
	(patcher_invokeinterface): Likewise.
	(patcher_checkcast_instanceof_interface): Likewise.
	
	* src/vm/jit/powerpc/codegen.h (gen_nullptr_check): Removed.
	(gen_bound_check): Likewise.
	(M_BRAMASK): Renamed to M_BMASK.
	(M_BRMASK): Renamed to M_BCMASK.
	(M_BRA): Renamed to M_B and hardcoded the opcode.
	(M_BRAC): Renamed to M_BC and hardcoded the opcode.
	(gen_resolvebranch): Removed.
	
	* src/vm/jit/emit-common.c (emit_array_checks): New function.
	* src/vm/jit/emit-common.h (emit_array_checks): Added.

2006-11-09 10:23  twisti

	* src/vm/jit/stacktrace.c (stacktrace_add_method): Get codeinfo from
	data segment.

2006-11-09 09:59  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.h: Changed ABI for float
	arguments.
	
	* src/vm/jit/powerpc64/linux/md-asm.h: Likewise.
	
	* src/vm/jit/powerpc64/linux/md-abi.c: Likewise.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method): Various
	argument handling fixes.
	
	* src/vm/jit/powerpc64/codegen.h (M_BRAC): Renamed to M_BC
	(M_BRA): Renamed to M_B
	(M_BRACMASK): Renamed to M_BCMASK.
	(M_BRAMASK): Renamed to M_BMASK.
	
	* src/vm/jit/powerpc64/md.c (md_codegen_patch_branch): Use M_BCMASK
	and M_BMASK instead of hardcoded masks.

2006-11-09 09:54  twisti

	* src/vm/jit/powerpc/linux/md-os.c (vm/jit/profile/profile.h): Changed
	to vm/jit/optimizing/profile.h.
	(md_signal_handler_sigsegv): If faulting address is not equal 0, try
	to dump a tsacktrace and exit.

2006-11-08 22:02  twisti

	* NEWS: Added release 0.98.

2006-11-08 22:00  twisti

	* src/vm/method.h (methodinfo): Added signature.
	* src/vm/field.h (fieldinfo): Added signature.
	* src/vm/loader.c (load_method): Load signature attribute.
	(load_field): Likewise.
	* src/native/vm/java_lang_reflect_Method.c (getSignature):
	Implemented.
	* src/native/vm/java_lang_reflect_Field.c (getSignature): Likewise.

2006-11-08 20:34  edwin

	* src/vm/jit/code.h (codeinfo): Added field stackframesize.
	* src/vm/jit/code.c (code_get_stack_frame_size): Return
	code->stackframesize.
	
	* src/vm/jit/replace.c (replace_create_replacement_points): Set
	code->stackframesize.
	(replace_read_executionstate): Read stack types from rplallocs.
	(replace_write_executionstate): Check stack types.
	(replace_pop_activation_record): New function.
	(replace_me): Added some temporary code for testing.
	(replace_executionstate_println): Use executionstate.code.
	(java_value_print): New function.
	(replace_sourcestate_println): Print values prettily.
	
	* src/vm/jit/replace.h (executionstate): Added field `code`.
	(sourcestate): Added field `javastacktype`.
	(replace_pop_activation_record): New function.
	(replace_executionstate_println): Changed arguments.

2006-11-08 20:27  twisti

	* src/vm/exceptions.c (new_nullpointerexception): Renamed to
	exceptions_new_nullpointerexception.
	* src/vm/exceptions.h: Likewise.
	* src/vm/jit/stacktrace.c: Likewise.
	* src/cacaoh/headers.c: Likewise.

2006-11-08 13:33  tbfg

	* src/vm/jit/powerpc64/codegen.h (gen_resolvebranch): Removed.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Replaced
	gen_resolvebranch with md_codegen_patch_branch.
	
	* src/vm/jit/powerpc64/md.c (md_codegen_patch_branch): Prevent AA
	and LK overwrites for b.

2006-11-08 13:03  tbfg

	* src/vm/jit/powerpc64/md.c (md_codegen_patch_branch): Added.

2006-11-07 09:06  twisti

	* src/vm/jit/i386/md.c (md_codegen_patch_branch): New function.
	* src/vm/jit/i386/emit.c (emit_exception_stubs): Use
	md_codegen_patch_branch.
	* src/vm/jit/i386/codegen.c (codegen): Use codegen_resolve_branchrefs.
	* src/vm/jit/i386/codegen.h (gen_resolvebranch): Removed.

2006-11-07 08:51  twisti

	* src/vm/jit/codegen-common.h (codegen_resolve_branchrefs): Added.

2006-11-06 21:12  twisti

	* jit/mips/emit.c (emit_patcher_stubs): Handle displacement overflows.
	
	* jit/mips/codegen.c (codegen): Removed patcher NOPs generation.
	(createnativestub): Likewise.
	
	* jit/mips/codegen.h (PATCHER_CALL_INSTRUCTIONS): Defined.
	(PATCHER_CALL_SIZE): Changed to 5 * 4;
	(PATCHER_NOPS): Defined.
	
	* jit/mips/patcher.c (patcher_wrapper): Restore original instructions.
	(patcher_get_putstatic): Don't restore original code.
	(patcher_get_putfield): Likewise.
	(patcher_aconst): Likewise.
	(patcher_builtin_multianewarray): Likewise.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_invokestatic_special): Likewise.
	(patcher_invokevirtual): Likewise.
	(patcher_invokeinterface): Likewise.
	(patcher_checkcast_instanceof_flags): Likewise.
	(patcher_checkcast_interface): Likewise.
	(patcher_instanceof_interface): Likewise.
	(patcher_checkcast_instanceof_class): Likewise.
	(patcher_clinit): Likewise.
	(patcher_athrow_areturn): Likewise.
	(patcher_resolve_native): Likewise.
	
	* jit/mips/asmpart.S (asm_patcher_wrapper): Handle bigger patcher stub
	stack.
	
	* jit/codegen-common.c (codegen_add_patch_ref): Generate NOPs, if
	requested.

2006-11-06 17:13  twisti

	* src/vm/jit/codegen-common.c (toolbox/list.h): Added.
	(codegen_addreference): Renamed to codegen_add_branch_ref, use
	md_codegen_patch_branch instead of gen_resolvebranch.
	(codegen_resolve_branchrefs): New function.
	(codegen_addpatchref): Renamed to codegen_add_patch_ref.
	* src/vm/jit/codegen-common.h (codegen_addreference): Renamed to
	codegen_add_branch_ref.
	(codegen_resolve_branchrefs): New function.
	(codegen_addpatchref): Renamed to codegen_add_patch_ref.
	
	* src/vm/jit/dseg.h (toolbox/list.h): Added.
	
	* src/vm/jit/mips/emit.c (vm/options.h): Added.
	(emit_arithmetic_check): New function.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_arraystore_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	(emit_exception_check): Likewise.
	(emit_exception_stubs): Use md_codegen_patch_branch instead of
	gen_resolvebranch.
	
	* src/vm/jit/mips/md.c (vm/vm.h): Added.
	(md_codegen_patch_branch): New function.
	
	* src/vm/jit/mips/codegen.c (codegen): Use new emit_* functions, use
	opt_shownops instead of opt_showdissasemble.
	(createnativestub): Likewise.
	
	* src/vm/jit/mips/codegen.h (gen_nullptr_check): Removed.
	(gen_bound_check): Likewise.
	(gen_div_check): Likewise.
	(gen_resolvebranch): Likewise.
	
	* src/vm/jit/mips/patcher.c: Use opt_shownops instead of
	opt_showdissasemble.
	(patcher_checkcast_instanceof_interface): Split into two functions:
	patcher_checkcast_interface and patcher_instanceof_interface.
	
	* src/vm/jit/patcher.h (patcher_checkcast_interface): Added.
	(patcher_instanceof_interface): Added.
	
	* src/vm/jit/emit-common.h (emit_arithmetic_check): Added.
	(emit_arrayindexoutofbounds_check): Likewise.
	(emit_arraystore_check): Likewise.
	(emit_classcast_check): Likewise.
	(emit_nullpointer_check): Likewise.
	(emit_exception_check): Likewise.

2006-11-06 16:38  tbfg

	* src/vm/jit/powerpc64/codegen.c (codegen): Various more fixes all
	over the place. jctest is now successfull for ppc64.
	
	* src/vm/jit/powerpc64/codegen.h (M_DIV): Changed used opcode.
	(M_SLL_IMM): Fixed.

2006-11-06 16:17  edwin

	* src/vm/jit/replace.c (replace_create_replacement_point): New
	function.
	(replace_create_replacement_points): Create replacement points for
	INVOKE* and *RETURN instructions.
	(replace_read_executionstate): Fixed loop.
	(replace_write_executionstate): Fixed loop.
	(replace_sourcestate_println): Adapted to new source state layout.

2006-11-05 23:17  edwin

	* src/vm/jit/i386/codegen.c (codegen): Create replacement points after
	the final allocations.
	
	* src/vm/jit/jit.c (jit_compile_intern): Do not create replacement
	points before the codegen is called.

2006-11-05 23:11  edwin

	* src/vm/jit/codegen-common.h (codegendata): Removed maxlocals. This
	is
	now in jitdata.
	* src/vm/jit/codegen-common.c (codegen_setup): Removed cd->maxlocals.
	
	* src/vm/jit/replace.c: Move towards exact replacement/GC points.
	* src/vm/jit/replace.h: Likewise.
	
	* src/vm/jit/optimizing/lsra.h: Use jd->maxlocals.
	* src/vm/jit/optimizing/lifetimes.c: Likewise.
	* src/vm/jit/optimizing/ssa.c: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/loop/analyze.c: Likewise.
	* src/vm/jit/inline/inline.c: Likewise.
	* src/vm/jit/allocator/lsra.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/allocator/liveness.c: Likewise.
	* src/vm/jit/jit.c: Likewise.
	
	* src/vm/jit/show.h (show_allocation): Made global.
	* src/vm/jit/show.c: Likewise.

2006-11-05 22:47  edwin

	* src/vm/jit/jit.c (jit_jitdata_new): Initialize jd->maxlocals.

2006-11-05 22:46  edwin

	* src/vm/jit/jit.h (jitdata): Added maxlocals field.

2006-11-05 21:43  twisti

	* src/vm/options.c (opt_shownops): Added.
	* src/vm/options.h (opt_shownops): Likewise.
	* src/vm/vm.c (usage): Added -so help.
	(vm_create): Added opt_shownops handling.

2006-11-05 21:27  edwin

	* src/vm/jit/jit.h (INS_FLAG_RETADDR): Added flag for marking ASTOREs
	of returnAddresses.
	
	* src/vm/jit/stack.c (stack_reanalyse_block): Invalidate target of
	ASTORE with returnAddress.
	(stack_analyse): Likewise.

2006-11-05 21:23  twisti

	* src/vm/utf8.c (utf_Signature): Added.
	(utf8_init): Initialize utf_Signature.
	* src/vm/utf8.h (utf_Signature): Added.

2006-11-05 21:18  twisti

	* src/vm/loader.c (load_attributes): Load Signature attribute.
	* src/vm/class.h (classinfo): Added signature.
	* src/native/vm/java_lang_VMClass.c (getClassSignature): Implemented.

2006-11-05 21:14  edwin

	* src/vm/jit/show.c (show_basicblock): Show javalocals.
	(show_variable_array): Made it NULL-safe, show UNUSED entries.

2006-11-05 20:17  edwin

	* src/vm/jit/show.c (show_icmd): Show javaindex for *STORE.

2006-11-05 20:07  edwin

	* src/vm/jit/jit.h (s3_operand_t): Added field javaindex.
	(INS_FLAG_KILL_PREV): New flag.
	(INS_FLAG_KILL_NEXT): New flag.
	(basicblock): Added field javalocals. This points to the mapping from
	Java bytecode locals to cacao variables at the beginning of the block.
	
	* src/vm/jit/stack.c (Changes): Merged with Authors.
	(stackdata_t): Added fields maxlocals and javalocals.
	(stack_clone_block): Initialize javalocals.
	(stack_create_locals): New function.
	(stack_merge_locals): New function.
	(stack_create_invars): Use stack_create_invars.
	(stack_create_invars_from_outvars): Likewise.
	(stack_check_invars): Use stack_merge_locals.
	(stack_check_invars_from_outvars): Likewise.
	(stack_reanalyse_block): Maintain javalocals mapping.
	(stack_init_javalocals): New function.
	(stack_analyse): Maintain javalocals mapping.
	(stack_verbose_show_block): Show javalocals.
	(stack_verbose_block_enter): Distinguish block cloning and
	re-analysing.
	(stack_verbose_show_state): New function.

2006-11-05 19:49  edwin

	* src/vm/jit/stack.c (COPY_VAL_AND_TYPE): Fix: Only copy vv for
	TYPE_RET
	(and later for other constants). Otherwise the allocation of PREALLOC
	variables can be overwritten when re-analysing a block.

2006-11-05 19:45  edwin

	* src/vm/jit/show.c (show_method): Show maxinterfaces only for stage
	>= SHOW_STACK.
	(show_variable): Show allocation for PREALLOC variables.

2006-11-05 16:58  michi

	* src/vm/jit/stacktrace.h: Added stacktracecontainer.
	* src/vm/jit/stacktrace.c (stacktrace_fillInStackTrace): Now returns
	stacktracecontainer as wrapper for stacktracebuffer and entries.
	
	* src/native/vm/java_lang_VMThrowable.c: Undoes the wrapping
	mentioned above.

2006-11-05 15:47  edwin

	* src/vm/jit/replace.c (replace_create_replacement_points): Partially
	ported to new IR.
	
	* src/vm/jit/i386/codegen.c (codegen): Reactivate code for
	replacement points.
	* src/vm/jit/jit.c (jit_compile_intern): Likewise.

2006-11-05 10:40  edwin

	* src/vm/jit/inline/inline.c: Ported to the new IR. There are some
	checkins missing to make it linkable, though.
	* src/vm/jit/inline/inline_debug.inc: Likewise.

2006-11-05 10:31  edwin

	* src/vm/global.h (ACC_METHOD_IMPLEMENTED): Added.
	(ACC_METHOD_MONOMORPHIC): Added.

2006-11-05 10:22  edwin

	* src/vm/jit/jit.h (jitdata): New fields maxinterfaces, returnblock,
	returncount, branchtoentry, branchtoend.
	
	* src/vm/jit/jit.c (jit_jitdata_new): Initialize new fields.
	
	* src/vm/jit/parse.c (parse_mark_exception_boundaries): Set
	branchtoend.
	(parse): Set branchtoentry.
	
	* src/vm/jit/stack.c (stack_analyse): Set jd->maxinterfaces,
	returncount, and returnblock.
	
	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_interfaces):
	Use jd->maxinterfaces.
	(simplereg_allocate_temporaries): Likewise.
	
	* src/vm/jit/show.c (show_method): Show the new fields. Use
	jd->maxinterfaces. Show invalid variable indices. Show inline info.

2006-11-05 09:52  edwin

	* src/vm/jit/i386/codegen.c (codegen): Reactivated code for inlining.

2006-11-04 23:42  edwin

	* src/vm/jit/jit.h (jitdata): Clarified comment of isleafmethod.

2006-11-04 23:37  edwin

	* src/vm/jit/jit.c (jit_jitdata_new): Initialize jd->isleafmethod
	depending on whether the method needs synchronization.
	
	* src/vm/jit/parse.c (parse): Initialization of jd->isleafmethod has
	been moved to jit_jitdata_new.

2006-11-04 23:29  edwin

	* src/vm/jit/jit.h, src/vm/jit/jit.c (jit_jitdata_new): Made global.

2006-11-04 23:24  edwin

	* src/vm/loader.c (load_newly_created_array): Explicitly zero the
	allocated methodinfo array.

2006-11-04 23:13  edwin

	* src/vm/jit/stack.c (stack_change_to_tempvar): Fix: Only replace
	pass-through variables at the right stack depth. Otherwise the IR
	can become inconsistent, for example a temporary variable could be
	used more than once.

2006-11-04 22:40  edwin

	* src/vm/jit/stack.c (stack_reanalyse_block): Relocate dst.varindex
	for ICMD_JSR (even if it is not used, it keeps the IR consistent).

2006-11-04 22:01  edwin

	* src/mm/memory.c: Added ENABLE_MEMCHECK code:
	(mem_alloc): Prepared for poisoning memory.
	(mem_realloc): Invalidate freed memory.
	(mem_free): Invalidate freed memory.
	(dump_check_canaries): New function.
	(dump_alloc): Added canaries, record allocation.
	(dump_realloc): Invalidate freed memory.
	(dump_release): Check canaries, invalidate freed memory.
	
	* src/mm/memory.h (dump_allocation_t): New struct.
	(dumpinfo_t): Added allocation list for ENABLE_MEMCHECK.
	
	* configure.ac (--enable-memcheck): Added configure flag.

2006-11-04 17:30  michi

	* src/mm/boehm.h: Renamed to gc-common.h
	* src/mm/gc-common.h: Added.
	
	* src/vm/builtin.c, src/vm/jit/mips/linux/md-os.c,
	src/vm/jit/mips/irix/md-os.c, src/vm/jit/stacktrace.c, src/vm/vm.c,
	src/native/tool/gennativetable.c, src/native/jni.c,
	src/native/vm/gnu_java_lang_management_VMThreadMXBeanImpl.c,
	src/native/vm/gnu_java_lang_management_VMMemoryMXBeanImpl.c,
	src/native/vm/java_lang_VMObject.c,
	src/native/vm/java_lang_VMRuntime.c,
	src/native/vm/gnu_java_lang_management_VMClassLoadingMXBeanImpl.c,
	src/native/jvmti/jvmti.c, src/mm/nogc.c, src/mm/boehm.c,
	src/mm/memory.h,
	src/threads/native/threads.c, src/cacaoh/headers.c,
	src/cacaoh/cacaoh.c:
	Changed include from "mm/boehm.h" to "mm/gc-common.h"
	
	* src/mm/Makefile.am: Added subdir and lib for cacao-gc
	
	* src/mm/cacao-gc: Added.
	* src/mm/cacao-gc/gc.c: Added.
	* src/mm/cacao-gc/Makefile.am: Added.
	* src/mm/cacao-gc/.cvsignore: Added.
	
	* src/threads/native/threads.c: Fixed include of boehms gc.h
	
	* src/vm/jit/mips/linux/md-os.c (md_init) [ENABLE_GC_BOEHM]: Added
	ifdef
	for boehm specific call.
	* src/vm/jit/mips/irix/md-os.c: Likewise.
	* src/vm/signal.c: Likewise.
	
	* configure.ac: Adapted buildsystem for new GC. Added cacao-gc.

2006-11-04 15:46  tbfg

	* src/vm/jit/powerpc64/emit.c (emit_verbosecall_enter):
	Removed unsued var.
	
	* src/vm/jit/powerpc64/codegen.c (codegen):
	Lots of arithmetic changes.
	
	* src/vm/jit/powerpc64/codegen.h (M_SLL): Converted to 64bit.
	(M_LSTX): Added.
	(gen_bound_check): Fixed.

2006-11-03 22:11  michi

	* src/vm/loader.c (load_class_from_classbuffer): Removed commented
	code which
	placed methodinfos onto the heap.

2006-11-03 15:40  tbfg

	checkcast testcase

2006-11-03 15:13  twisti

	* parisc/.cvsignore: New file.
	* parisc/linux/.cvsignore: Likewise.

2006-11-03 14:03  twisti

	* src/vm/jit/parisc/md-abi.h: New file.
	* src/vm/jit/parisc/md.c: Likewise.
	* src/vm/jit/parisc/arch.h: Likewise.
	* src/vm/jit/parisc/Makefile.am: Likewise.
	* src/vm/jit/Makefile.am (SUBDIRS): Added parisc.
	* configure.ac: Added parisc support.

2006-11-02 12:54  twisti

	* src/toolbox/list.c, src/toolbox/list.h (list_create_dump): New
	function.
	(list_first_unsynced): Likewise.
	(list_last_unsynced): Likewise.
	(list_next_unsynced): Likewise.
	(list_prev_unsynced): Likewise.

2006-11-02 12:50  twisti

	* src/Makefile.am (DIST_SUBDIRS): Compile mm first.
	(SUBDIRS): Likewise.

2006-11-02 10:21  twisti

	* src/vm/jit/dseg.h (patchref): Added comments.

2006-11-01 20:19  twisti

	* src/vm/jit/mips/codegen.c (codegen): Use new dseg function names.
	(createnativestub): Likewise.
	* src/vm/jit/mips/emit.c (emit_iconst): Likewise.
	(emit_lconst): Likewise.
	(emit_exception_stubs): Likewise.
	(emit_patcher_stubs): Likewise.
	(emit_verbosecall_enter): Likewise.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/mips/codegen.h (M_INTMOVE): Wrap into do-while.

2006-10-31 22:02  twisti

	* src/vm/jit/Makefile.am (DIST_SUBDIRS): Forgot to remove ifconv.

2006-10-31 22:01  twisti

	* src/vm/jit/ifconv: Removed.
	
	* src/vm/jit/optimizing/ifconv.c: Added.
	* src/vm/jit/optimizing/ifconv.h: Likewise.
	
	* src/vm/jit/optimizing/Makefile.am (IFCONV_SOURCES): Added.
	(liboptimizing_la_SOURCES): Added IFCONV_SOURCES.
	
	* src/vm/jit/jit.c (vm/jit/ifconv/ifconv.h): Changed to
	vm/jit/optimizing/ifconv.h.
	
	* src/vm/jit/Makefile.am (IFCONV_LIB): Removed.
	
	* configure.ac (AC_CONFIG_FILES): Removed src/vm/jit/ifconv/Makefile.

2006-10-31 21:57  ajordan

	* src/vm/jit/sparc64/asmpart.S: added exception handling code.
	* src/vm/jit/sparc64/md-asm.h: Likewise.
	
	* src/vm/jit/sparc64/*: implemented createnativestub, added functions
	for param allocation following the ABI.

2006-10-31 21:35  twisti

	* src/vm/jit/reorder.c: Removed.
	* src/vm/jit/reorder.h: Likewise.
	
	* src/vm/jit/optimizing/reorder.c: Added.
	* src/vm/jit/optimizing/reorder.h: Likewise.
	
	* src/vm/jit/optimizing/Makefile.am (REORDER_SOURCES): Added.
	(liboptimizing_la_SOURCES): Added REORDER_SOURCES.
	
	* src/vm/jit/jit.c (vm/jit/reorder.h): Changed to
	vm/jit/optimizing/reorder.h.
	
	* src/vm/jit/Makefile.am (libjit_la_SOURCES): Removed reorder.[ch].

2006-10-31 21:27  twisti

	* src/vm/jit/optimizing/Makefile.am (INCLUDES): Renamed to
	AM_CPPFLAGS.
	(LIBS): Added.

2006-10-31 20:26  twisti

	* src/vm/vm.c (vm/jit/profile/profile.h): Changed to
	vm/jit/optimizing/profile.h.
	(vm/jit/recompile.h) Changed to vm/jit/optimizing/recompile.h.

2006-10-31 20:11  twisti

	* src/vm/jit/optimizing/profile.c: Added.
	* src/vm/jit/optimizing/profile.h: Likewise.
	* src/vm/jit/optimizing/recompile.c: Likewise.
	* src/vm/jit/optimizing/recompile.h: Likewise.
	
	* src/vm/jit/optimizing/Makefile.am (INCLUDES): Added OS_DIR.
	(PROFILE_SOURCES): Added.
	(RECOMPILE_SOURCES): Added.
	(SSA_SOURCES): Added.
	
	* src/vm/jit/recompile.c: Removed.
	* src/vm/jit/recompile.h: Likewise.
	* src/vm/jit/profile: Likewise.
	
	* src/vm/jit/Makefile.am (SUBDIRS): Added optimizing.
	(PROFILE_LIB): Removed.
	(RECOMPILE_SOURCES): Likewise.
	
	* src/cacao/Makefile.am (GC_LIB): Removed.
	
	* src/mm/Makefile.am (DIST_DUBDIRS): Added boehm-gc.
	(GC_LIB): Added.
	
	* src/Makefile.am (DIST_SUBDIRS): Removed boehm-gc.
	(SUBDIRS): Likewise.
	(BOEHM): Removed.
	
	* src/threads/native/threads.c (boehm-gc/include/gc.h): Changed to
	mm/boehm-gc/include/gc.h.
	
	* src/cacaoh/Makefile.am (GC_LIB): Removed.
	
	* configure.ac (AC_CONFIG_FILES): Removed src/vm/jit/profile/Makefile.
	(AC_CONFIG_SUBDIRS): Changed src/boehm-gc to src/mm/boehm-gc.
	* autogen.sh: Changed path to boehm-gc.

2006-10-31 20:00  twisti

	* src/vm/exceptions.c (exceptions_handle_exception): Made identation
	correct.

2006-10-31 19:58  twisti

	* src/mm/boehm-gc/.cvsignore: Added some files.

2006-10-31 15:42  twisti

	* Moved boehm-gc from src/ to src/mm/.

2006-10-31 13:40  tbfg

	* src/vm/jit/powerpc64/codegen.c (codegen):
	Fixed parameter passing.
	Various fixes for many ICMD_*.
	
	* src/vm/jit/powerpc64/patcher.c (patcher_get_putfield):
	Fixed for longs.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method):
	Fixed methodheader, exception handling now works.
	
	* src/vm/exceptions.c (exceptions_handle_exception):
	Indenting.

2006-10-31 10:16  twisti

	* configure.ac (AC_INIT): Changed version to 0.97+svn.
	(OPT_CFLAGS): Changed to -O0.

2006-10-31 10:15  twisti

	* NEWS: Forgot to commit the date for 0.97, grrrr.

2006-10-31 00:07  twisti

	* ChangeLog: Updated for release 0.97.
2006-10-30 23:52  twisti

	* configure.ac (AC_INIT): Changed version to 0.97.
	(--enable-threads): Removed green from help string.

2006-10-30 13:03  twisti

	* src/vm/jit/show.c (show_method): Removed debug output.
	(SHOW_INT_CONST): Removed long cast and print hex value additionally.
	(SHOW_LNG_CONST): Removed long long cast and print hex value
	additionally. Also added version for SIZEOF_VOID_P == 4.
	(SHOW_ADR_CONST): Added.
	(SHOW_FLT_CONST): Print hex value additionally.
	(SHOW_DBL_CONST): Likewise. Also added version for SIZEOF_VOID_P == 4.
	(show_icmd): Smaller changes.

2006-10-30 12:27  twisti

	* src/threads/native/threads.h (MUTEXSIM): Removed.
	(pthread_mutex_rec_t): Likewise.
	(pthread_mutex_init_rec): Likewise.
	(pthread_mutex_destroy_rec): Likewise.
	(pthread_mutex_lock_rec): Likewise.
	(pthread_mutex_unlock_rec): Likewise.
	* src/threads/native/threads.c (pthread_mutex_init_rec): Removed.
	(pthread_mutex_destroy_rec): Likewise.
	(pthread_mutex_lock_rec): Likewise.
	(pthread_mutex_unlock_rec): Likewise.
	(compiler_lock): Use pthread functions.
	(compiler_unlock): Likewise.
	(threads_cast_darwinstop): Warning fixes and use vm_abort.
	(threads_cast_darwinresume): Use vm_abort.
	(threads_cast_stopworld): Warning fixes.
	(pthreads_preinit) [!MUTEXSIM]: Removed code.

2006-10-30 11:52  edwin

	* src/vm/jit/intrp/intrp.h (Cell): Moved the typedef upward, so we can
	use it in other headers.
	(global_sp): Does not need the complex casts anymore.
	
	* src/threads/native/threads.h (threadobject): Made _global_sp a
	Cell*.
	* src/threads/native/threads.c: Likewise.

2006-10-30 11:21  edwin

	* src/mm/memory.h (ALIGN): Renamed to MEMORY_ALIGN.
	* src/mm/memory.c: Likewise.
	* src/vm/jit/dseg.c: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/codegen-common.c: Likewise.
	* src/vm/linker.c: Likewise.
	* src/mm/nogc.c: Likewise.
	* src/cacaoh/headers.c: Likewise.

2006-10-30 11:04  edwin

	* src/threads/native/threads.c (threads_dump): Cast pthread_t to long
	for printing it.

2006-10-30 11:00  edwin

	* src/vm/jit/cfg.c (cfg_build): Removed set-but-not-used variable (m).
	* src/vm/jit/ifconv/ifconv.c (check): Likewise (cd).
	* src/vm/jit/stack.c (stack_reanalyse_block): Likewise (maythrow).
	(stack_analyse): Likewise (code, b_index).
	* src/vm/jit/show.c (show_basicblock): Likewise (m).
	* src/vm/jit/mips/emit.c (emit_copy): Likewise (rd).
	* src/vm/jit/parse.c (parse): Likewise (code).
	* src/vm/exceptions.c (exceptions_handle_exception): Likewise
	(framesize).

2006-10-30 10:32  edwin

	* src/vm/jit/verify/typecheck-common.c (typecheck_init_flags): Removed
	set-but-not-used variable `i`.

2006-10-30 10:31  edwin

	* src/vm/jit/verify/typecheck-builtins.inc: Removed set-but-not-used
	variable `cls`.

2006-10-30 10:15  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Zero `uf` to avoid warning.

2006-10-30 00:45  edwin

	* src/vm/builtin.c (builtin_print_argument): Made logtextlen an in/out
	argument. Correctly reallocate logtext, increase logtextlen.
	(builtin_trace_args): Pass &logtextlen to builtin_print_argument.
	(builtin_displaymethodstop): Likewise.

2006-10-29 23:43  edwin

	* src/vm/jit/jit.h (stackelement): Removed the obsolete fields
	`typeinfo` and `regoff`.

2006-10-29 23:37  edwin

	* src/vm/jit/stack.c (stack_grow_variable_array): Zero the additional
	space when reallocating the jd->var array.
	
	* src/vm/jit/parse.c (parse_realloc_instructions): Zero the
	additional space when reallocating the instructions array.

2006-10-29 23:33  edwin

	* src/vm/jit/parse.c (parse): Fix in ICMD_TABLESWITCH: Put table into
	dump memory.

2006-10-29 23:23  edwin

	* NEWS: Typo fixed.

2006-10-29 16:21  edwin

	* src/vm/suck.c (stdlib.h): Include to avoid warning about `free`.

2006-10-29 16:14  edwin

	* src/vm/suck.c (suck_add_from_property): Use `free` to free memory
	coming out of the C library - it has not been allocated with M?NEW,
	so M?FREE is wrong here.

2006-10-29 14:49  twisti

	* src/vm/builtin.c (builtin_print_argument): Print float/double values
	with %g and addresses as hex.
	(builtin_trace_args): Fixed message length calclation.
	(builtin_displaymethodstop): Fixed bug: we only passed the long value.

2006-10-29 11:15  edwin

	* src/cacaoh/headers.c (vm_abort): Print the error message before
	aborting.

2006-10-28 19:40  twisti

	* NEWS: New news.

2006-10-28 19:26  twisti

	* src/vm/jit/dseg.c (dseg_find_float): Compare hex value.
	(dseg_find_double): Likewise.

2006-10-28 17:45  twisti

	* NEWS: Added some stuff.

2006-10-28 17:15  edwin

	* NEWS: Added news for CACAO 0.97.

2006-10-28 16:55  edwin

	* src/vm/jit/jit.c (stackreq): Fixed for DUP/SWAP instructions. The
	numbers for DUP2_X1 and DUP2_X2 were also wrong before the new IR
	had been introduced. The new IR in addition needs extra temps in some
	cases, thus the numbers before the 'plus' operators.

2006-10-28 16:51  edwin

	* src/vm/jit/stack.c (stack_analyse): Store vartop in jitdata.
	
	* src/vm/jit/show.c (show_method): Show number of variables.
	
	* tests/regression/jasmin/test_many_dup2_x2.j: New test.
	* tests/regression/jasmin/test_many_dup.j: Likewise.
	* tests/regression/jasmin/test_many_dup_x2.j: Likewise.
	* tests/regression/jasmin/test_many_swap.j: Likewise.
	* tests/regression/jasmin/test_many_dup2.j: Likewise.
	* tests/regression/jasmin/test_many_dup2_x1.j: Likewise.
	* tests/regression/jasmin/test_many_dup_x1.j: Likewise.
	
	* tests/regression/jasmin/Makefile.am: Added new tests.

2006-10-28 15:21  edwin

	* src/vm/jit/stack.c (stackdata_t): Added field varsallocated.
	(stack_grow_variable_array): Smarted memory allocation.
	(stack_analyse): Initialize sd.varsallocated.

2006-10-28 13:02  edwin

	* src/vm/access.c (ACCESS_ASSERT): Replaced with assert. Because of
	a mistake in the definition of ACCESS_DEBUG, ACCESS_ASSERT always
	was a NOP!
	(access_is_accessible_member): Fixed assertion.

2006-10-28 12:53  edwin

	* src/vm/loader.c (LOADER_ASSERT): Replaced with assert.

2006-10-28 12:49  edwin

	* src/vm/class.c (CLASS_ASSERT): Replaced by assert.

2006-10-28 12:47  edwin

	* src/vm/class.c (class_array_of): Release dump memory.
	(class_multiarray_of): Likewise.
	(class_get_classref_multiarray_of): Likewise.

2006-10-27 10:41  twisti

	* src/vm/vm.c: Renamed -Xglibj to -Xbootclasspath/c to match jamvm's
	option (Robert, Mark and I decided that once).
	(vm_create): Removed unnecessary k. #ifdef'd the profiling stuff.
	(vm_run): Removed commented code.
	* src/vm/options.c, src/vm/options.h [ENABLE_PROFILING] (opt_prof)
	(opt_prof_bb): Added.
	* src/vm/jit/jit.c (jit_compile) [ENABLE_PROFILING]: Added for
	opt_prof stuff.
	[ENABLE_VERIFIER]: Added for flag setting.
	* src/vm/jit/codegen-common.c (codegen_createnativestub)
	[ENABLE_PROFILING]: Added for opt_prof stuff.

2006-10-26 16:41  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Declare variables at the start
	of codegen (uf, fi).

2006-10-26 12:05  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Made fieldinfo and
	unresolved_field fucntion variables, fieldtype was uninitialized for
	PUTFIELD.

2006-10-26 11:57  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Made fieldinfo and
	unresolved_field function variables (it makes the code more readable).

2006-10-26 11:47  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Fixed ICMD_PUTFIELD: Set
	fieldtype before it is used. Fixed warnings.
	
	* src/vm/jit/mips/codegen.c (codegen): Prevent warnings.

2006-10-26 11:35  twisti

	* NEWS: Added some 0.97 news.

2006-10-26 11:30  twisti

	* src/vm/exceptions.c (exceptions_print_exception): Removed [!NDEBUG]
	condition, as we may need this function in the VM (e.g. recompile).
	* src/vm/jit/recompile.c (vm/exceptions.h): Added.
	(recompile_thread): Call exceptions_print_exception in exception case.

2006-10-26 11:29  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Initialize uf to NULL for
	resolved fields, to avoid warnings.
	
	* src/vm/jit/intrp/engine.c (engine): Initialize
	classcastexception_object and arrayindexoutofbounds_index to avoid
	warnings.

2006-10-26 11:23  edwin

	* src/vm/jit/dseg.c (dseg_addlinenumber_inline_start): Read inline
	info from instruction, ported to new instruction format.
	(dseg_addlinenumber_inline_end): Likewise.

2006-10-26 11:19  edwin

	* src/vm/jit/show.c (show_icmd): Fixed warning fix.

2006-10-26 11:18  edwin

	* src/threads/native/threads.c (threads_table_dump): Fix warning (the
	function is currently unused, but may become handy again.)

2006-10-26 11:15  edwin

	* src/vm/jit/show.c (show_method): Fixed warning.
	(show_basicblock): Likewise.
	(show_icmd): Likewise.

2006-10-26 11:04  twisti

	* src/vm/jit/x86_64/md.h: Removed.
	* src/vm/jit/x86_64/Makefile.am (libarch_la_SOURCES): Removed md.h.
	* src/vm/jit/x86_64/codegen.c (md.h): Removed.
	(codegen): Warning fix.

2006-10-26 10:34  twisti

	* src/vm/jit/mips/md-abi.h: Fixed MIPS64 compilation and backported
	some MIPS32 stuff.

2006-10-26 10:09  twisti

	* src/vm/descriptor.h (paramdesc): We need a type for MIPS32, as the
	type in the allocated argument register may be different to the actual
	register (e.g. passing a float in an integer register).

2006-10-26 09:55  twisti

	* src/vm/jit/mips/codegen.c (codegen): More comment and brace changes.

2006-10-26 09:44  twisti

	* src/vm/jit/mips/codegen.c (codegen): Comment and brace changes.

2006-10-26 09:29  twisti

	* src/vm/jit/mips/md-asm.h: Renamed t8 to t4 and removed t9, as it's
	actually itmp3.
	* src/vm/jit/mips/asmpart.S: Likewise.

2006-10-25 14:26  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.c (_ALIGN): Renamed to
	CACAO_ALIGN because of name clash with /usr/include/asm-ppc64/page.h.
	
	* src/vm/jit/powerpc64/emit.c (emit_lconst): Added.
	(emit_iconst): Reformatted.
	
	* src/vm/jit/powerpc64/codegen.c (codegen):
	Replaced all stackframesize with cd->stackframesize.
	Implemented ICMD_IF_LLT, ICMD_IF_LLE, ICMD_IF_LGE, ICMD_IF_LGT.
	
	* src/vm/jit/powerpc64/asmpart.S:
	Partially fixed exception path.
	(asm_cacheflush): Fixed.
	
	* src/vm/jit/powerpc64/codegen.h (LCONST): Implemented.
	
	* tests/if_tests.java: Added simple testcase for if and compare.

2006-10-24 23:24  edwin

	* src/vm/utf8.h, src/vm/utf8.c (utf8_safe_number_of_u2s): Modified to
	completely emulate the behaviour of the RI in case of truncated UTF-8
	characters. This requires an extra strlen(text) beforehand. We still
	require zero-termination. We could drop that with a few extra changes,
	should we find other uses for these functions.
	(utf8_safe_convert_to_u2s): Likewise.
	
	* src/vm/string.c (javastring_safe_new_from_utf8): Pass number of
	bytes to the decoding functions.

2006-10-24 17:51  edwin

	* src/vm/utf8.c (utf8_safe_number_of_u2s): Skip only bytes beginning
	with high bits 10 in invalid sequences.
	(utf8_safe_convert_to_u2s): Likewise.

2006-10-24 16:41  edwin

	* src/vm/utf8.h, src/vm/utf8.c (utf8_safe_number_of_u2s): New
	function.
	(utf8_safe_convert_to_u2s): Likewise.
	
	* src/vm/stringlocal.h, src/vm/string.c
	(javastring_safe_new_from_utf8): New function.
	
	* src/native/jni.c (_Jv_JNI_NewStringUTF): Use the new functions for
	safe UTF-8 decoding.

2006-10-24 11:17  twisti

	* src/vm/jit/dseg.c (dseg_display): Rewritten.

2006-10-22 04:28  ajordan

	* src/vm/jit/sparc64/codegen.h: fixed M_SAVE.
	
	* src/vm/jit/sparc64/disass.c: configuring disass for big-endian.

2006-10-22 02:49  ajordan

	* src/vm/jit/sparc64/emit.c: Implemented trace enter/exit functions.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	
	* src/vm/jit/sparc64/md.c: Implemented md_get_method_patch_address.
	
	* src/vm/jit/sparc64/asmpart.S(asm_call_jit_compiler): Fixed window
	handling
	
	* src/vm/jit/sparc64/disass.c: Fixed disassembly printing.
	
	* src/vm/jit/sparc64/md-abi.h: Minor changes/fixes.
	* src/vm/jit/sparc64/codegen.h: Likewise.
	* src/vm/jit/sparc64/md-asm.h: Likewise.

2006-10-22 00:38  edwin

	* src/vm/jit/jit.c (jit_asm_compile): Fixed xpc for extern
	stackframeinfo by subtracting 1 from the return address.
	This fixes stacktraces when exceptions are thrown out of
	the compiler.
	
	* tests/regression/extest.2output: Changed line numbers to
	the values same the RI returns, which are correct upon inspection
	of the Java code.

2006-10-21 15:06  edwin

	* src/vm/jit/parse.c (parse): Bugfix for -noverify: Do not make the
	variable array dependant on jd->flags, as this breaks stack_analyse.

2006-10-20 18:35  twisti

	* src/vm/jit/mips/codegen.c (md.h): Removed.
	* src/vm/jit/mips/md.h: Removed.
	* src/vm/jit/mips/Makefile.am (libarch_la_SOURCES): Removed md.h.

2006-10-20 14:53  twisti

	* src/vm/jit/jit.c (jit_init) [ENABLE_JIT]: Call stack_init only for
	JIT.
	[ENABLE_JIT] (jit_asm_compile): Only for JIT.
	
	* src/vm/jit/Makefile.am (SUBDIRS) [ENABLE_JIT]: Add allocator only
	for JIT.
	(libjit_la_SOURCES) [ENABLE_JIT]: Compile reg.[ch], replace.[ch] and
	stack.[ch] only for JIT.
	
	* src/cacaoh/headers.c [ENABLE_INTRP] (intrp_asm_abstractmethoderror):
	Added.

2006-10-20 14:26  twisti

	* src/vm/linker.c (link_class_intern): Handle AbstractMethodError for
	interpreter (missed this one in the last commit).

2006-10-20 14:22  twisti

	* src/vm/jit/intrp/asmpart.c (intrp_asm_abstractmethoderror): Added.
	* src/vm/jit/asmpart.h [ENABLE_INTRP] (intrp_asm_abstractmethoderror):
	Likewise.
	* src/vm/linker.c (linker_addinterface): Handle AbstractMethodError
	for interpreter.

2006-10-20 13:58  twisti

	* src/native/vm/gnu_classpath_VMSystemProperties.c (preInit): Removed
	unused ld_library_path.

2006-10-20 13:54  twisti

	* src/vm/suck.c (vm/vm.h): Added.
	(bootclasspath, classpath): Removed.
	(suck_add_from_property): Prefix bootclasspath with _Jv_.
	* src/vm/suck.h (bootclasspath, classpath): Removed.
	
	* src/vm/vm.c (_Jv_bootclasspath, _Jv_classpath)
	(_Jv_java_library_path): Added.
	(version): Prefix bootclasspath with _Jv_.
	(vm_create): Likewise, set _Jv_java_library_path to LD_LIBRARY_PATH
	before handling commandline options.
	* src/vm/vm.h (_Jv_bootclasspath, _Jv_classpath)
	(_Jv_java_library_path): Added.
	
	* src/native/vm/gnu_classpath_VMSystemProperties.c (preInit): Prefix
	bootclasspath and classpath with _Jv_, use _Jv_java_library_path for
	setting java.library.path.
	
	* src/cacao/cacao.c (main): First let dlopen try to open libjvm at
	it's default locations.
	* src/native/native.c (native_init): Likewise.
	
	* src/cacaoh/headers.c (_Jv_bootclasspath): Added.
	
	* contrib/setenvinstalled.in: Set LD_LIBRARY_PATH again.
	* contrib/setenvsource.in: Likewise.
	
	* tests/regression/native/Makefile.am (JAVAFLAGS): Removed
	-Djava.library.path=.
	(check): Set LD_LIBRARY_PATH.
	* tests/regression/codepatching/Makefile.am (check): Likewise.
	* tests/regression/Makefile.am: Likewise.

2006-10-20 13:09  twisti

	* src/vm/signal.c (signal_init): Added dummy allocation to install
	Boehm's signal handlers.
	* src/threads/native/threads.c (threads_preinit): Removed dummy
	allocation.
	
	* src/vm/vm.c (vm_create): Call threads_preinit before gc_init.
	* src/cacaoh/cacaoh.c (main): Likewise.

2006-10-20 12:00  twisti

	* src/vm/exceptions.c [ENABLE_JIT] (exceptions_handle_exception): Only
	required for JIT.

2006-10-20 00:37  ajordan

	* src/mm/memory.c: fixed typo in _no_threads_dumpinfo definition

2006-10-19 10:10  twisti

	* src/threads/native/threads.c (threads_interrupt_thread): Renamed to
	threads_thread_interrupt, send thread a SIGHUP singal to interrupt
	blocking system calls (thanks to Robert Schuster).
	(threads_dump): Removed threads_sleep call.
	
	* src/threads/native/threads.h (threads_interrupt_thread): Renamed to
	threads_thread_interrupt.
	* src/native/vm/java_lang_VMThread.c (interrupt): Likewise.
	* src/native/jvmti/jvmti.c (InterruptThread): Likewise.
	
	* src/vm/signal.c (signal_init): Register SIGHUP.
	(signal_handler_sighup): Added.

2006-10-19 09:32  twisti

	* src/vm/jit/stacktrace.c (stacktrace_dump_trace): Changed signature.
	* src/vm/jit/stacktrace.h: Likewise.
	
	* src/vm/jit/codegen-common.c (codegen_get_pv_from_pc): Pass
	threadobject to stacktrace_dump_trace.
	
	* src/vm/signal.c (signal_init): Don't register SIGUSR1.
	(signal_handler_sigusr1): Removed.
	
	* src/native/jni.h: Include GNU Classpath JNI header before we define
	our header.
	(localref_table): Forward typedef.
	
	* src/threads/native/threads.c (threads_dump): Pass threadobject to
	stacktrace_dump_trace.
	
	* src/cacaoh/headers.c (stacktrace_dump_trace): Added.

2006-10-19 09:27  twisti

	* src/threads/native/threads.h (threadobject, threads_table_entry_t)
	(threads_table_t): Forward typedef.
	(threadobject): Changed dumpinfo to dumpinfo_t.

2006-10-19 09:25  twisti

	* src/mm/memory.h (dumpblock): Postfixed with _t and moved before
	internal includes, as we have some problems with threadobject.
	(dumpinfo): Likewise.
	* src/mm/memory.c: Postfixed dumpblock and dumpinfo with _t.

2006-10-19 09:23  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Warning fixes.

2006-10-18 16:55  edwin

	* src/vm/jit/codegen-common.c (codegen_createnativestub): Initialize
	jd->flags to zero.

2006-10-18 16:27  edwin

	* tests/regression/jasmin/runtest: Removed debugging `tee TEST`.
	* tests/regression/jasmin/Makefile.am (CLEANFILES): Added file
	TESTSIA.

2006-10-18 16:19  edwin

	* tests/regression/jasmin/Makefile.am (SOURCE_FILES): Use EXTRA_DIST,
	instead.

2006-10-18 15:57  edwin

	* src/vm/jit/i386/linux/Makefile.am (noinst_HEADERS): Added md-asm.h.
	* src/vm/jit/i386/freebsd/Makefile.am (noinst_HEADERS): Likewise.

2006-10-18 15:27  twisti

	* src/vm/jit/Makefile.am (DIST_SUBDIRS): Added powerpc64.

2006-10-18 15:19  twisti

	* src/vm/jit/Makefile.am (DIST_SUBDIRS): Added optimizing.

2006-10-18 15:14  twisti

	* src/vm/jit/sparc64/Makefile.am (libarch_la_SOURCES): Removed md.h.

2006-10-18 15:09  twisti

	* src/vm/jit/i386/Makefile.am (libarch_la_SOURCES): Renamed md-emit.h
	to emit.h.

2006-10-18 15:04  twisti

	* configure.ac (AC_INIT): Changed to version 0.97rc.
	(CFLAGS): Changed to -O2.

2006-10-18 14:53  edwin

	* tests/regression/jasmin/Makefile.am: Temporarily disable failing
	tests for the release.
	* src/vm/jit/stack.c (stack_analyse): Check field type when creating
	a PUTFIELDCONST/PUTSTATICCONST instruction.

2006-10-16 09:59  edwin

	* src/vm/jit/parse.c (parse_resolve_exception_table): Do not use
	codegendata.
	(parse): Likewise.
	
	* src/vm/jit/stack.c (stack_analyse): Likewise.

2006-10-16 09:02  twisti

	* src/vm/jit/allocator/simplereg.c [ENABLE_STATISTICS]
	(simplereg_make_statistics): Don't print this INREGISTER stuff.

2006-10-16 08:53  twisti

	* src/vm/jit/jit.c (jit_compile_intern) [ENABLE_STATISTICS]:
	exceptiontablelength is now in jitdata.

2006-10-16 00:05  ajordan

	* src/vm/jit/sparc64/codegen.c: Ported to unified variables.
	* src/vm/jit/sparc64/emit.c: Likewise.
	
	* src/vm/jit/sparc64/md.c: Implemented md_codegen_get_pv_from_pc.
	
	* src/vm/jit/sparc64/codegen.h: Some fixes.
	* src/vm/jit/sparc64/asmpart.S: Likewise.

2006-10-15 22:44  edwin

	* src/vm/linker.c (link_class_intern): Removed unused variable.

2006-10-15 22:25  edwin

	* src/vm/jit/jit.h (exception_entry): New struct.
	(jitdata): Added exceptiontable fields. Cleaned up.
	
	* src/vm/exceptions.h (exceptionentry): Removed.
	
	* src/vm/jit/dseg.h (dseg_exception_entry): New struct.
	
	* src/vm/jit/stack.h (BLOCK_OF): Moved to parse.h.
	* src/vm/jit/parse.h (BLOCK_OF): Added.
	
	* src/vm/jit/codegen-common.h (codegendata): Removed exceptiontable
	and exceptiontablelength.
	
	* src/vm/loader.c (load_method): Renamed m->exceptiontable* to
	m->rawexceptiontable*.
	(load_class_from_classbuffer): Likewise.
	* src/vm/method.c (method_free): Likewise.
	
	* src/vm/method.h (methodinfo): Renamed m->exceptiontable* to
	m->rawexceptiontable*.
	(exceptiontable): Renamed to raw_exception_entry. Removed fields that
	are only used in jd->exceptiontable.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Moved exceptiontable to jd,
	renamed struct exceptiontable to exception_entry.
	* src/vm/jit/sparc64/codegen.c (codegen): Likewise.
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/stack.c (stackdata_t): Likewise.
	(stack_analyse): Likewise.
	(stack_reanalyse_block): Likewise.
	* src/vm/jit/optimizing/graph.c (graph_add_exceptions): Likewise.
	* src/vm/jit/show.c (show_method): Likewise.
	* src/vm/jit/verify/typecheck-common.h (verifier_state): Likewise.
	* src/vm/jit/verify/typecheck.c (verify_basic_block): Likewise.
	* src/vm/jit/verify/typecheck-stackbased.c (typecheck_stackbased):
	Likewise.
	* src/vm/jit/mips/codegen.c (codegen):
	* src/vm/jit/loop/loop.h (LoopContainer): Likewise.
	* src/vm/jit/loop/analyze.c (analyze_nested): Likewise.
	(analyze_or_exceptions): Likewise.
	(update_internal_exceptions): Likewise.
	(create_static_checks): Likewise.
	(optimize_loops): Likewise.
	* src/vm/jit/inline/inline.c (test_inlining): Likewise.
	* src/vm/jit/allocator/lsra.c (lsra_add_exceptions): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.
	* src/vm/jit/intrp/codegen.c (codegen): Likewise.
	* src/vm/jit/schedule/schedule.h (M_SCHEDULE_SET_EXCEPTION_POINT):
	Likewise.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.
	* src/vm/jit/jit.c (jit_compile_intern): Likewise.
	(jit_jitdata_new): Initialize exceptiontable fields.
	
	* src/vm/jit/codegen-common.c (codegen_setup): Removed exceptiontable
	fields.
	
	* src/vm/jit/parse.c (parse_mark_exception_boundaries): New function.
	(parse_resolve_exception_table): New function.
	(fillextable): Removed.
	(parse): Use parse_mark_exception_boundaries and
	parse_resolve_exception_table. Write the basicblockindex for the end
	marker block.
	
	* src/vm/jit/intrp/asmpart.c (exceptionentry): Renamed to
	dseg_exception_entry.
	* src/vm/exceptions.c (exceptions_handle_exception): Likewise.
	
	* src/vm/linker.c (link_class_intern): Do not resolve exception
	classes here. This is now done in parse.c.

2006-10-15 13:52  edwin

	* src/vm/jit/jit.h: Indentation cleanup.

2006-10-15 13:37  edwin

	* src/vm/jit/jit.h (flags_operand_t): Removed `fields` struct. It was
	not safe to use, as defined.

2006-10-15 13:19  edwin

	* src/vm/jit/jit.h (flags_operand_t): Removed unused argcount.
	(ACONST_LOAD): Removed.
	(ACONST_BUILTIN): Removed.

2006-10-15 12:59  edwin

	* src/vm/method.h (methodinfo): Removed c_block_nr.
	* src/vm/jit/jit.h (jitdata): Removed c_block_nr.
	(BASICBLOCK_INIT): Do not set bptr->nr here.
	
	* src/vm/jit/jit.c (jit_compile_intern): Renumber basic blocks after
	transformations.
	(jit_check_basicblock_numbers): Made stricter.
	
	* src/vm/jit/stack.c (stack_append_block): Set basic block numbers
	correctly.
	(stack_clone_block): Do not set bptr->nr here.
	
	* src/vm/jit/verify/typecheck.c (typestate_reach): Use the correct
	check for setting the repeat flag.
	(typecheck): Check basic block numbers.
	
	* src/vm/jit/verify/typecheck-stackbased.c (typecheck_stackbased):
	Check basic block numbers.
	
	* src/vm/jit/loop/analyze.c (copy_handler): Do not use c_block_nr.
	(create_static_checks): Likewise.
	* src/vm/jit/inline/inline.c (create_block): Likewise.
	* src/vm/jit/parse.c (parse): Likewise.

2006-10-15 12:20  edwin

	* src/vm/jit/jit.c (jit_renumber_basicblocks): New function.
	(jit_check_basicblock_numbers): Likewise.
	(jit_init): Removed obsolete variable `i`.
	
	* src/vm/jit/jit.h (jit_renumber_basicblocks): New function.
	(jit_check_basicblock_numbers): Likewise.

2006-10-14 19:12  twisti

	* src/native/jni.c (_Jv_JNI_DetachCurrentThread): Made
	--disable-threads-safe.

2006-10-13 18:29  edwin

	* tests/regression/jasmin/Makefile.am: Added new tests.

2006-10-13 18:25  edwin

	* src/vm/jit/verify/icmds.c: Check basic types of instance for field
	access.
	* src/vm/jit/verify/typecheck-fields.inc: Check basic type of value.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: Regenerated.
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Likewise.
	
	* src/vm/jit/verify/typecheck.c (verify_fieldaccess): Define
	VERIFY_ERROR for the include file.
	
	* src/vm/jit/verify/typecheck-stackbased.c (VERIFY_ERROR): Fixed
	macro.
	
	*
	tests/regression/jasmin/test_verify_fail_putfieldconst_basic_type_instance.j,
	tests/regression/jasmin/test_verify_fail_getfield_basic_type_instance.j,
	tests/regression/jasmin/test_verify_fail_putfield_basic_type_value.j,
	tests/regression/jasmin/test_verify_fail_putstatic_basic_type_value.j,
	tests/regression/jasmin/test_verify_fail_putfieldconst_basic_type_value.j,
	tests/regression/jasmin/test_verify_fail_getfield_basic_type_value.j,
	tests/regression/jasmin/test_verify_fail_putfield_basic_type_instance.j,
	tests/regression/jasmin/test_verify_fail_putfield_basic_type_lookup.j,
	tests/regression/jasmin/test_verify_fail_getfield_basic_type_lookup.j,
	tests/regression/jasmin/test_verify_fail_putstaticconst_basic_type_value.j:
	New tests.
	
	* tests/regression/jasmin/runtest: Look for specified ICMDs in -sia
	output.

2006-10-13 17:06  tbfg

	* src/vm/jit/powerpc64/md.c (md_get_method_patch_address): Fixed
	comments.
	
	* src/vm/jit/powerpc64/codegen.c: Added credits.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_handle_nat_exception): Fixed
	exception handling code. Added credits.

2006-10-13 16:30  edwin

	* src/vm/jit/verify/typecheck-fields.inc: Re-activate stack overflow
	checking.
	
	* src/vm/jit/verify/typecheck-common.h (verifier_state): Added field
	`stackceiling`.
	
	* src/vm/jit/verify/typecheck-stackbased.c (CHECK_STACK_DEPTH):
	Cleaned up.
	(CHECK_STACK_SPACE): Cleaned up.
	(typecheck_stackbased_verify_fieldaccess): Check for stack overflow.
	(typecheck_stackbased): Moved stackceiling into state.

2006-10-13 16:06  edwin

	* src/vm/jit/codegen-common.c (codegen_reg_of_var): Removed `inline`
	declaration. The crappy IRIX compiler does not create a global symbol
	otherwise.

2006-10-13 14:34  edwin

	* src/vm/jit/verify/typecheck.c (verify_basic_block): Use generated
	code.
	
	* src/vm/jit/verify/typecheck-stackbased-gen.inc: New file, GENERATED!
	* src/vm/jit/verify/typecheck-variablesbased-gen.inc: Likewise.
	
	* src/vm/jit/verify/typecheck.h (typecheck_stackbased): Added.
	
	* src/vm/jit/verify/Makefile.am: Added source files for both generated
	verifiers.
	
	* src/vm/jit/jit.c (jit_compile_intern): Call the stack-based verifier
	for the interpreter.
	
	* src/vm/vm.c (vm_create): Re-enable verification fot the interpreter.

2006-10-13 14:22  edwin

	* src/vm/jit/verify/generate.pl: Clearly mark generated code.

2006-10-13 14:00  edwin

	* src/vm/jit/icmdtable.inc: Documented prettily.

2006-10-13 13:11  edwin

	* src/vm/jit/jit.h (op_data): Removed.
	(stackreq): Moved to a more logical place.
	
	* src/vm/jit/jit.c (op_data): Removed.
	(jit_init): Removed code initializing op_data.
	
	* src/vm/jit/optimizing/lifetimes.c (LifeOutAtStatement): Use
	icmd_table.
	* src/vm/jit/optimizing/ssa.c (dead_code_elimination): Likewise.

2006-10-13 12:49  edwin

	* src/vm/jit/jit.h (icmd_table): Added.
	(icmd_names): Removed.
	
	* src/vm/jit/jit.c (icmd_table): Added.
	(icmd_names): Removed.
	
	* src/vm/jit/show.c (show_icmd): Use icmd_table.
	* src/vm/jit/optimizing/ssa.c (dead_code_elimination): Likewise.

2006-10-13 12:47  edwin

	* src/vm/resolve.c: Removed obsolete debug prints.

2006-10-13 11:57  edwin

	* src/vm/jit/jit.h: Added DF_ constants for ICMD table.
	Added CF_ constants.
	Added ICMDTABLE_ constants.
	(icmdtable_entry_t): New struct.

2006-10-13 11:28  edwin

	* src/vm/jit/icmdtable.inc: New file. Not used, yet.
	* src/vm/jit/Makefile.am: Added new file.

2006-10-13 11:27  edwin

	* src/vm/jit/verify/generate.pl: Omit comma at end of ICMD table.

2006-10-13 11:11  edwin

	* src/vm/jit/verify/typecheck-stackbased.c: New file. Not used, yet.
	* src/vm/jit/verify/icmds.c: New file.
	* src/vm/jit/verify/generate.pl: New file.
	
	* src/vm/jit/verify/typecheck-invoke.inc: Added copyright notice.
	* src/vm/jit/verify/typecheck-fields.inc: Likewise.
	* src/vm/jit/verify/typecheck-builtins.inc: Likewise.
	* src/vm/jit/verify/typecheck-common.c: Likewise.
	* src/vm/jit/verify/typecheck-common.h: Likewise.

2006-10-13 10:36  edwin

	* src/vm/jit/verify/typeinfo.c (typevector_store): Remove obsolete
	assertion.

2006-10-13 10:33  edwin

	* src/vm/jit/stack.c (stack_analyse): Set iptr->dst for CHECKNULL.

2006-10-13 00:47  edwin

	* src/vm/builtin.c (builtin_isanysubclass): Bugfix for the case that
	`sub` is an interface and `super` is a class. The function returned
	random values in this case, since it used the <= 0 base value of the
	interface class to perform the subclass check. The only case in which
	an interface can be a subclass of a non-interface `super` is when
	`super` is java.lang.Object, so we check explicitly for this case.
	This fixes a bug with BeanShell-2.0b4.
	
	(builtin_isanysubclass_vftbl): Likewise.

2006-10-12 23:34  edwin

	* src/vm/jit/stack.c (stack_check_invars): Bugfix: Only set flags to
	BBTYPECHECK_REACHED if the block has already been analysed.
	
	(stack_check_invars_from_outvars): Likewise.

2006-10-12 20:06  twisti

	* src/vm/jit/cfg.c (cfg_build): Check for EXH basic blocks in
	fall-through case.

2006-10-12 15:59  edwin

	* tests/regression/jasmin/runtest: Added timeout capability.

2006-10-12 15:22  edwin

	* src/vm/jit/verify/typecheck-common.h (typecheck_print_statistics):
	Added prototype.
	(typecheck_jsr_t): New struct.
	(typecheck_jsr_caller_t): Likewise.
	(verifier_state): Added fields for stackbased verifier.

2006-10-12 15:07  edwin

	* src/vm/jit/verify/typecheck-common.c: Made debugging and statistics
	symbols global.
	* src/vm/jit/verify/typecheck-common.h: Likewise.

2006-10-12 14:52  edwin

	* src/vm/jit/verify/typecheck-invoke.inc: Added code variants for the
	stackbased verifier. Not used, yet.
	* src/vm/jit/verify/typecheck-builtins.inc: Likewise.

2006-10-12 14:42  edwin

	* src/vm/jit/verify/typecheck-common.c: Include headers.
	* src/vm/jit/verify/typecheck-common.h: Cleanup.

2006-10-12 14:39  edwin

	* src/vm/jit/verify/typecheck.c (ISBUILTIN): Removed.
	* src/vm/jit/verify/typecheck-builtins.inc (ISBUILTIN): Added.

2006-10-12 14:38  tbfg

	* src/vm/jit/powerpc64/codegen.c (codegen): Adopt locals
	and regoff changes.

2006-10-12 14:18  edwin

	* src/vm/jit/verify/typecheck.c (verify_invocation): Prepared for
	addeding the stackbased verifier. No functional change, yet.
	(verify_builtin): Likewise.

2006-10-12 14:12  edwin

	* src/vm/jit/verify/typecheck-common.c,
	src/vm/jit/verify/typecheck-common.h (typecheck_init_flags): Added
	minflags argument.
	
	* src/vm/jit/verify/typecheck.c (typecheck): Call typecheck_init_flags
	with minflags set to BBFINISHED.

2006-10-12 14:02  edwin

	* src/vm/jit/verify/typecheck.c (verify_fieldaccess): New function.
	(verify_basic_block): Moved field verification into a separate
	function.
	
	* src/vm/jit/verify/typecheck-fields.inc: Removed opcode-dependant
	stuff. Some code for the stackbased verifier is checked in, but not
	used, yet.

2006-10-12 13:13  twisti

	* src/vm/jit/mips/linux/md-os.c (thread_restartcriticalsection): Added
	uClibc support.

2006-10-12 12:44  twisti

	* src/vm/jit/mips/linux/md-os.c (md_signal_handler_sigsegv): Added
	uClibc support.

2006-10-12 10:10  edwin

	* src/vm/jit/verify/typecheck.c: Moved <assert.h> include to the right
	place. Moved some code to typecheck-common.[ch].
	
	* src/vm/jit/verify/typecheck-common.c: New file.
	* src/vm/jit/verify/typecheck-common.h: New file.
	
	* src/vm/jit/verify/Makefile.am: Added new source files.

2006-10-11 23:52  edwin

	* src/vm/jit/verify/typecheck-builtins.inc: Removed redundant
	`return true`. Moved declaration of `av`.

2006-10-11 23:44  edwin

	* src/vm/jit/verify/typecheck-invoke.inc: Use invokestatic where
	possible. Added a comment.

2006-10-11 23:41  edwin

	* src/vm/jit/verify/typecheck-invoke.inc: Indent log messages to make
	them more readable.

2006-10-11 23:37  edwin

	* src/vm/jit/verify/typecheck.c (verify_invocation): Define jd and dv
	before including the function body.
	
	* src/vm/jit/verify/typecheck-invoke.inc: Removed definitions of jd
	and dv. Small cleanup.

2006-10-11 23:22  edwin

	* src/vm/jit/verify/typecheck.c (verify_builtin): Define jd and dv
	before including the function body.
	
	* src/vm/jit/verify/typecheck-builtins.inc: Removed definitions
	of jd and dv.

2006-10-11 23:00  edwin

	* src/vm/jit/verify/typecheck.c (verify_invocation): Moved body to a
	separate file in order to prepare comitting the stackbased verifier.
	(verify_builtin): Likewise.
	(verify_generic_builtin): Likewise, no integrated in verify_builtin.
	(verify_basic_block): Moved field instruction verification to a
	separate file.
	
	* src/vm/jit/verify/typecheck-invoke.inc: New file.
	* src/vm/jit/verify/typecheck-fields.inc: New file.
	* src/vm/jit/verify/typecheck-builtins.inc: New file.
	
	* src/vm/jit/verify/Makefile.am: Added new source files.

2006-10-11 19:43  edwin

	* src/cacaoh/headers.c (typeinfo_print_short): Stub added.

2006-10-11 19:42  edwin

	* src/vm/jit/verify/typeinfo.c (typeinfo_init_component): Fixed for
	the case that srcarray == dst. (The mergedlist was overwritten with
	NULL in this case.)

2006-10-11 19:40  edwin

	* src/vm/resolve.c, src/vm/resolve.h
	(resolve_method_param_type_checks_stackbased): New function.
	(resolve_constrain_unresolved_method_params_stackbased): Likewise.

2006-10-11 16:31  edwin

	*
	tests/regression/jasmin/test_verify_fail_athrow_wrong_reftype_unresolved.j:
	New test.
	
	* tests/regression/jasmin/test_verify_fail_athrow_wrong_reftype.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added new tests.

2006-10-11 16:21  edwin

	* tests/regression/jasmin/test_verify_fail_areturn_wrong_reftype.j:
	New test.
	
	* tests/regression/jasmin/test_verify_fail_invoke_return_basic_type.j:
	New test.
	
	* tests/regression/jasmin/test_verify_fail_ireturn_wrong_type.j: New
	test.
	
	* tests/regression/jasmin/Makefile.am: Added new tests.

2006-10-11 10:17  edwin

	* tests/regression/jasmin/test_verify_fail_handler_bad_local.j: new
	test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-10 21:16  edwin

	* tests/regression/jasmin/test_verify_fail_jsr_recursion_terminates.j:
	Added expected error.
	
	* tests/regression/jasmin/test_verify_fail_jsr_recursion.j: Likewise.
	
	* tests/regression/jasmin/test_verify_ok_jsr_improper_nesting.j: New
	test.
	
	* tests/regression/jasmin/test_verify_fail_jsr_multiple_returns.j: New
	test.
	
	* tests/regression/jasmin/Makefile.am: Added new tests.

2006-10-10 20:45  edwin

	*
	tests/regression/jasmin/test_verify_fail_jsr_recursion_terminates.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-10 20:31  edwin

	* tests/regression/jasmin/test_verify_fail_jsr_recursion.j: New test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-10 00:29  edwin

	* src/vm/resolve.c, src/vm/resolve.h (constrain_unresolved_method):
	Split into two new functions.
	
	(resolve_constrain_unresolved_method_instance): New function.
	(resolve_constrain_unresolved_method_params): Likewise.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Use new
	functions.

2006-10-09 23:53  edwin

	* src/vm/resolve.c (resolve_method_type_checks): Split up into
	two new functions.
	
	(resolve_method_instance_type_checks): New function.
	
	(resolve_method_param_type_checks): New function.
	
	* src/vm/resolve.h (resolve_method_type_checks): Removed.
	(resolve_method_instance_type_checks): New function.
	(resolve_method_param_type_checks): New function.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Call
	resolve_method_instance_type_checks and
	resolve_method_param_type_checks.

2006-10-09 23:21  edwin

	* src/vm/resolve.c (resolve_method_verifier_checks): Removed unused
	variable. Removed unclear assertion.

2006-10-09 23:17  edwin

	* src/vm/resolve.c (resolve_method_verifier_checks): Removed unused
	arguments.
	
	(resolve_method): Changed arguments to resolve_method_verifier_checks.
	
	* src/vm/resolve.h (resolve_method_verifier_checks): Removed unused
	arguments.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Changed
	arguments to resolve_method_verifier_checks.

2006-10-09 23:06  edwin

	* src/vm/resolve.c (resolve_method_verifier_checks): Factored out
	parameter type checks into a separate function.
	
	(resolve_method_type_checks): New function.
	
	* src/vm/resolve.h (resolve_method_type_checks): New function.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Call
	resolve_method_type_checks.

2006-10-09 22:19  edwin

	* src/vm/resolve.c (resolve_method_verifier_checks): Factored out
	loading constraints into a separate function.
	
	(resolve_method_loading_constraints): New function.
	
	(resolve_method): Call resolve_method_loading_constraints.
	
	* src/vm/resolve.h (resolve_method_loading_constraints): New function.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Call
	resolve_method_loading_constraints.

2006-10-09 17:08  edwin

	* src/vm/resolve.c (resolve_method_lazy): Removed dependence on
	instruction format. Do not perform verifier checks. (Caller will
	do these.)
	
	(create_unresolved_method): Renamed to
	resolve_create_unresolved_method. Changed arguments.
	
	* src/vm/resolve.h (create_unresolved_method): Renamed to
	resolve_create_unresolved_method. Changed arguments.
	
	(resolve_method_lazy): Changed arguments.
	
	(resolve_method_verifier_checks): Export.
	
	* src/vm/jit/verify/typecheck.c (verify_invocation): Adapted
	to changed resolve functions. Call resolve_method_verifier_checks.
	Do promotion from INVOKEVIRTUAL to INVOKESPECIAL here.
	
	* src/vm/jit/parse.c (parse): Adapted to changed resolve functions.
	Do promotion from INVOKEVIRTUAL to INVOKESPECIAL here.

2006-10-09 15:42  edwin

	* src/vm/resolve.c (resolve_field_verifier_checks): Removed dependence
	on instruction format.
	
	(resolve_field_lazy): Pass field reference, instead of instruction.
	Do not perform verification checks here. (Caller will do them.)
	
	(resolve_field): Adapted to changed resolve_field_verifier_checks.
	
	(create_unresolved_field): Renamed to resolve_create_unresolved_field.
	
	(constrain_unresolved_field): Renamed to
	resolve_constrain_unresolved_field. Removed dependence on instruction
	format.
	
	* src/vm/resolve.h (create_unresolved_field): Renamed to
	resolve_create_unresolved_field.
	
	(resolve_field_lazy): Changed arguments.
	
	(resolve_field_verifier_checks): Export.
	
	(constrain_unresolved_field): Renamed to
	resolve_constrain_unresolved_field. Changed arguments.
	
	* src/vm/jit/verify/typecheck.c (typecheck): Moved instruction set
	dependent parts of resolve functions into typecheck.
	
	* src/vm/jit/parse.c (resolve_field_lazy): Changed arguments.
	(create_unresolved_field): Renamed.

2006-10-08 22:49  edwin

	*
	test/regression/jasmin/test_verify_ok_jsr_subroutine_loops_to_start.j:
	New test.
	
	* test/regression/jasmin/test.j: Small cleanup.
	
	* test/regression/jasmin/Makefile.am: Added new test.

2006-10-08 11:39  edwin

	* src/vm/jit/stack.c: Verify that subroutines are not merged.
	(SBRSTART): New macro.
	(COPY_VAL_AND_TYPE_VAR): New macro, propagate SBRSTART.
	(COPY_VAL_AND_TYPE): Use COPY_VAL_AND_TYPE_VAR.
	(stack_create_invars): Cleaned up, use COPY_VAL_AND_TYPE_VAR.
	(stack_create_invars_from_outvars): Use COPY_VAL_AND_TYPE_VAR.
	(stack_check_invars): Check against merging of subroutines. Wrapped
	verifier checks in #if defined(ENABLE_VERIFIER).
	(stack_check_invars_from_outvars): Likewise.
	(stack_reanalyse_block): Wrapped verifier checks in
	#if defined(ENABLE_VERIFIER).
	(stack_analyse): Prepare a real variable for the handler stack.
	Implemented re-analysing of blocks. Set SBRSTART for JSR.
	
	* src/vm/jit/parse.c (parse): Reserve extra variables needed by
	stack_analyse.
	
	* src/vm/global.h (STACK_EXTRA_VARS): New macro.

2006-10-08 10:51  edwin

	* src/vm/jit/show.c (show_basicblock): Removed extra newline.

2006-10-08 00:07  edwin

	*
	tests/regression/jasmin/test_verify_fail_jsr_merge_subroutines_via_stack.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-07 23:56  edwin

	* src/vm/jit/cfg.c (cfg_build): Fixed a bug causing infinite loops.
	
	* src/vm/jit/parse.c (parse): Always add a NOP at block ends. This is
	needed by the JSR elimination in stack.c.
	
	* tests/regression/jasmin/test_verify_fail_jsr_merge_subroutines.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-07 23:02  edwin

	* tests/regression/jasmin/test_verify_fail_jsr_polymorphic_pop.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added new test.
	
	* src/vm/jit/stack.c (stack_check_invars): Fixed bug exposed by the
	new test.
	(stack_check_invars_from_outvars): Likewise.

2006-10-07 22:34  edwin

	*
	tests/regression/jasmin/test_verify_fail_jsr_called_with_different_stackdepths.j:
	New test.
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-10-07 12:54  edwin

	* src/vm/jit/stack.c (GET_NEW_VAR): Fixed macro argument.
	
	(SET_TEMPVAR): Call new function stack_change_to_tempvar.
	
	(stack_change_to_tempvar): New function.
	
	(stack_analyse): Mark pass-through stackslots of INVOKEs instead of
	resetting them to TEMPVARs.
	
	* src/vm/jit/jit.h (PASSTHROUGH): New flag.

2006-10-07 10:22  edwin

	* src/vm/jit/allocator/simplereg.c: Implemented REG_INDEX for
	architectures with address register file.

2006-10-07 09:44  edwin

	* src/vm/jit/allocator/simplereg.c
	(simplereg_allocate_locals_leafmethod): Fixed declaration after code.

2006-10-07 00:06  edwin

	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_interface):
	Copy all flags except SAVEDVAR when reusing an interface slot.

2006-10-06 23:58  edwin

	* src/vm/jit/allocator/simplereg.c: Cleaned up memory slot allocation.

2006-10-06 23:41  edwin

	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_interfaces):
	Fixed
	indentation.

2006-10-06 23:03  edwin

	* src/vm/jit/allocator/simplereg.c (simplereg_allocate_temporaries):
	Minor cleanup, use SIMPLEREG_REG_INDEX.

2006-10-06 22:37  edwin

	* src/vm/jit/allocator/simplereg.c: Reuse interface registers in
	blocks
	that don't need them. Abstracted out the free register stacks with
	macros. Major code cleanup.
	
	* src/vm/jit/allocator/simplereg.h (reg_make_statistics): Renamed to
	simplereg_make_statistics.
	
	* src/vm/jit/reg.h (registerdata): Added fields `adrusedinout`,
	`intusedinout`, `fltusedinout`, and `regisoutvar`.
	
	* src/vm/jit/jit.c (simplereg_make_statistics): Renamed to
	simplereg_make_statistics.
	
	* src/vm/jit/jit.h (SAVEDTMP): Renamed to SAVREG.
	(TMPARG): Renamed to ARGREG.
	(STCOPY): Removed.
	(STKEEP): Removed.

2006-10-06 21:30  edwin

	* src/vm/jit/stack.c (stack_analyse): Do not set argintreguse to
	a value > INT_ARG_CNT, as this breaks some new code that will
	later be committed to simplereg.c, and does not make sense, anyway.

2006-10-06 20:11  edwin

	* src/vm/jit/intrp/Makefile.am (Changes): Added my name.

2006-10-06 20:09  edwin

	* src/vm/jit/show.h (show_variable): Made global.
	(show_variable_array): Likewise.
	
	* src/vm/jit/show.c (show_variable): Likewise.
	(show_variable_array): Likewise.

2006-10-05 20:30  edwin

	* src/threads/native/threads.c (threads_attach_current_thread): Rename
	left-over `t` to `thread` in interpreter code.

2006-10-05 20:21  edwin

	* src/vm/jit/codegen-common.c: Include vm/jit/intrp/intrp.h to prevent
	a warning.

2006-10-05 20:18  edwin

	* src/vm/jit/intrp/intrp.h: Added missing prototypes.
	
	* src/vm/jit/intrp/engine.c: Comment unused variable `ca1`.
	
	* src/vm/jit/intrp/java.vmg: Mark the variables `currentsp` as
	MAYBE_UNUSED.

2006-10-05 20:04  edwin

	* src/vm/jit/intrp/intrp.h: Cleaned up. Defined missing prototypes.
	
	* src/vm/jit/intrp/java.vmg: Defined "afi" type prefix.

2006-10-05 19:36  edwin

	* src/vm/jit/intrp/peephole.c: Include interpreter files using < >
	instead of " ", so they are only searched for in the include path.
	This avoids using the wrong include files when compiling in a
	buildir.
	
	* src/vm/jit/intrp/codegen.c: Likewise.
	* src/vm/jit/intrp/engine.c: Likewise.
	* src/vm/jit/intrp/disasm.c: Likewise.
	* src/vm/jit/intrp/dynamic-super.c: Likewise.
	
	* src/vm/jit/intrp/vmgenx: Fixed to work with builddir, and cleaned
	up.
	
	* src/vm/jit/intrp/Makefile.am: Fixed dependencies for builddir.

2006-10-05 17:52  edwin

	* src/vm/jit/intrp/engine.c (Changes): Added my name.
	(vim boilerplate): Added.

2006-10-05 17:28  twisti

	* src/native/jni.c (jni_attach_current_thread): New help function.
	(_Jv_JNI_AttachCurrentThread): Use helper function.
	(_Jv_JNI_AttachCurrentThreadAsDaemon): Likewise.
	(_Jv_JNI_DetachCurrentThread): Implemented.
	
	* src/threads/native/threads.c (method_thread_init)
	(method_threadgroup_add_: Made static.
	(threads_init): Code rearranged.
	(threads_startup_thread): Removed thread detach code and call
	threads_detach_thread.
	(threads_detach_thread): New function.
	
	* src/threads/native/threads.h (threads_detach_thread): Added.

2006-10-05 17:23  twisti

	* src/vm/utf8.c (utf_removeThread, utf_java_lang_Thread__V): Added.
	(utf8_init): Initialize new strings.
	* src/vm/utf8.h (utf_removeThread, utf_java_lang_Thread__V): Added.

2006-10-05 16:28  edwin

	* src/vm/vm.c (vm_create): Turn off the verifier for -Xint.

2006-10-05 16:18  edwin

	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Style fix.

2006-10-05 16:12  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Save synchronized object in
	a special stackslot and use it for monitorexit.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): When
	unwinding a synchronized method, exit the monitor.

2006-10-05 15:43  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Reserve an extra stackslot in
	synchronized methods.
	(intrp_createcompilerstub): Likewise.
	(intrp_createnativestub): Use stackframesize for clarity.

2006-10-05 15:33  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Separate stackframesize from
	the number of local variables.
	(intrp_createcompilerstub): Likewise.
	
	* src/vm/jit/intrp/engine.c (MAXLOCALS): Changed to FRAMESIZE.
	
	* src/vm/jit/intrp/java.vmg (INVOKEVIRTUAL): Use FRAMESIZE.
	(INVOKESTATIC): Likewise.
	(INVOKESPECIAL): Likewise.
	(INVOKEINTERFACE): Likewise.

2006-10-05 14:13  twisti

	* src/native/jni.c (jni_init_localref_table): New function.
	(AttachCurrentThread): Implemented.
	(JNI_CreateJavaVM): Use jni_init_localref_table.
	
	* src/threads/native/threads.c (method_thread_init)
	(method_threadgroup_add): New global variables.
	(threads_init): Store methods resolved in global variables.
	(threads_attach_current_thread): New function.
	
	* src/threads/native/threads.h (MIN_PRIORITY, NORM_PRIORITY)
	(MAX_PRIORITY): Defined.
	(threads_attach_current_thread): New function.

2006-10-05 12:23  edwin

	* src/vm/jit/intrp/java.vmg (TRACECALL): Implemented for 32-bit
	architectures.

2006-10-05 10:50  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Fix off-by-one error in len
	tests of optimizations.

2006-10-05 10:41  edwin

	* src/vm/jit/show.c (show_icmd): Show constant operand of IFxx, and
	IF_Lxx.

2006-10-05 10:39  edwin

	* src/vm/jit/show.c (show_basicblock): Fixed deadcode check.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Clear
	global_sp.

2006-10-05 09:04  twisti

	* src/vm/jit/powerpc/emit.c (emit_verbosecall_enter): Darwin build
	fixes.

2006-10-05 00:21  edwin

	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Fixed for
	catch-all handlers.

2006-10-05 00:06  edwin

	* src/vm/jit/show.c (show_method): Adapted to interpreter.
	(show_basicblock): Likewise.
	
	* src/vm/jit/intrp/disass.c (intrp_disassinstr): Write disassembly to
	stdout.
	(intrp_disassemble): Likewise.

2006-10-04 23:08  edwin

	* tests/regression/jctest.java: Also test division/remainder with
	constant divisor 1.
	
	* tests/regression/jctest.output: Updated test output.

2006-10-04 23:05  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Don't ?DIVPOW2 with value 1.
	The optimization produces the wrong result in this case.

2006-10-04 22:53  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Implemented IDIVPOW2 and
	LDIVPOW2 optimizations.

2006-10-04 22:39  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Implemented IREMPOW2 and
	LREMPOW2 optimizations.

2006-10-04 22:12  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Implement optimization of
	comparisons.

2006-10-04 20:44  edwin

	* src/vm/jit/allocator/simplereg.c (reg_free_temp_func): Fixed indices
	into regcopycount array.
	(allocate_scratch_registers): Likewise.

2006-10-04 20:02  edwin

	* src/vm/jit/intrp/codegen.c (codegen): #if 0-ed optimized ICMDs that
	are currently not used. In order to use these instructions, we could
	either add the optimization checks directly to codegen.c, or introduce
	a special pass between parse and intrp_codegen which replaces the
	instructions.

2006-10-04 19:47  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Removed unoptimized *CONST
	instructions. Since stack_analyse is no longer performed before the
	interpreter codegen, these instructions cannot occur.

2006-10-04 19:38  edwin

	* src/vm/jit/stack.c: Removed interpreter-specific code.

2006-10-04 18:44  edwin

	* src/threads/native/lock.c (lock_monitor_exit): Check for NULL
	object.
	There is no guarantee that MONITORENTER/EXITs are properly nested, so
	we cannot rely on the check in lock_monitor_enter here.

2006-10-04 18:39  edwin

	* tests/regression/jasmin/test_nullpointerexception_monitorexit.j:
	Fixed test case, so it passes if the exception is thrown.

2006-10-04 18:35  edwin

	* tests/regression/jasmin/test_nullpointerexception_monitorexit.j:
	New test.
	
	* tests/regression/jasmin/Makefile.am: Added
	test_nullpointerexception_monitorexit.j.

2006-10-04 18:25  edwin

	* tests/regression/jasmin/Makefile.am: Properly quote variables.

2006-10-04 18:23  edwin

	* src/vm/jit/intrp/engine.c (THROW_CLASSCASTEXCEPTION): Really throw a
	ClassCastException, not a NullPointerException.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Set
	global_sp, in case the resolving of the catchtype involves the
	execution of Java code.
	
	* src/vm/jit/intrp/java.vmg (MONITORENTER): Check for exception.
	(MONITOREXIT): Likewise.

2006-10-04 16:42  edwin

	* src/vm/jit/intrp/java.vmg (LOOKUPSWITCH): No point in using >= 0 on
	an unsigned variable.

2006-10-04 16:01  edwin

	* src/vm/jit/intrp/codegen.c (nativecall): Store return valud of
	codegen_finish_native_call in *exceptionptr.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Resolve
	unresolved catchtype references.

2006-10-04 15:14  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Convert JavaPCs to block
	indices.
	Do not check for BBREACHED (not set by parse).
	(gen_branch): Convert JavaPCs to block indices.
	
	* src/vm/jit/intrp/java.vmg (RET): restored.
	
	* src/vm/jit/jit.c (jit_compile_intern): Do not perform stack_analyse
	and
	dependent passes for intrp.

2006-10-04 15:04  twisti

	* src/vm/jit/intrp/md.c (intrp_md_init): Set vm_out to stderr.
	
	* src/vm/jit/intrp/engine.c (THROW_CLASSCASTEXCEPTION): Added.
	(engine): Handle ClassCastExceptions with argument.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Indent.
	
	* src/vm/jit/intrp/dynamic-super.c: Use LOCK_MONITOR_{ENTER,EXIT}
	macros.
	
	* src/vm/jit/intrp/patcher.c (intrp_patcher_invokestatic_special):
	Write back method pointer. I wonder how this ever worked before.
	(intrp_patcher_invokevirtual): Likewise.
	(intrp_patcher_invokeinterface): Likewise.
	
	* src/vm/jit/intrp/java.vmg (RET): Removed.
	(TABLESWITCH): Changed reading direction of cases. Don't know if that
	works: NOT TESTED!
	(CHECKCAST): Use THROW_CLASSCASTEXCEPTION.
	(ARRAYCHECKCAST): Likewise.
	(MONITORENTER): Likewise.
	(MONITOREXIT): Likewise.

2006-10-04 14:50  edwin

	* src/vm/jit/intrp/dynamic-super.c (superreuse_insert): Use
	lock_monitor_ functions.
	(patchersuper_rewrite): Likewise.
	(hashtable_patchersupers_insert): Likewise.

2006-10-04 14:31  edwin

	* src/vm/jit/intrp/codegen.c (codegen): Restored ICMD_RET to really
	perform a RET (JSR elimination will not be performed for intrp.)
	Removed a comment that does not apply any more.

2006-10-04 14:20  edwin

	* src/vm/jit/intrp/java.vmg (builtin_monitorenter): Changed to
	lock_monitor_enter.
	(builtin_monitorexit): Changed to lock_monitor_exit.

2006-10-04 13:40  edwin

	* src/vm/jit/intrp/codegen.c: Made it compile again.

2006-10-04 13:35  twisti

	* src/vm/jit/intrp/codegen.c: New instruction format fixes.

2006-10-04 12:09  twisti

	* configure.ac (AC_CONFIG_FILES): Removed src/scripts/rmic and
	src/scripts/rmiregistry.
	* src/scripts/Makefile.am (bin_SCRIPTS): Removed trailing \.

2006-10-04 10:37  twisti

	* src/scripts/rmic.in: Removed.
	* src/scripts/rmiregistry.in: Likewise.
	
	* src/scripts/Makefile.am (bin_SCRIPTS) Removed rmi.in and
	rmiregistry.in.
	* src/scripts/.cvsignore: Likewise.
	
	* src/scripts/java.in: Don't call cacao with an absolute path, this
	would break WITH_JRE_LAYOUT. I think we can expect cacao to be in the
	PATH.

2006-10-04 10:10  twisti

	* configure.ac (--with-jre-layout): Added.
	
	* src/vm/global.h (CLASSPATH_LIBRARY_PATH): Removed.
	
	* src/vm/vm.c [WITH_JRE_LAYOUT] (libgen.h, unistd.h): Added.
	(cacao_prefix, cacao_libjvm, classpath_libdir): New global variables.
	(version): Print gnu.classpath.boot.library.path instead of
	java.library.path as this is the interesting one.
	(vm_create): Added WITH_JRE_LAYOUT stuff.
	
	* src/vm/vm.h (stackbottom): Removed.
	(cacao_prefix, cacao_libjvm, classpath_libdir): Added.
	
	* src/cacao/cacao.c [WITH_JRE_LAYOUT] (errno.h, libgen.h, unistd.h):
	Added.
	(main): Added WITH_JRE_LAYOUT stuff.
	
	* src/native/vm/gnu_classpath_VMSystemProperties.c (vm/vm.h): Added.
	(preInit): Set env_java_home to cacao_prefix and
	gnu.classpath.boot.library.path to classpath_libdir.
	
	* src/native/native.c (native_init): Use cacao_libjvm in lt_dlopenext
	call.

2006-10-03 21:19  edwin

	* src/vm/jit/jit.h (jitdata): Renamed c_debug_nr to c_block_nr. (Still
	not a good name. Should probably be removed entirely.)
	Added comments.
	
	* src/vm/method.h (c_debug_nr): Renamed to c_block_nr.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/loop/analyze.c: Likewise.
	* src/vm/jit/inline/inline.c: Likewise.
	* src/vm/jit/parse.c: Likewise.

2006-10-03 20:57  edwin

	* src/vm/jit/powerpc/codegen.c: Removed new_ prefix from variable and
	field names.
	
	* src/vm/jit/cfg.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/reorder.c: Likewise.
	* src/vm/jit/ifconv/ifconv.c: Likewise.
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/stack.h: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/replace.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/parse.h: Likewise.
	* src/vm/jit/jit.c: Likewise.
	* src/vm/jit/jit.h: Likewise.

2006-10-03 20:44  edwin

	* src/vm/resolve.c: Removed new_ prefix from function names.
	* src/vm/resolve.h: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/stack.h: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/show.h: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/allocator/simplereg.h: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/parse.h: Likewise.
	* src/vm/jit/jit.c: Likewise.

2006-10-03 20:27  edwin

	* src/vm/jit/allocator/simplereg.c: Warning fixed.

2006-10-03 20:26  edwin

	* src/vm/jit/i386/codegen.c (codegen): Use varindex as in other
	codegens.

2006-10-03 20:22  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Removed obsolete stack depth
	checking code.
	
	* src/vm/jit/stack.h (CHECK_STACK_DEPTH): Removed macro.

2006-10-03 19:11  edwin

	* src/vm/jit/powerpc64/codegen.c (codegen): Unified IINC and
	IADDCONST.

2006-10-03 18:50  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Unify IINC and IADDCONST.

2006-10-03 18:34  edwin

	* src/vm/jit/allocator/simplereg.c (reg_make_statistics): Bugfix.

2006-10-03 18:21  twisti

	* src/native/vm/gnu_classpath_VMSystemProperties.c (preInit): We don't
	need to strcpy the library variables. Don't know where this code came
	from.

2006-10-03 18:09  edwin

	* src/vm/jit/allocator/simplereg.c (reg_make_statistics): Make it
	compile again.

2006-10-03 17:44  edwin

	Moved unified_variables branch to trunk.

2006-10-03 17:24  edwin

	* tests/regression/jasmin/test_iinc.j: New test.
	
	* tests/regression/jasmin/Makefile.am: Added test_iinc.j

2006-10-03 16:42  edwin

	Merged r5640 from trunk:
	
	* src/vm/jit/x86_64/Makefile.am (libarch_la_SOURCES): Renamed
	md-emit.h to emit.h.

2006-10-03 16:32  edwin

	* src/vm/jit/powerpc/codegen.c: Implemented ICMD_JSR like ICMD_GOTO.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	
	* src/vm/jit/alpha/codegen.c: Implemented ICMD_JSR like ICMD_GOTO.
	Unified ICMD_IINC and ICMD_IADDCONST.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.

2006-10-02 19:24  edwin

	Merged r5636, r5637, and r5638 from trunk:
	
	* src/native/tools/gennativetable.c: Made it work again.
	
	* tests/regression/jasmin/.cvsignore: New file.
	
	* src/vm/jit/powerpc/codegen.c (codegen): #if 0 replacement point
	code.
	
	* src/vm/jit/powerpc/emit.c [!NDEBUG] (emit_verbosecall_enter)
	(emit_verbosecall_exit): #ifdef'ed.

2006-10-02 16:36  christian

	* src/vm/jit/alpha/md-abi.c (md_return_alloc): Activated return value
	stackslot registers precolouring again.

2006-10-02 14:18  edwin

	* src/vm/jit/powerpc/netbsd/md-abi.c: Blindly ported to
	unified_variables.
	
	* src/vm/jit/powerpc/linux/md-abi.c: Cleaned up.
	* src/vm/jit/powerpc/darwin/md-abi.c: Likewise.
	* src/vm/jit/alpha/md-abi.c: Likewise.
	* src/vm/jit/mips/md-abi.c: Likewise.
	* src/vm/jit/powerpc64/linux/md-abi.c: Likewise.
	* src/vm/jit/x86_64/md-abi.c: Likewise.

2006-10-02 13:59  edwin

	* src/vm/jit/powerpc/codegen.c: Changed OUTVAR to INOUT.
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/jit.h: Likewise.

2006-10-02 13:43  edwin

	* src/vm/jit/alpha/codegen.h: Removed M_COPY.
	* src/vm/jit/mips/codegen.h: Likewise.
	* src/vm/jit/i386/codegen.h: Likewise.
	* src/vm/jit/powerpc64/codegen.h: Likewise.
	* src/vm/jit/x86_64/codegen.h: Likewise.
	
	* src/vm/jit/powerpc/codegen.c: Unified ICMD_RET with ICMD_GOTO.
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/intrp/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.

2006-10-02 13:26  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Unified LOAD/STORE and
	COPY/MOVE instructions.
	
	* src/vm/jit/powerpc/codegen.h (M_COPY): Removed.

2006-10-02 13:16  edwin

	* src/vm/jit/powerpc/linux/md-abi.c (md_param_alloc): Cleaned up
	comments.
	* src/vm/jit/powerpc/darwin/md-abi.c (md_param_alloc): Likewise.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Removed obsolete call to
	codegen_reg_of_var.
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/mips/codegen.c (codegen): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.
	
	* src/vm/jit/codegen-common.c (codegen_reg_of_var): Cleaned up.
	(codegen_reg_of_dst): Implemented using inline codegen_reg_of_var.

2006-10-02 12:10  edwin

	Merged r5626 from trunk:
	
	* src/vm/jit/replace.c (replace_create_replacement_points): Return
	true.

2006-10-02 11:55  edwin

	Merged r5624 from trunk:
	
	* src/vm/jit/mips/asmpart.S (asm_vm_call_method): Remove argument
	stack frame in normal path.

2006-10-02 00:32  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Unified MOVE/COPY with
	LOAD/STORE instructions.

2006-10-02 00:08  edwin

	* tests/regression/jasmin/runtest: Made it a bash script, so it works
	on crappy fp98.

2006-10-02 00:06  edwin

	* tests/regression/jasmin/runtest: Do not use grep -o.

2006-10-01 23:51  edwin

	* src/vm/jit/mips/emit.c (emit_copy): Fixed arguments to
	codegen_reg_of_var.
	* src/vm/jit/powerpc64/emit.c (emit_copy): Likewise.
	
	* src/vm/jit/mips/codegen.c (codegen): Define varindex.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise. Fixed arguments
	to codegen_reg_of_var. Replaced codegen_reg_of_var with
	codegen_reg_of_dst.

2006-10-01 23:37  edwin

	* src/vm/jit/powerpc64/codegen.c: Ported to unified_variables.
	* src/vm/jit/powerpc64/codegen.h: Likewise.
	* src/vm/jit/powerpc64/emit.c: Likewise.
	* src/vm/jit/powerpc64/linux/md-abi.c: Likewise.

2006-10-01 23:00  edwin

	Merged r5616 from trunk:
	
	* src/native/jni.c: Prefix all JNI functions with _Jv_JNI_, as gcj
	does. This should prevent any linking problems.

2006-10-01 22:55  edwin

	* src/vm/jit/mips/codegen.c: Ported to unified_variables.
	* src/vm/jit/mips/codegen.h: Likewise.
	* src/vm/jit/mips/emit.c: Likewise.
	* src/vm/jit/mips/md-abi.c: Likewise.

2006-10-01 20:52  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Cleaned up unified_variables
	changes.

2006-10-01 20:49  edwin

	* src/vm/jit/i386/codegen.c (codegen): Cleaned up unified_variables
	changes.

2006-10-01 20:42  edwin

	* src/vm/jit/x86_64/codegen.c (codegen): Cleaned up unified_variables
	changes.

2006-10-01 20:37  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Cleaned up unified_variables
	changes.

2006-10-01 20:08  edwin

	* tests/regression/jasmin/runtest: Use default JASMIN_JAR, if given.

2006-10-01 18:01  edwin

	* src/vm/jit/codegen-common.c (codegen_reg_of_var): Fixed typo in
	ARM code.

2006-10-01 15:44  edwin

	* src/vm/jit/verify/typeinfo.c (typevector_store_retaddr): Do not
	invalidate the variable at index i-1.
	(typevector_store_twoword): Removed.

2006-10-01 15:25  edwin

	* src/vm/jit/verify/typecheck.c (typecheck): Added debug print of
	the reverse local map.

2006-10-01 14:43  edwin

	* src/vm/vm.c (vm_compile_all): Only use if !defined(NDEBUG).
	(vm_compile_method): Likewise.

2006-10-01 14:37  edwin

	* src/vm/jit/verify/typeinfo.h: Disabled TYPECHECK_VERBOSE.

2006-09-30 23:28  edwin

	* src/vm/jit/jit.c (jit_compile_intern): Removed commented out
	debugging code.

2006-09-30 23:12  edwin

	* src/vm/jit/allocator/simplereg.c (reg_new_temp): Simplified.
	(reg_free_temp): Formatted.

2006-09-30 23:06  edwin

	* src/vm/jit/powerpc/linux/md-abi.c: Use VAR and VAROP macros.
	* src/vm/jit/powerpc/darwin/md-abi.c: Likewise.
	* src/vm/jit/alpha/codegen.c: Likewise.
	* src/vm/jit/alpha/codegen.h: Likewise.
	* src/vm/jit/alpha/md-abi.c: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/i386/codegen.h: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/x86_64/emit.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.h: Likewise.
	* src/vm/jit/x86_64/md-abi.c: Likewise.
	* src/vm/jit/codegen-common.c: Likewise.

2006-09-30 22:45  edwin

	* src/vm/jit/i386/codegen.c (codegen): Use VAR and VAROP macros.
	(codegen_insert_phi_moves): Likewise.

2006-09-30 22:24  edwin

	Merged r5591 from trunk:
	
	* src/native/jni.c (GetVersion): Prefixed with _Jv_, we should do that
	with all JNI functions.

2006-09-30 22:22  edwin

	Merged r5589 and r5590 from trunk:
	
	* configure.ac: Fixed CFLAGS for cygwin.
	* src/threads/native/threads.c: Inserted asserts for cygwin.
	* src/vm/jit/i386/cygwin/Makefile.am: See below.
	* src/vm/jit/i386/cygwin/md-asm.h: Added.
	* src/vm/jit/i386/cygwin/md-os.c: Inserted asserts.
	* src/vm/jit/i386/cygwin/ucontext.c: Added 3rd party file.
	* src/vm/jit/i386/cygwin/ucontext.h: Added 3rd party file.
	
	
	* src/cacao/.cvsignore, src/cacaoh/.cvsignore,
	src/vm/jit/tools/.cvsignore: Added ignores for cygwin and
	modified properties accordingly.

2006-09-30 11:04  christian

	* src/vm/jit/alpha/codegen.c (codegen): Changed to use the macros VAR
	and VAROP.

2006-09-30 10:16  christian

	* src/vm/jit/x86_64/codegen.c (codegen): Changed to use the macros
	VAR and VAROP.

2006-09-29 14:02  edwin

	* src/vm/jit/allocator/simplereg.c (reg_free_temp_func): Handle
	packed registers.
	(new_allocate_scratch_registers): Likewise.

2006-09-29 13:33  edwin

	Merged r5540 from trunk:
	
	* configure.ac: Cygwin OS dir added.
	* src\lib\Makefile.am: Now checks for "zip.exe" as well
	* src\vm\jit\i386\Makefile.am: Added Cygwin OS dir.
	* src\vm\jit\i386\cygwin\Makefile.am: Added.
	* src\vm\jit\i386\cygwin\md-os.c: Added. Only contains
	dummy signal handlers.
	* src\vm\builtin.c: Undefine Bias for Cygwin because
	Windows uses this define.
	* src\vm\signal.c: No signal handlers for Cygwin.

2006-09-29 12:46  edwin

	Merged r5573, r5574, r5577, r5578, and r5579 from trunk.
	
	* src/cacao/cacao.c (vm/vm.h): Added.
	* src/cacao/Makefile.am [!ENABLE_LIBJVM] (CACAO_LIB): Link libjvm.la.
	
	
	* src/vm/jit/powerpc/darwin/md-asm.h (md_codegen_get_pv_from_pc):
	Added stub define.
	* src/vm/jit/powerpc/asmpart.S (L_md_codegen_get_pv_from_pc$stub):
	Added.
	
	
	* src/cacaoh/cacaoh.c (cacaoh_options_prepare): Set nOptions, this was
	deleted accidentally.
	
	
	* src/vm/vm.c (vm_create): Added installation of exit handler.
	(vm_run): New function.
	(vm_get_mainclass_from_jar): Likewise.
	(vm_compile_all): Likewise.
	(vm_compile_method): Likewise.
	* src/vm/vm.h (vm_run): New function.
	
	* src/vm/options.c (options_prepare): Removed.
	* src/vm/options.h (options_prepare): Likewise.
	
	* src/cacao/cacao.c (getmainclassnamefromjar): Removed.
	(main): Moved most stuff to vm-functions and load libjvm with dlopen
	and resolve symbols for ENABLE_LIBJVM.
	(cacao_options_prepare): New function.
	
	* src/cacao/Makefile.am (CACAO_LIBS): New variable.
	(cacao_LDADD): Use CACAO_LIBS.
	
	* src/native/native.c (native_init): Set mainhandle to libjvm for
	ENABLE_LIBJVM.
	
	* src/cacaoh/cacaoh.c (cacaoh_prepare_options): New function.
	
	
	* src/native/jni.c (JNI_CreateJavaVM): Renamed jvm to vm.

2006-09-28 22:33  edwin

	* src/vm/jit/powerpc64: Merged changes from r5403 to r5548 from trunk.

2006-09-28 20:56  edwin

	* src/vm/jit/i386/cygwin: Copied directory from trunk.

2006-09-28 20:38  edwin

	Merged r5547 from trunk:
	
	* src/native/jni.c (FindClass): Removed architecture #ifdef's.

2006-09-28 20:33  edwin

	Merged r5543 from trunk:
	
	* src/vm/jit/sparc64/codegen.c: Completed port to new instruction
	format.
	* src/vm/jit/sparc64/md-abi.h: Likewise.
	* src/vm/jit/sparc64/emit.c: Likewise.

2006-09-28 20:31  edwin

	Merged r5541 from trunk:
	
	* src/vm/jit/powerpc/emit.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.
	(emit_load_s1, emit_load_s2, emit_load_s3, emit_load_s1_low)
	(emit_load_s2_low, emit_load_s3_low, emit_load_s1_high)
	(emit_load_s2_high, emit_load_s3_high) (emit_store_dst): Removed.
	
	* src/vm/jit/powerpc/codegen.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.

2006-09-28 20:29  edwin

	Merged r5540 and r5542 from trunk:
	
	* configure.ac: Cygwin OS dir added.
	* src\lib\Makefile.am: Now checks for "zip.exe" as well
	* src\vm\jit\i386\Makefile.am: Added Cygwin OS dir.
	* src\vm\jit\i386\cygwin\Makefile.am: Added.
	* src\vm\jit\i386\cygwin\md-os.c: Added. Only contains
	dummy signal handlers.
	* src\vm\builtin.c: Undefine Bias for Cygwin because
	Windows uses this define.
	* src\vm\signal.c: No signal handlers for Cygwin.
	
	* src/vm/jit/i386/cygwin/.cvsignore: New file.

2006-09-28 20:23  edwin

	Merged r5539 from trunk:
	
	* src/vm/jit/mips/emit.c (emit_exception_stubs): Don't use
	SIZEOF_VOID_P for getting return address, this is wrong on MIPS32.
	* src/vm/jit/mips/codegen.c (createnativestub): Likewise.

2006-09-28 20:20  edwin

	Merged r5538 from trunk:
	
	* src/native/native.c (native_insert_char): New function.
	(native_resolve_function): Use native_insert_char function to fill
	name buffer.

2006-09-28 20:19  edwin

	Merged r5537 from trunk:
	
	* src/vm/jit/mips/codegen.c (codegen): Make fieldinfo,
	unresolved_field local variables, better code for ICMD_PUTFIELD.

2006-09-28 20:18  edwin

	Merged r5536 from trunk:
	
	* src/vm/jit/mips/emit.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.
	(emit_load_s1, emit_load_s2, emit_load_s3, emit_store_dst): Removed.
	
	* src/vm/jit/mips/codegen.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.
	(codegen): Some updates to field instructions.

2006-09-28 20:17  edwin

	Merged r5535 from trunk:
	
	* src/vm/jit/mips/codegen.c (codegen): Moved ICMD_IREMPOW2 and
	ICMD_LREMPOW2.

2006-09-28 20:16  edwin

	Merged r5534 from trunk:
	
	* src/vm/jit/alpha/emit.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.
	(emit_load_s1, emit_load_s2, emit_load_s3, emit_store_dst): Removed.
	
	* src/vm/jit/alpha/codegen.c (vm/jit/emit.h): Renamed to
	vm/jit/emit-common.h.

2006-09-28 20:13  edwin

	Merged r5531 and r5532, ported to unified_variables:
	
	* src/vm/jit/i386/md-emit.h: Renamed to src/vm/jit/i386/emit.h.
	
	* src/vm/jit/i386/emit.c (vm/jit/i386/md-emit.h): Renamed to
	vm/jit/i386/emit.h.
	(vm/jit/emit.h): Renamed to vm/jit/emit-common.h.
	(emit_load_s1, emit_load_s2, emit_load_s3, emit_load_s1_low)
	(emit_load_s2_low, emit_load_s1_high, emit_load_s2_high)
	(emit_store_dst): Removed.
	
	* src/vm/jit/i386/codegen.c (vm/jit/i386/md-emit.h): Renamed to
	vm/jit/i386/emit.h.
	(vm/jit/emit.h): Renamed to vm/jit/emit-common.h.

2006-09-28 19:53  edwin

	Merged r5530 from trunk:
	
	* src/vm/jit/emit.h: Renamed to src/vm/jit/emit-common.h.
	* src/vm/jit/emit-common.c: New file.
	
	* src/vm/jit/Makefile.am (noinst_HEADERS): Removed emit.h.
	(libjit_la_SOURCES): Added emit-common.[ch].
	
	* src/vm/jit/x86_64/emit.c (emit_load_s1, emit_load_s2, emit_load_s3)
	(emit_store_dst): Removed.
	
	* src/vm/jit/x86_64/codegen.c: Changed include names.

2006-09-28 19:46  edwin

	Merged r5529 from trunk:
	
	* src/vm/jit/x86_64/md-emit.h: Renamed to src/vm/jit/x86_64/emit.h.

2006-09-28 19:36  edwin

	Merged r5527 from trunk:
	
	* src/native/include/.cvsignore: Added sun_misc_Unsafe.h.

2006-09-28 19:33  edwin

	Merged r5526 from trunk:
	
	* src/native/vm/sun_misc_Unsafe.c: New file:
	* src/native/vm/Makefile.am (libnativevm_la_SOURCES): Added
	sun_misc_Unsafe.c.
	* src/native/include/Makefile.am (GEN_HEADER_FILES): Added
	sun_misc_Unsafe.h.

2006-09-28 19:31  edwin

	Merged r5525 from trunk:
	
	* tests/regression/clinitexception.2output: Updated to GNU Classpath
	0.92.
	* tests/regression/extest.2output: Likewise.

2006-09-28 19:30  edwin

	Merged r5509 from trunk:
	
	* src/vm/jit/show.c (new_show_basicblock): Print predecessors only for
	stage >= SHOW_CFG.
	* src/vm/jit/show.h (SHOW_CFG): Defined.

2006-09-28 19:24  edwin

	Merged r5506 from trunk:
	
	* src/native/jni.c (GetDirectBufferAddress): Check if address is NULL.

2006-09-28 19:22  edwin

	Merged r5502 from trunk, with additional fixes:
	
	* src/vm/jit/jit.c (jit_compile_intern): Moved cfg_build call after
	stack_analyse, because of JSR elimination.
	
	* src/vm/jit/cfg.c (cfg_build): Updated to be run after stack_analyse.
	
	Fixes:
	
	* src/vm/jit/cfg.c (cfg_build): Skip NOPs at the end of the block.
	Handle JSR and RET correctly. Use bptr->next in the default case
	of falling into the following block.

2006-09-28 18:45  edwin

	Merged r5489 from trunk:
	
	* configure.ac (INTRP_CFLAGS): Moved a bit.
	* src/vm/jit/intrp/Makefile.am (CFLAGS): Don't define.
	(AM_CFLAGS): Define as INTRP_CFLAGS, that seems to be the correct way.

2006-09-28 18:42  edwin

	* src/vm/jit/sparc64/codegen.c (codegen): Replaced catchtype.cls
	with catchtype.any to reflect that it can be a classref or a
	classinfo. (Also see r5488.)

2006-09-28 18:35  edwin

	Merged r5476 from trunk:
	
	Merged sparc64 changes from trunk.

2006-09-28 18:31  edwin

	Merged r5462 from trunk:
	
	* src/vm/jit/parse.c (new_parse): Added a ICMD_NOP at the end of each
	basic block, if we have reorder enabled.

2006-09-28 17:02  edwin

	* src/vm/jit/reg.h (registerdata): New fields regcopycount,
	memcopycount, and memcopycountsize.
	
	* src/vm/jit/allocator/simplereg.c (reg_init_temp): Take jitdata
	argument, initialize copy counts.
	(reg_free_temp): Simplified a bit.
	(reg_free_temp_func): Check if freeing a copy.
	(reg_alloc_dup): New function.
	(new_allocate_scratch_registers): Implemented DUP coalescing using a
	copy count for each register/memory regoff.

2006-09-19 09:41  edwin

	* tests/regression/jasmin/runtest: Display only the basename of tests.
	* tests/regression/jasmin/Makefile.am: Use $(srcdir) to locate the
	runtest script.

2006-09-15 20:18  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Set stackslot SAVEDVAR for
	MULTIANEWARRAY.

2006-09-15 17:19  christian

	src/vm/jit/allocator/simplereg.c (reg_free_temp_func): New var
	structures also for SUPPORT_COMBINE_INTEGER_REGISTERS.

2006-09-15 17:05  christian

	* src/vm/jit/ppc/emit.c (emit_load): Changed to new variable
	structure (varinfo * instead of stackptr) and the use of Macros
	IS_INMEMORY and VAROP.
	(emit_store): Likewise.
	(emit_copy): Likewise.
	(emit_load_high): Likewise.
	(emit_load_low): Likewise.
	(emit_load_s1): Likewise.
	(emit_load_s1_low): Likewise.
	(emit_load_s1_high): Likewise.
	(emit_load_s2): Likewise.
	(emit_load_s2_low): Likewise.
	(emit_load_s2_high): Likewise.
	(emit_load_s3): Likewise.
	(emit_load_s3_low): Likewise.
	(emit_load_s3_high): Likewise.
	(emit_store_dst): Likewise.
	
	* src/vm/jit/ppc/codegen.c (codegen): Changed to new variable
	structure (varinfo * instead of stackptr, adapting of Argument
	handling, no interface copying anymore at BB Boundaries ) and the use
	of Macros IS_INMEMORY, VAR and VAROP. ICMD_xSTORE and ICMD_xLOAD use
	now
	emit_copy. ICMD_DUPx and ICMD_SWAP were replaced by ICMD_MOVE and
	ICMD_COPY. Invars are now regarded for EXH and JSR
	Blocks. Changed ICMD_RET handling like with i386.
	
	* src/vm/jit/ppc/codegen.h (M_COPY): Changed to new variable
	structure.
	
	* src/vm/jit/ppc/linux/md-abi.c (md_return_alloc): Changed to new
	variable structure.
	
	* src/vm/jit/ppc/darwin/md-abi.c (md_return_alloc): Changed to new
	variable structure.

2006-09-15 16:55  edwin

	* tests/regression/jasmin/Makefile.am: Added new test.
	* tests/regression/jasmin/test_dup_x2_interface_slots.j: New test.
	* tests/regression/jasmin/test_dup_x1_interface_slots.j: Changed
	second loop to also use DUP_X1.

2006-09-15 16:44  edwin

	* src/vm/jit/stack.c (MOVE_TO_TEMP): New macro.
	(new_stack_analyse): Use MOVE_TO_TEMP to save sources for all
	DUP*, SWAP instructions where it is necessary.
	
	* src/vm/jit/parse.c (new_parse): Reserve additional NOPs for
	DUP* instructions.

2006-09-15 16:39  edwin

	* tests/regression/jasmin/test_dup_x1_interface_slots.j: New test.
	* tests/regression/jasmin/test_dup2_x1.j: Added dup2_x1 with
	interface slots.
	* tests/regression/jasmin/Makefile.am: Added new test.

2006-09-15 16:31  christian

	* src/vm/jit/alpha/emit.c (emit_load): Changed to new variable
	structure (varinfo * instead of stackptr) and the use of Macro
	IS_INMEMORY.
	(emit_store): Likewise.
	(emit_copy): Likewise.
	(emit_load_s1): Likewise and reuse emit_load.
	(emit_load_s2): Likewise and reuse emit_load.
	(emit_load_s3): Likewise and reuse emit_load.
	(emit_store_dst): Likewise and reuse emit_store.
	
	* src/vm/jit/alpha/codegen.c (codegen): Changed to new variable
	structure (varinfo * instead of stackptr, adapting of Argument
	handling, no interface copying anymore at BB Boundaries ) and the use
	of Macro IS_INMEMORY. ICMD_xSTORE and ICMD_xLOAD use now
	emit_copy. ICMD_DUPx and ICMD_SWAP were replaced by ICMD_MOVE and
	ICMD_COPY. Invars are now regarded
	for EXH and JSR Blocks. Changed ICMD_RET handling like with i386.
	
	* src/vm/jit/alpha/codegen.h (M_COPY): Changed to new variable
	structure.
	
	* src/vm/jit/alpha/md-abi.c (md_return_alloc): Changed to new
	variable structure.

2006-09-15 15:52  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Add a third move at the
	beginning of a swap operation to save the src1 operand, unless it
	is in a temporary variable.
	
	* src/vm/jit/parse.c (new_parse): Reserve three ICMDs for SWAP.

2006-09-15 15:44  edwin

	* tests/regression/jasmin/Makefile.am: Added/renamed tests.

2006-09-15 14:43  edwin

	* src/vm/jit/verify/typecheck.c: Cleanup and documentation.

2006-09-15 14:18  edwin

	* src/vm/jit/verify/typecheck.c (typestate_reach): Removed check
	against uninitialized object on stack/in locals during backward
	branch. It is unnecessary, and not done by the RI. Reference:
	Alessandro Coglio
	Improving the official specification of Java bytecode verification
	Proceedings of the 3rd ECOOP Workshop on Formal Techniques for
	Java Programs
	June 2001
	citeseer.ist.psu.edu/article/coglio03improving.html
	
	(verify_basic_block): Removed check against uninitialized object in
	locals within try block. See above.
	
	* tests/regression/jasmin/
	test_verify_fail_backward_with_new_in_local.j: Renamed.
	* tests/regression/jasmin/test_verify_fail_new_in_local_within_try.j:
	Renamed.
	
	* tests/regression/jasmin/
	test_verify_unspecced_ok_backward_with_new_on_stack.j: New test.
	
	* tests/regression/jasmin/
	test_verify_fail_backward_with_new_on_stack.j: Fixed.

2006-09-15 13:08  edwin

	* tests/regression/jasmin/runtest: Use [ \t] instead of \s in the
	regex for sed, as this seems to be more portable.

2006-09-15 13:03  edwin

	* src/vm/jit/verify/typecheck.c (typecheck_reset_flags): Mark
	unreached
	blocks as BBDELETED. The only case in which this can happen to a block
	that was considered reachable by the stack analysis, is in the case of
	an exception handler which only covers blocks that have no PEIs.

2006-09-15 12:51  edwin

	* src/vm/resolve.c (new_resolve_field_lazy): Check jd->flags instead
	of opt_verify.
	(new_resolve_method_lazy): Likewise.

2006-09-15 12:48  christian

	* src/vm/jit/stack.c (new_stack_analyse): Stackslot flags have to be
	set for SAVEDVARs, too.

2006-09-15 11:02  edwin

	* src/vm/jit/verify/typecheck.c (verify_basic_block): Fix check for
	active exception handlers. We may not compare pointers here, as the
	blocks are not allocated with rising memory addresses. Use the
	block numbers to compare ranges.

2006-09-15 09:19  christian

	* src/vm/jit/x86_64/emit.c (emit_load): Changed to new variable
	structure (varinfo * instead of stackptr) and the use of Macro
	IS_INMEMORY.
	(emit_store): Likewise.
	(emit_copy): Likewise.
	(emit_ishift): Likewise.
	(emit_lshift): Likewise.
	(emit_load_s1): Likewise and reuse emit_load.
	(emit_load_s2): Likewise and reuse emit_load.
	(emit_load_s3): Likewise and reuse emit_load.
	(emit_store_dst): Likewise and reuse emit_store.
	
	* src/vm/jit/x86_64/md-emit.h: Adapded prototypes.
	
	* src/vm/jit/x86_64/codegen.c (codegen): Changed to new variable
	structure (varinfo * instead of stackptr, adapting of Argument
	handling, no interface copying anymore at BB Boundaries ) and the use
	of Macro IS_INMEMORY. ICMD_xSTORE and ICMD_xLOAD use now
	emit_copy. Invars are now regarded for EXH and JSR Blocks.
	
	* src/vm/jit/x86_64/codegen.h (M_COPY): Changed to new variable
	structure.
	
	* src/vm/jit/x86_64/md-abi.c (md_return_alloc): Changed to new
	variable structure.
	
	* src/vm/jit/stack.c (new_stack_analyse): Only try to preallocate
	return stackslots, if they hold a TEMPVAR. Some preparation for SSA.
	
	* src/vm/jit/jit.c (jit_compile_intern): Had to disable
	replace_create_replacement_points(jd).
	
	* src/vm/jit/show.c (new_show_icmd): Show s1 of [FIDL]RETURN like for
	ARETURN.

2006-09-14 22:51  edwin

	* configure.ac: Generate tests/regression/jasmin/Makefile.
	
	* tests/regression/Makefile.am: Added subdir jasmin.
	
	* tests/regression/jasmin/Makefile.am: New file.
	
	* tests/regression/jasmin/runtest: Check if jasmin .jar is available.

2006-09-14 22:49  edwin

	* src/vm/jit/verify/typecheck.c (verify_basic_block): Change
	destination variable of GETFIELD/GETSTATIC after all checks have been
	performed, so there is no problem if destination == source.

2006-09-14 21:29  edwin

	* tests/regression/jasmin/test_verify_fail_retaddr_as_object.j:
	New test.

2006-09-14 21:23  edwin

	*
	tests/regression/jasmin/test_verify_fail_backward_with_new_in_local.j:
	New test.
	* tests/regression/jasmin/test_verify_fail_new_in_local_within_try.j:
	Likewise.
	* tests/regression/jasmin/test_verify_fail_double_local_index.j:
	Likewise.
	*
	tests/regression/jasmin/test_verify_fail_backward_with_new_on_stack.j:
	Likewise.

2006-09-14 20:55  edwin

	* tests/regression/jasmin/test_verify_fail_long_local.j:
	Added comment.
	* tests/regression/jasmin/test_verify_fail_double_overwritten.j:
	New test.
	* tests/regression/jasmin/test_verify_fail_invoke_basic_type.j:
	New test.
	* tests/regression/jasmin/test_verify_fail_long_overwritten.j:
	New test.

2006-09-14 20:36  edwin

	* src/vm/jit/verify/typecheck.c (typecheck_invalidate_locals):
	New function.
	(verify_basic_block): Invalidate locals that share space with the
	stored local.
	(typecheck): Build reverse map of locals.

2006-09-14 18:56  edwin

	* src/vm/jit/reg.h (varinfo): Added typeinfo member.
	
	* src/vm/jit/verify/typecheck.c: Ported to unified_variables.
	* src/vm/jit/verify/typeinfo.h: Likewise.
	* src/vm/jit/verify/typeinfo.c: Likewise.

2006-09-14 18:55  edwin

	* src/vm/resolve.c (resolve_class_from_name): RESOLVE_VERBOSE changes.
	(resolve_classref_or_classinfo): Likewise.
	(resolve_class_from_typedesc): Likewise.
	(resolve_and_check_subtype_set): Likewise.
	(new_create_unresolved_field): Likewise.
	(new_create_unresolved_method): Likewise.
	
	(new_resolve_field_verifier_checks): Ported to unified_variables.
	(new_resolve_field_lazy): Likewise.
	(new_resolve_method_verifier_checks): Likewise.
	(new_resolve_method_lazy): Likewise.
	(new_constrain_unresolved_field): Likewise.
	
	
	(unresolved_subtype_set_from_typeinfo): Take classname directly,
	instead of the constant_classref *.
	
	(create_unresolved_class): Pass classname to
	unresolved_subtype_set_from_typeinfo.
	
	(new_constrain_unresolved_method): Ported to unified_variables.
	Pass classname to unresolved_subtype_set_from_typeinfo. (This should
	fix a bug when fieldref->p.classref was invalid.)
	
	(new_constrain_unresolved_method): Ported to unified_variables.
	Pass classname to unresolved_subtype_set_from_typeinfo.
	
	* src/vm/resolve.h (jit/reg.h): Include this before typeinfo.h
	(new_resolve_method_lazy): Added jd parameter.
	(new_resolve_field_lazy): Likewise.
	(new_constrain_unresolved_field): Likewise.
	(new_constrain_unresolved_method): Likewise.
	
	* src/vm/jit/parse.c (new_parse): Pass jd to resolve functions.

2006-09-14 18:45  edwin

	* src/vm/jit/show.c (new_show_method): Only show allocation of locals
	if stage is at least SHOW_REGS.
	(new_show_icmd): Show class for CHECKCAST.

2006-09-14 18:44  edwin

	* src/vm/jit/stack.c (stack_create_invars): Add extra locals needed
	by the verifier.
	(stack_create_invars_from_outvars): Likewise.
	(new_stack_analyse): Create inlocals for first block. Allow ASTORE of
	returnAddress values.

2006-09-14 18:40  edwin

	* src/vm/jit/parse.c (new_parse): Commented calculation of varcount
	and added added extra variables that will be needed by the verifier.

2006-09-14 18:36  edwin

	* src/vm/global.h (VERIFIER_EXTRA_LOCALS): New constant.
	(VERIFIER_EXTRA_VARS): Likewise.

2006-09-14 18:20  edwin

	* src/vm/class.c (class_classref_or_classinfo_print): New function.
	(class_classref_or_classinfo_println): Likewise.
	
	* src/vm/class.h (class_classref_or_classinfo_print): New function.
	(class_classref_or_classinfo_println): Likewise.

2006-09-14 18:16  edwin

	* src/vm/jit/jit.h (VAROP): New macro for accessing variable operands.
	(VAR): New macro for getting a variable from a varindex.

2006-09-14 16:46  edwin

	* tests/regression/jasmin/test_verify_fail_load_wrong_type.j:
	New test.
	* tests/regression/jasmin/
	test_verify_fail_load_wrong_type_within_block.j: New test.
	* tests/regression/jasmin/test_verify_fail_local_index.j: New test.
	* tests/regression/jasmin/test_verify_fail_long_local_index.j:
	New test.
	* tests/regression/jasmin/test_verify_fail_long_local.j: New test.
	* tests/regression/jasmin/test_verify_fail_split_local.j: New test.
	* tests/regression/jasmin/test_verify_ok_overwrite_local_type.j:
	New test.
	* tests/regression/jasmin/test_verify_ok_untyped_local.j: New test.

2006-09-13 00:21  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Replaced catchtype.cls with
	catchtype.any to reflect that it can be a classref or a classinfo.
	
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/mips/codegen.c (codegen): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.
	* src/vm/jit/intrp/codegen.c (codegen): Likewise.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.
	
	* src/vm/jit/intrp/asmpart.c (intrp_asm_handle_exception): Added XXX
	comment warning that classrefs must be resolved here.

2006-09-13 00:03  edwin

	* src/vm/jit/i386/codegen.c (codegen): Use emit_copy for LOAD/STORE
	instructions. We should also combine this with ICMD_COPY/MOVE, but
	I was not sure how to deal with the M_COPY macro.

2006-09-12 23:35  edwin

	* tests/regression/jasmin/test_swap_locals.j: New test.

2006-09-12 23:31  edwin

	* tests/regression/jasmin/test_swap_interface_slots.j: New test.

2006-09-12 23:18  edwin

	* tests/regression/jasmin/test_many_monitors.j: New test. (This test
	case used to fail with old-instruction-format cacao.)

2006-09-12 22:32  christian

	* src/vm/jit/i386/codegen.c (codegen): Corrected handling of taking
	arguments out of stack frame. Some changes to adapt SSA to unified
	variables.

2006-09-12 21:34  edwin

	* src/vm/jit/parse.c (parse_check_instructions): Renamed to
	parse_realloc_instructions to reflect what it really does. Fixed so
	it adds at least as many instructions as required by the check.
	
	* src/vm/jit/parse.h (INSTRUCTIONS_CHECK): Use
	parse_realloc_instructions.
	(MARK_BASICBLOCK): Cleaned up backslashes.

2006-09-12 21:23  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Fixed test for existing
	coalescing for *STORE.
	Properly use the return value of stack_mark_reached when analysing
	a block for the first time.
	
	* tests/regression/jasmin/test_simple_load_store.j: Added a test
	that just does ILOAD 1, ISTORE 1.

2006-09-12 00:21  edwin

	* tests/regression/jasmin/test_verify_ok_jsr_handler_in_sub.j:
	Renamed to test_verify_fail_jsr_handler_in_sub.j, as it fails on the
	reference implementation.
	
	* tests/regression/jasmin/test_verify_ok_jsr_exceptions.j: Renamed to
	test_verify_fail_jsr_exceptions.j, likewise.
	
	* tests/regression/jasmin/test_verify_fail_ret_uninit_var.j,
	tests/regression/jasmin/test_verify_fail_aload_retaddress.j,
	tests/regression/jasmin/test_verify_fail_ret_bad_type.j: Made
	expected error match both CACAO's message and the reference
	implementation's message.

2006-09-11 23:32  edwin

	* src/vm/jit/stack.c (stack_reanalyse_block): Removed unused
	variable.

2006-09-11 23:24  edwin

	* src/vm/jit/stack.c: Added JSR elimination by block specialization.
	
	* src/vm/jit/i386/codegen.c (codegen): Treat ICMD_RET as a GOTO.

2006-09-11 23:17  edwin

	* tests/regression/jasmin/runtest: Add --color option.

2006-09-11 22:17  edwin

	* tests/regression/jasmin/test_verify_ok_jsr_handler_in_sub2.j: Added
	a second call of the subroutine, so cacao has to clone the exception
	handler.

2006-09-11 14:59  edwin

	* tests/regression/jasmin/test_verify_ok_jsr_handler_in_sub.j:
	New test.
	* tests/regression/jasmin/test_verify_ok_jsr_exceptions.j: Likewise.
	* tests/regression/jasmin/test_verify_ok_jsr_through_variable.j:
	Likewise.
	* tests/regression/jasmin/test_verify_ok_jsr_handler_in_sub2.j:
	Likewise.
	* tests/regression/jasmin/test_verify_ok_jsr_swap.j: Likewise.

2006-09-11 14:57  edwin

	* tests/regression/jasmin/test_dup2.j: Fix stackdepth.
	* tests/regression/jasmin/test_load_store_conflict.j: Likewise.

2006-09-11 14:55  edwin

	* tests/regression/jasmin/runtest: Only show PASS if status is ok.

2006-09-11 14:54  edwin

	* src/vm/jit/allocator/simplereg.c (new_allocate_scratch_registers):
	Zero destination of ICMD_JSR to avoid problems when showing the IR.

2006-09-11 14:52  edwin

	* src/vm/jit/show.h (show_jit_type_letters): New variable.
	(show_jit_type_names): Likewise.
	
	* src/vm/jit/show.c (jit_type): Renamed to show_jit_type_names and
	exported.
	(show_jit_type_letters): New variable.
	(new_show_method): Improved.
	(new_show_icmd): Likewise.

2006-09-11 14:45  edwin

	* src/toolbox/logging.h (log_text): Fixed for strings containing %.

2006-09-11 14:37  edwin

	* src/vm/jit/reg.h (varinfo): Put regoff inside a union (vv) so it
	can share space with the constant values put in varinfo. Also made
	type and flags s4.
	
	* src/vm/jit/stack.c (new_stack_analyse): Replace regoff with
	vv.regoff.
	
	* src/vm/jit/show.c (new_show_method): Likewise.
	(new_show_variable): Likewise.
	
	* src/vm/jit/allocator/simplereg.c (local_regalloc): Likewise.
	(reg_new_temp_func): Likewise.
	(reg_free_temp_func): Likewise.
	(new_allocate_scratch_registers): Likewise.
	(reg_make_statistics): Likewise.
	
	* src/vm/jit/i386/emit.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/codegen-common.c: Likewise.

2006-09-11 00:33  edwin

	* src/vm/global.h (TYPE_RET): New constant.
	
	* src/vm/exceptions.c (exceptions_throw_verifyerror_for_stack):
	Display TYPE_RET correctly.

2006-09-11 00:30  edwin

	* src/vm/jit/jit.h (basicblock): Added fields `inlocals` and
	`original` (for JSR elimination).

2006-09-11 00:03  edwin

	* tests/regression/jasmin/test_verify_fail_aload_retaddress.j: New
	test.
	* tests/regression/jasmin/test_verify_fail_ret_uninit_var.j: New
	test.
	* tests/regression/jasmin/test_verify_ok_jsr_pop.j: New test.
	* tests/regression/jasmin/test_verify_ok_jsr_push.j: New test.

2006-09-10 13:51  edwin

	* tests/regression/jasmin/runtest: Return correct exit code.

2006-09-10 13:45  edwin

	* tests/regression/jasmin/runtest: Delete temporary files.
	* tests/regression/jasmin/test_verify_ok_jsr.j: New test.
	* tests/regression/jasmin/test_verify_ok_jsr_multiple_blocks.j: New
	test.
	* tests/regression/jasmin/test_verify_fail_ret_bad_type.j: New test.

2006-09-10 13:43  edwin

	* tests/regression/jasmin/runtest: Added harness code for expecting
	errors.

2006-09-10 11:35  christian

	* src/vm/jit/i386/codegen.c (codegen): Corrected handling of taking
	arguments out of stack frame.

2006-09-10 11:20  edwin

	* src/vm/jit/stack.c (DUP_SLOT): Removed code for direct coalescing.
	(DUP coalescing will be done in simplereg, probably.)

2006-09-10 09:11  edwin

	* src/vm/jit/show.c (new_show_method): Use class_print and
	class_classref_print for showing the catch type.

2006-09-09 22:33  edwin

	* src/vm/jit/stack.c: Fixed macro backslashes.

2006-09-09 22:05  edwin

	* src/vm/jit/show.c (new_show_method): Show hexadecimal offsets in
	stack slot table.

2006-09-09 21:58  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Reset the sd.new pointer at
	the beginning of each basic block.

2006-09-09 21:50  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Made control-flow easier
	to read. The majority of the code is now indented one level too much.
	I did not change this, yet, to avoid a giant diff. We can do this
	when all the branches are merged together.

2006-09-09 21:41  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Combined calls to
	stack_create_instack.

2006-09-09 21:33  edwin

	* src/vm/jit/jit.h (basicblock): Removed members instack and
	outstack.
	
	* src/vm/jit/stack.c (stack_check_invars): New function.
	(stack_create_instack): New function.
	(stack_mark_reached): Use new functions.
	(new_stack_analyse): Likewise.
	
	* src/vm/jit/stack.h (COPYCURSTACK): Removed macro.

2006-09-09 20:05  edwin

	* src/vm/jit/stack.h (COPYCURSTACK): Do not create invars here.
	
	* src/vm/jit/stack.c (stack_create_invars): New function.
	(stack_mark_reached): Use stack_create_invars.
	(new_stack_analyse): Likewise.

2006-09-09 19:37  edwin

	* src/vm/jit/jit.h (basicblock): Added fields varstart and varcount.
	Reordered fields for clarity and alignment.
	
	* src/vm/jit/stack.c (new_stack_analyse): Set varstart and varcount
	of each basic block.

2006-09-09 19:25  edwin

	* src/vm/exceptions.c (exceptions_handle_exception): Added comment on
	why we have to do eager resolving here. Check for exceptions while
	resolving the catch class reference.
	
	* src/vm/linker.c (link_class_intern): Resolve exception classes
	in handler entries lazily, instead of eagerly.

2006-09-09 14:49  edwin

	* src/vm/jit/stack.h (CURKIND): Removed macro.
	(CURTYPE): Removed macro.
	
	* src/vm/jit/stack.c (new_stack_analyse): Removed the single use of
	CURKIND.

2006-09-09 14:45  edwin

	* src/vm/jit/stack.h (Changes): Added my name.

2006-09-09 14:41  edwin

	* src/vm/jit/stack.h (REQUIRE_1, REQUIRE_2, REQUIRE_3, REQUIRE_4):
	Removed.
	* src/vm/jit/stack.c (new_stack_analyse): Use the general REQUIRE
	macro.

2006-09-08 23:59  edwin

	* src/vm/jit/stack.c (IS_TEMPVAR): Fix bug spotted
	(and produced ;) by c_u.

2006-09-08 20:54  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Added some assertion.
	When we do a STORE coalescing, the stackslot must have a creator.

2006-09-08 20:50  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Unified last_dup_boundary
	and last_pei_boundary to coalescing_boundary.
	Activated STORE coalescing. Change destination operand of creator, if
	any.

2006-09-08 20:41  edwin

	* src/vm/jit/stack.h (COPYCURSTACK): Use GET_NEW_VAR.
	Removed SET_OUTVAR.
	* src/vm/jit/stack.c (GET_NEW_VAR): New macro.
	(various macros): Use GET_NEW_VAR, so the variable type is set.
	Reset coalescing for non-consuming uses.
	(SET_TEMPVAR): Fix: do not use "copy". Change the destination operand
	of the creator, if any.
	(DST_LOCAL): Activate LOAD coalescing.
	(new_stack_analyse): Reset coalescing for pass-through operands.

2006-09-08 19:48  edwin

	* src/vm/jit/jit.h (stackelement): Added creator field.
	* src/vm/jit/stack.h (COPYCURSTACK): Set creator = NULL.
	* src/vm/jit/stack.c (DST, DST_LOCALVAR, MOVE_COPY_UP, COPY_DOWN):
	Set creator to current iptr.
	* src/vm/jit/stack.h: Cleaned up macros.
	* src/vm/jit/stack.c: Likewise.

2006-09-08 18:14  edwin

	* src/vm/jit/codegen-common.h: Removed the NEW_VAR define.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/reg.c: Likewise.
	* src/vm/jit/reg.h: Likewise.
	* src/vm/jit/jit.c: Likewise.
	* src/vm/jit/codegen-common.c: Likewise.
	* src/vm/jit/jit.h: Likewise, and removed the dupslots member from
	the dst_operand_t union.

2006-09-08 18:12  edwin

	* src/vm/jit/show.c (new_show_icmd): Removed code for DUPs.

2006-09-08 17:59  edwin

	* src/vm/jit/verify/typecheck.c: Removed code for DUPs.

2006-09-08 17:57  edwin

	* src/vm/jit/i386/codegen.c (codegen): Removed code for DUPs.

2006-09-08 17:50  edwin

	* src/vm/jit/i386/codegen.c (*LOAD, *STORE): Normalized the source ==
	dest check so it always looks the same.
	(LLOAD, LSTORE): Use M_LNGMOVE, not M_INTMOVE.
	(DSTORE): Combined with FSTORE, because it now has the same code.

2006-09-08 17:37  edwin

	* src/vm/jit/i386/codegen.c (codegen): Fix LSTORE: The source == dest
	test was broken.

2006-09-08 16:41  edwin

	* src/vm/jit/show.c (new_show_method): Fix display of local table.

2006-09-08 16:26  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Fix ICMD_RET: The variable
	index has to be mapped.

2006-09-08 16:07  edwin

	* src/vm/jit/stack.c (DUP_SLOT): Turn off coalescing.
	(MOVE_COPY_UP): New macro.
	(COPY_DOWN): New macro.
	(interface_map): Changed to array of interface_info.
	(*STORE): Fix index into last_store_boundary (must be javaindex).
	(DUP*, SWAP): Eliminate DUPs.
	(new_stack_analyse): Mark invar interfaces used.
	
	* src/vm/jit/show.c (new_show_method): Adapted to new
	interface_map layout.
	
	* src/vm/jit/allocator/simplereg.c (interface_regalloc): Adapted
	to new interface_map layout.
	(new_allocate_scratch_registers): Likewise.
	(new_allocate_scratch_registers): Removed code for DUP* instructions.
	(ICMD_MOVE, ICMD_COPY): Added.

2006-09-08 16:02  edwin

	* src/vm/jit/i386/codegen.h (M_FLTMOVE): Only assert(0) if move would
	have to be performed.

2006-09-08 14:17  edwin

	* src/vm/jit/show.c (show_variable): Check for invalid flags.

2006-09-08 14:16  edwin

	* src/vm/jit/i386/codegen.c (codegen): Removed a debug print.

2006-09-08 14:15  edwin

	* src/vm/jit/stack.c (DST_LOCALVAR): _Really_ turn off coalescing
	temporarily.

2006-09-08 12:19  edwin

	* src/vm/jit/allocator/simplereg.c (interface_regalloc): Changed
	allocation of interface registers. interface_map now contains the
	necessary flags, and receives a combination of allocated flags
	and regoff.
	
	(new_allocate_scratch_registers): Copy the allocation of the
	invars and outvars for each basic block.

2006-09-08 12:17  edwin

	* src/vm/jit/jit.h (LOCAL_UNUSED): Changed (in comment) to UNUSED.

2006-09-08 12:16  edwin

	* src/vm/jit/stack.c (stackdata_t): New struct for keeping internal
	data of the stack analysis. This is necessary for converting macros
	to functions.
	(various macros): Adapted to use stackdata_t. Removed old code.
	(DST_LOCALVAR): Temporarily turned off local variable coalescing.
	(MARKREACHED): Converted to a function.
	(stack_mark_reached): New function.
	(last_store_boundary): Use java indices instead of internal local
	indices into this table.
	(new_stack_analyse): Removed old code.
	
	* src/vm/jit/stack.h (various macros): Adapted to use stackdata_t.
	(MARKREACHED): Converted to a function.

2006-09-08 12:10  edwin

	* src/vm/jit/parse.h: Removed old code.
	* src/vm/jit/parse.c (new_parse): Do not modify m->maxlocals and
	cd->maxlocals.
	They refer to the number of javalocals, and that's ok. We have
	jd->localcount
	to keep the number of internal locals.

2006-09-08 12:07  edwin

	* src/vm/jit/show.c (new_show_method): Show isleafmethod.
	(new_show_method): Pretty interface map printing (prepared for
	interface register allocation changes).
	(new_show_method): Print allocation of stack slots.
	(show_allocation): New function.
	(show_variable): Mark SAVEDVARs with an exclamation mark.

2006-09-08 01:05  edwin

	* src/vm/jit/show.c (new_show_method): Only show local table if there
	are locals.

2006-09-07 23:17  edwin

	* src/vm/jit/show.c (jit_type): Made types uppercase.
	(new_show_method): Prettier printing of locals_map and interface_map.
	(SHOW_STACKVAR): Renamed to SHOW_VARIABLE.
	(new_show_stackvar): Renamed to show_variable. Cleaned up.

2006-09-07 22:44  edwin

	* src/vm/jit/allocator/simplereg.c (reg_new_temp_func): Removed old
	version.
	(reg_free_temp_func): Likewise.
	(allocate_scratch_registers): Likewise.

2006-09-07 22:39  edwin

	* src/vm/jit/allocator/simplereg.c (reg_alloc_dup): Removed.
	(new_reg_mark_copy): Likewise.

2006-09-07 14:41  edwin

	* src/vm/jit/i386/codegen.c (ICMD_COPY): Added.
	(ICMD_MOVE): Likewise.

2006-09-07 14:38  edwin

	* src/vm/jit/reg.h (varinfo): New field copycount.
	* src/vm/jit/parse.c (new_parse): Zero jd->var array.

2006-09-07 14:31  edwin

	* src/vm/jit/parse.c (new_parse): Allocate extra NOPs for stack
	operations.

2006-09-07 14:25  edwin

	* src/vm/jit/show.c (ICMD_COPY): Uncommented.
	(ICMD_MOVE): Likewise.

2006-09-07 14:24  edwin

	* src/vm/jit/jit.h, src/vm/jit/jit.c (ICMD_COPY): New ICMD.
	(ICMD_MOVE): Likewise.

2006-09-07 14:00  christian

	* src/vm/jit/allocator/simplreg: Removed #if defined(NEW_VAR) over
	some functions.

2006-09-07 13:41  edwin

	* src/vm/jit/jit.c (ENABLE_VERIFY): Corrected to ENABLE_VERIFIER.

2006-09-07 13:29  christian

	Unified variables changes for common/i386.

2006-09-07 13:01  edwin

	Branch for developing unified variables.

2006-09-07 12:52  twisti

	* src/vm/jit/i386/emit.c: Use IS_INMEMORY macro.
	* src/vm/jit/i386/codegen.c: Likewise.

2006-09-07 12:26  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Use IS_INMEMORY macro.

2006-09-07 12:24  twisti

	* src/vm/jit/powerpc/emit.c (emit_copy): Eliminate register move if
	one of the variables resides in memory.

2006-09-07 11:14  twisti

	* src/vm/jit/alpha/emit.c (emit_copy): Only one not-equal comparison.

2006-09-07 11:09  twisti

	* src/vm/jit/powerpc64/emit.c (emit_copy): Eliminate register move if
	one of the variables resides in memory.

2006-09-07 10:59  twisti

	* src/vm/jit/mips/emit.c (emit_copy): Eliminate register move if one
	of the variables resides in memory.

2006-09-07 10:46  twisti

	* src/vm/jit/i386/emit.c (emit_copy): Eliminate register move if one
	of the variables resides in memory.

2006-09-07 10:16  twisti

	* src/vm/jit/x86_64/emit.c (emit_copy): Eliminate register move if one
	of the variables resides in memory.

2006-09-07 10:03  twisti

	* src/vm/jit/alpha/emit.c (emit_copy): Eliminate register move if one
	of the variables resides in memory.

2006-09-07 09:40  twisti

	* src/vm/jit/jit.h (IS_SAVEDVAR): Added.
	(IS_INMEMORY): Likewise.

2006-09-07 00:32  edwin

	* src/vm/jit/show.c (new_show_icmd): Separate real arguments and
	pass-through variables for INVOKE*.

2006-09-07 00:29  edwin

	* src/vm/jit/show.c (new_show_icmd): Separate real arguments and
	pass-through variables for BUILTIN.

2006-09-06 23:18  twisti

	* src/vm/jit/powerpc64/linux/md-abi.h: Bugfixes and changes for new
	instruction format.
	* src/vm/jit/powerpc64/linux/md-abi.c: Likewise.
	* src/vm/jit/powerpc64/emit.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.h: Likewise.

2006-09-06 22:34  twisti

	* src/vm/jit/mips/linux/md-abi.h (REG_A0, REG_A1, REG_A2, REG_A3):
	Defined.
	* src/vm/jit/mips/codegen.c: Use REG_A? defines instead of
	rd->argintreg[] loads.

2006-09-06 22:16  twisti

	* src/vm/jit/alpha/linux/md-abi.h (REG_A0, REG_A1, REG_A2, REG_A3):
	Defined.
	* src/vm/jit/alpha/codegen.c: Use REG_A? defines instead of
	rd->argintreg[] loads.

2006-09-06 21:56  twisti

	* src/vm/jit/x86_64/md-abi.h (REG_A0, REG_A1, REG_A2, REG_A3):
	Defined.
	* src/vm/jit/x86_64/codegen.c: Use REG_A? defines instead of
	rd->argintreg[] loads.

2006-09-06 21:40  twisti

	* src/vm/jit/stack.c (new_stack_analyse): Removed obsolete precedessor
	calucation.

2006-09-06 21:32  edwin

	* tests/regression/jasmin/test_dup_x2.j: Split second test into
	separate file.
	* tests/regression/jasmin/test_dup_x2_to_dup_x1: New test.

2006-09-06 21:30  edwin

	* tests/regression/jasmin/runtest: Improved harness script.

2006-09-06 21:17  twisti

	* src/vm/jit/powerpc/linux/md-abi.h (REG_A0, REG_A1, REG_A2, REG_A3):
	Defined.
	* src/vm/jit/powerpc/darwin/md-abi.h: Likewise.
	
	* src/vm/jit/powerpc/codegen.c: Use REG_A? defines instead of
	rd->argintreg[] loads.

2006-09-06 17:05  twisti

	* src/vm/jit/mips/codegen.c (codegen): Generate the INVOKE/BUILTIN
	call code in a common place.

2006-09-06 16:43  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Generate the INVOKE/BUILTIN
	call code in a common place.

2006-09-06 16:41  twisti

	* src/vm/jit/i386/codegen.c (codegen): Don't move the function address
	into disp for ICMD_BUILTIN.

2006-09-06 16:30  twisti

	* src/vm/jit/i386/codegen.c (codegen): Generate the INVOKE/BUILTIN
	call code in a common place.
	(createnativestub): Removed unused disp variable.

2006-09-06 16:24  twisti

	* src/vm/jit/alpha/codegen.c (codegen): Generate the INVOKE/BUILTIN
	call code in a common place.

2006-09-06 16:06  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Generate the INVOKE/BUILTIN
	call code in a common place.

2006-09-06 16:01  edwin

	* src/vm/jit/jit.h (INS_FLAG_NOCHECK): Reversed to INS_FLAG_CHECK.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/stack.h: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/parse.h: Likewise.

2006-09-06 15:22  edwin

	* src/vm/jit/parse.h (INSTRUCTIONS_CHECK): New macro.
	* src/vm/jit/parse.c (new_parse): Merged twisti's reallocation of the
	instruction array.

2006-09-06 14:38  twisti

	* src/vm/jit/alpha/codegen.c (ICMD_I2L): Use REG_ITMP1 for dst, this
	can save a move.
	(ICMD_LDIV, ICMD_LREM): Use argument registers for s1 and s2 when
	loaded.

2006-09-06 14:32  edwin

	Checked in jasmin tests.

2006-09-06 14:01  edwin

	* src/vm/jit/parse.c (parserdata_t): New type.
	(parse_setup): New function.
	(parse_check_instructions): New function.

2006-09-06 13:46  christian

	* src/vm/jit/stack.c (new_stack_analyse): Ifdeffed handling of new var
	system.
	
	* src/vm/jit/stack.h: Likewise.
	
	* src/vm/jit/parse.c (new_parse) : Likewise.
	
	* src/vm/jit/parse.h: Likewise.
	
	* src/vm/jit/jit.h: Ifdeffed structure entries for new var system.

2006-09-06 12:37  twisti

	* src/vm/jit/powerpc/codegen.c (codegen): Use M_ISUB in ICMD_ISUBCONST
	instead of M_IADD.

2006-09-06 11:58  twisti

	* src/vm/jit/mips/emit.c (emit_copy): Removed accidentally pasted
	code.

2006-09-06 11:12  edwin

	* src/vm/jit/stack.h: Removed macros for old instruction format.

2006-09-06 11:01  edwin

	* src/vm/jit/parse.h: Removed NEW_ prefix from macros.
	* src/vm/jit/parse.c: Likewise.

2006-09-06 10:56  edwin

	* src/vm/jit/stack.h (CHECKOVERFLOW): Removed.
	(NEW_CHECKOVERFLOW): Renamed to CHECKOVERFLOW.
	
	* src/vm/jit/stack.c (new_stack_analyse): Removed NEW_ prefix from
	macro names.

2006-09-06 10:48  edwin

	* src/vm/jit/x86_64/emit.c: Renamed new_instruction to instruction.
	* src/vm/jit/x86_64/md-emit.h: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.

2006-09-06 10:20  christian

	* src/vm/stack.c (new_stack_analyse): Removed assert to check, that
	all outvars are STACKVARS. Would be a possible conflict with swap
	
	* src/vm/parse.c (new_parse): Data colletion for local var
	renaming(de-coalescing)
	
	* src/vm/parse.h (new_pase): Likewise.
	
	* src/vm/jit.h: Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Ifdefed interface copy in
	regard to new
	var system.

2006-09-06 10:16  edwin

	* src/vm/jit/mips/emit.c (emit_load_s1): Removed obsolete src param.
	(emit_load_s2): Likewise.
	(emit_load_s3): Likewise.

2006-09-06 10:14  edwin

	* src/vm/jit/powerpc64/emit.c (emit_load): New function.
	(emit_load_s1): Implemented in terms of emit_load.
	(emit_load_s2): Likewise.
	(emit_load_s3): Likewise.
	(emit_store_dst): New function.

2006-09-06 10:09  edwin

	* src/vm/jit/mips/emit.c (emit_load): New function.
	(emit_load_s1): Implemented in terms of emit_load.
	(emit_load_s2): Likewise.
	(emit_load_s3): Likewise.
	(emit_store_dst): New function.

2006-09-06 09:57  edwin

	* src/vm/jit/stack.c (new_stack_analyse): Implement conflict checking
	and coalescing for *STORE.
	* src/vm/jit/show.c (new_show_stackvar): Show coalescing info.

2006-09-06 00:18  christian

	* src/vm/jit/stack.c (new_stack_analyse): Mark all in and out
	Stackslots of Basic Blocks as STACKVAR.
	
	* src/vm/jit/i386/codegen.c (codegen): Removed copy of interfaces
	to in and from out stackslots.

2006-09-06 00:07  edwin

	* src/vm/jit/powerpc64/codegen.c (codegen): ++lookup in LOOKUPSWITCH
	loop.
	* src/vm/jit/powerpc64/codegen.c (codegen): Ported to new instruction
	format.

2006-09-05 23:37  edwin

	* src/vm/jit/i386/codegen.c (codegen): Port LASTORECONST, PUT*CONST.

2006-09-05 23:10  edwin

	* src/vm/jit/mips/codegen.c (codegen): Ported to new instruction
	format.

2006-09-05 23:08  twisti

	* src/vm/jit/powerpc/emit.c: Updated to new instruction format.
	* src/vm/jit/powerpc/codegen.c: Likewise.

2006-09-05 23:07  twisti

	* src/vm/builtin.c (builtin_print_argument): Print decimal values for
	int and long arguments.

2006-09-05 22:51  christian

	* i386/emit.c: Changed to new instruction format.
	* i386/codegen.c: Likewise.
	* i386/codegen.h: Likewise.
	* parse.c: Likewise.
	* parse.h: Likewise.
	* jit.h: Likewise.

2006-09-05 22:42  edwin

	* src/vm/jit/show.c (new_show_icmd): Show LOOKUPSWITCH targets.

2006-09-05 22:27  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Port MULTIANEWARRAY.

2006-09-05 22:23  edwin

	* sarc/vm/jit/parse.c (parse): Check return value of
	lock_monitor_enter.

2006-09-05 22:22  edwin

	* src/threads/native/lock.h (lock_monitor_enter): Return bool.
	* src/threads/native/lock.c (lock_monitor_enter): Check for
	NullPointerException.

2006-09-05 22:05  twisti

	* src/vm/jit/cfg.c (cfg_build): It's better to not reuse the loop
	variable.

2006-09-05 21:53  edwin

	* src/vm/jit/show.c (new_show_icmd): Show BLOCK_OF tableswitch
	targets.

2006-09-05 21:50  edwin

	* src/vm/jit/show.c (new_show_icmd): Show TABLESWITCH targets.

2006-09-05 21:20  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Port ICMD_CHECKCAST.

2006-09-05 21:20  twisti

	* src/vm/method.h (methodinfo): Removed members basicblockcount,
	basicblocks, basicblockindex, instructioncount, instructions,
	stackcount, and stack.
	
	* src/vm/jit/cfg.c: Use jitdata variables instead of methodinfo ones.
	* src/vm/jit/reorder.c: Likewise.
	* src/vm/jit/ifconv/ifconv.c: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/replace.c: Likewise.
	* src/vm/jit/jit.c: Likewise.

2006-09-05 21:17  twisti

	* src/vm/jit/powerpc/Makefile.am (libarch_la_SOURCES): Added
	accidentally removed codegen.c.

2006-09-05 21:16  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Use d for return type checks.

2006-09-05 21:15  twisti

	* src/cacaoh/headers.c: Use a dummy flag for natively overloaded
	methods.

2006-09-05 21:14  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Deactivate replacement points.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.

2006-09-05 21:06  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Set fieldtype in all cases.

2006-09-05 20:58  edwin

	* src/vm/jit/show.c (new_show_basicblock): Prettier if.

2006-09-05 20:57  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Use jd->new_basicblocks.

2006-09-05 20:50  edwin

	* src/vm/jit/alpha/codegen.c: Use invars/outvars instead of
	instack/outstack.

2006-09-05 20:17  edwin

	* src/vm/jit/alpha/codegen.c (codegen): Port handling of INVOKE*
	arguments.

2006-09-05 20:11  edwin

	* src/vm/jit/alpha/emit.c: Ported to new instruction format.
	* src/vm/jit/alpha/codegen.c: Likewise.

2006-09-05 19:38  twisti

	* src/vm/jit/jit.h (instruction): Removed.
	(new_instruction): Renamed to instruction.
	
	* src/vm/builtin.c: Renamed new_instruction to instruction.
	* src/vm/builtin.h: Likewise.
	* src/vm/resolve.c: Likewise.
	* src/vm/resolve.h: Likewise.
	* src/vm/jit/powerpc/emit.c: Likewise.
	* src/vm/jit/powerpc/Makefile.am: Likewise.
	* src/vm/jit/codegen-common.h: Likewise.
	* src/vm/jit/cfg.c: Likewise.
	* src/vm/jit/reorder.c: Likewise.
	* src/vm/jit/emit.h: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/stack.h: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/dseg.c: Likewise.
	* src/vm/jit/verify/typecheck.c: Likewise.
	* src/vm/jit/verify/typeinfo.c: Likewise.
	* src/vm/jit/show.h: Likewise.
	* src/vm/jit/allocator/simplereg.c: Likewise.
	* src/vm/jit/parse.c: Likewise.
	* src/vm/jit/codegen-common.c: Likewise.

2006-09-05 19:06  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Converted with
	portcodegen.pl.
	* src/vm/jit/sparc64/codegen.c (codegen): Likewise.
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/mips/codegen.c (codegen): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.

2006-09-05 18:43  edwin

	Merge changes from trunk (powerpc64).

2006-09-05 17:42  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): Use emit_load instead of
	emit_load_s1/s2 for variable arguments and interface copying.
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/mips/codegen.c (codegen): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.

2006-09-05 17:21  edwin

	Merged changes from trunk.

2006-09-05 16:45  edwin

	* src/vm/jit/powerpc/codegen.c (codegen): ICMD_PUTSTATIC: Use
	emit_load_s1 to load the first operand.
	* src/vm/jit/sparc64/codegen.c (codegen): Likewise.
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	* src/vm/jit/mips/codegen.c (codegen): Likewise.
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc64/codegen.c (codegen): Likewise.

2006-09-05 16:12  edwin

	* src/vm/jit/jit.h (basicblock): Changed type of iinstr to
	new_instruction *.
	* src/vm/jit/stack.c (new_stack_analyse): Removed obsolete casts.
	* src/vm/jit/show.c (new_show_basicblock): Likewise.
	* src/vm/jit/verify/typecheck.c (verify_basic_block): Likewise.
	* src/vm/jit/allocator/simplereg.c (new_allocate_scratch_registers):
	Likewise.
	* src/vm/jit/parse.c (new_parse): Likewise.
	* src/vm/jit/x86_64/codegen.c (new_parse): Likewise.

2006-09-05 12:42  edwin

	* src/vm/jit/jit.h (s3_operand_t): Removed arrayvftbl.
	* src/vm/jit/x86_64/codegen.c (codegen): ICMD_MULTIANEWARRAY:
	Use s3.c.cls instead of s3.arrayvftbl.

2006-09-05 12:29  edwin

	* src/vm/jit/jit.h (jitdata): Removed field new_rd.
	* src/vm/jit/jit.c (jit_compile): Use rd instead of new_rd.
	(jit_compile_intern): Likewise.
	* src/vm/jit/verify/typecheck.c (typecheck): Likewise.
	(verify_basic_block): Removed unused variables.
	* src/vm/jit/allocator/simplereg.c (new_regalloc):
	Use rd instead of new_rd.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.

2006-09-05 11:53  edwin

	* src/vm/jit/x86_64/codegen.c: Ported to new instruction format.
	* src/vm/jit/x86_64/emit.c: Likewise.
	* src/vm/jit/x86_64/md-emit.h: Likewise.

2006-09-05 11:50  edwin

	* src/vm/jit/jit.h (s3_operand_t): Added union field arrayvftbl.

2006-09-05 11:47  edwin

	* src/vm/jit/jit.c (jit_compile): Test setup for the new x86_64
	codegen.
	(jit_compile_intern): Likewise.

2006-09-05 11:42  edwin

	* src/vm/jit/emit.h (emit_load*): Changed for new instruction format.
	(emit_store*): Likewise.
	(emit_copy*): Likewise.
	(emit_store_dst): New function.

2006-09-05 11:40  edwin

	* src/vm/jit/jit.h (basicblock): Added fields invars and outvars.
	* src/vm/jit/stack.h (MARKREACHED): Set invars.
	* src/vm/jit/stack.c (new_stack_analyse): Set invars and outvars.
	* src/vm/jit/show.c (new_show_basicblock): Show invars and outvars.

2006-09-05 11:34  edwin

	* src/vm/jit/jit.h (NEW_INSTRUCTION_*): Renamed to INSTRUCTION_.
	The old INSTRUCTION_ and ICMD_ macros are removed.
	* src/vm/resolve.c (NEW_INSTRUCTION_*): Replaced with INSTRUCTION_.
	* src/vm/jit/show.c (new_show_icmd): Likewise.
	* src/vm/jit/allocator/simplereg.c (new_allocate_scratch_registers):
	Likewise.
	* src/vm/jit/stack.c (new_stack_analyse): Likewise, and add a call
	of builtintable_replace_function.

2006-09-05 11:20  edwin

	* src/vm/jit/verify/typecheck.c: Ported to new instruction format.
	* src/vm/jit/verify/typeinfo.c (typeinfo_print): Likewise.
	(typeinfo_print_short): Likewise.

2006-09-05 11:16  edwin

	* src/vm/builtin.h (builtintable_replace_function): Ported to new
	instruction format.
	* src/vm/builtin.c (builtintable_replace_function): Likewise.

2006-09-05 11:13  edwin

	* src/vm/jit/show.c (new_show_variable_array): New function.
	(new_show_method): Fixed calculation of lastbptr.
	Only show code lengths if stage >= SHOW_CODE.

2006-09-05 10:52  edwin

	* src/vm/resolve.h: Removed code for old instruction format.
	* src/vm/resolve.c: Likewise.

2006-09-05 10:47  edwin

	* src/vm/jit/allocator/simplereg.h: Removed code for old instruction
	format.
	* src/vm/jit/allocator/simplereg.c: Likewise.

2006-09-05 10:44  edwin

	* src/vm/jit/show.h: Removed code for old instruction format.
	* src/vm/jit/show.c: Likewise.

2006-09-05 10:39  edwin

	* src/vm/jit/stack.h: Removed code for old instruction format.
	* src/vm/jit/stack.c: Likewise.

2006-09-05 10:37  edwin

	* src/vm/jit/parse.h: Removed code for old instruction format.
	* src/vm/jit/parse.c: Likewise.

2006-09-05 10:20  edwin

	Branch for porting the new instruction format.

2006-09-05 10:15  twisti

	* src/vm/jit/i386/Makefile.am (noinst_HEADERS): Removed
	icmd_uses_reg_res.inc.

2006-09-05 10:10  twisti

	* src/vm/jit/i386/icmd_uses_reg_res.inc: Removed.

2006-09-05 10:09  edwin

	* src/vm/jit/x86_64/codegen.h (ICONST): Fix this macro so it properly
	uses its arguments.
	(LCONST): Likewise.

2006-09-05 10:04  twisti

	* src/tests/Howdy.java: Removed.

2006-09-05 10:03  twisti

	* src/vm/jit/x86_64/codegen.c (codegen): Use cd->stackframesize
	instead of stackframesize (bugfix).
	(createnativestub): Likewise.

2006-09-05 09:59  edwin

	* src/vm/jit/codegen-common.h (codegen_reg_of_dst): New function.
	* src/vm/jit/codegen-common.c (codegen_reg_of_dst): Likewise.
	Right now this duplicates codegen_reg_of_var's body. We should
	probably make one of these functions inline the other.

2006-09-05 00:12  edwin

	* src/vm/jit/ifconv/ifconv.c (ifconv_static): Deactivated
	show_basicblock calls that will become a problem when code for the
	old instruction format is removed.
	(check): Likewise.

2006-09-05 00:02  edwin

	* src/vm/resolve.c (resolve_field): new_resolve_field_verifier_checks
	used instead of the old function that will be removed soon.
	(resolve_method): Use new_resolve_method_verifier_checks instead of
	the
	old function that will be removed soon.
	(new_resolve_method_verifier_checks): Port handling of
	TYPEINFO_IS_NEWOBJECT.
	(new_resolve_method_verifier_checks): Likewise.
	(new_constrain_unresolved_field): Likewise.
	(new_constrain_unresolved_method): Likewise.

2006-09-04 23:24  edwin

	* src/vm/jit/parse.c (new_parse): Changed leftover "OP" macro uses
	to "NEW_OP".

2006-09-04 17:45  twisti

	* src/vm/jit/mips/emit.c (config.h): Added.
	[ENABLE_THREADS] (threads/native/lock.h): Likewise.
	(vm/exceptions.h): Likewise.
	(vm/stringlocal.h): Likewise.
	(vm/jit/asmpart.h): Likewise.
	(vm/jit/dseg.h): Likewise.
	(vm/jit/replace.h): Likewise.
	(emit_exception_stubs): New method.
	(emit_patcher_stubs): Likewise.
	(emit_replacement_stubs): Likewise.
	
	* src/vm/jit/mips/codegen.c (codegen): Use cd->stackframesize instead
	of stackframesize, use emit functions to generate stubs and call trace
	code.
	(createnativestub): Likewise.

2006-09-04 17:12  christian

	* src/vm/jit/alpha/patcher.c (patcher_wrapper): Patch back machine
	code.
	(patcher_aconst): Renamed to patcher_resolve_classref_to_classinfo.
	(patcher_clinit): Renamed to patcher_initialize_class.
	(patcher_resolve_native): Renamed to patcher_resolve_native_function.
	(patcher_athrow_areturn): Renamed to patcher_resolve_class.
	(patcher_checkcast_instanceof_class): Renamed to
	patcher_resolve_classref_to_vftbl.
	(patcher_checkcast_instanceof_flags): Renamed to
	patcher_resolve_classref_to_flags.
	(patcher_builtin_multianewarray): Removed.
	(patcher_builtin_arraycheckcast): Likewise.
	
	* src/vm/jit/alpha/codegen.c (codegen): Use new patcher functions.

2006-09-04 16:33  twisti

	* src/vm/jit/alpha/emit.c (vm/builtin.h): Added.
	(vm/jit/abi-asm.h): Likewise.
	(vm/jit/replace.h): Likewise.
	(emit_verbosecall_enter): New method.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/alpha/codegen.c (codegen): Use emit functions to generate
	call trace code.
	(createnativestub): Likewise.

2006-09-04 15:48  twisti

	* src/vm/jit/powerpc/emit.c (config.h): Added.
	[ENABLE_THREADS] (threads/native/lock.h): Likewise.
	(vm/builtin.h): Likewise.
	(vm/jit/abi-asm.h): Likewise.
	(vm/jit/asmpart.h): Likewise.
	(vm/jit/replace.h): Likewise.
	(emit_exception_stubs): New method.
	(emit_patcher_stubs): Likewise.
	(emit_replacement_stubs): Likewise.
	(emit_verbosecall_enter): Likewise.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Use emit functions to
	generate stubs and call trace code.
	(createnativestub): Likewise.

2006-09-04 14:21  twisti

	* src/vm/jit/powerpc/asmpart.S (asm_call_jit_compiler): We don't save
	an argument on the stack anymore, offsets adjusted.
	(asm_handle_exception): Use md_codegen_get_pv_from_pc instead of
	assembler code and temporary variables as on other RISC architectures.

2006-09-04 12:38  tbfg

	* src/vm/jit/powerpc64/emit.c (emit_verbosecall_enter): Fixed off
	by one stackslot overwrite some stuff bug.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Fix parameter passing
	in.

2006-09-02 14:26  tbfg

	* src/vm/jit/powerpc64/arch.h: Reenabled platfrom features.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Fixed native calls.
	(createnativestub): Likewise.

2006-08-31 19:58  tbfg

	* srv/vm/jit/powerpc64/asmpart.S (asm_vm_call_method): Fixed argument
	handling.

2006-08-31 13:32  tbfg

	* src/vm/jit/powerpc64/emit.c (emit_verbosecall_enter): Moved from
	codegen.c refactored into function, and made it work.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/powerpc64/codegen.c (codegen_trace_args): Moved into
	emit.c and renamed it to emit_verbosecall_enter.
	(codegen): Using emit_verbosecall_* instead of inline code, and
	various fixes to make verbose:call work.
	(createnativestub): Likewise.

2006-08-28 19:31  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.h: New REG_TOC name needed to
	call builtins due to ppc64 function descriptors (ELF ABI).
	
	* src/vm/jit/powerpc64/codegen.c (createnativestub): Big endian
	requires M_LLD and M_IST to copy s4 values from dseg to stack.
	(codegen): gen_method needs to create function descriptor call.
	
	* src/vm/jit/powerpc64/asmpart.S: When linking statically
	non function descriptor calls are generated by compiler.
	Some ifdefs added to fix static linking.

2006-08-28 15:18  twisti

	* src/vm/jit/patcher.h (patcher_resolve_class): Added.
	(patcher_initialize_class): Likewise.
	(patcher_resolve_classref_to_classinfo): Likewise.
	(patcher_resolve_classref_to_vftbl): Likewise.
	(patcher_resolve_classref_to_flags): Likewise.
	(patcher_resolve_native_function): Likewise.
	
	* src/vm/jit/powerpc/patcher.c (patcher_wrapper): Patch back machine
	code.
	(patcher_aconst): Renamed to patcher_resolve_classref_to_classinfo.
	(patcher_clinit): Renamed to patcher_initialize_class.
	(patcher_resolve_native): Renamed to patcher_resolve_native_function.
	(patcher_athrow_areturn): Renamed to patcher_resolve_class.
	(patcher_checkcast_class): Renamed to
	patcher_resolve_classref_to_vftbl.
	(patcher_checkcast_instanceof_flags): Renamed to
	patcher_resolve_classref_to_flags.
	(patcher_builtin_multianewarray): Removed.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_instanceof_class): Likewise.
	
	* src/vm/jit/powerpc/codegen.c (codegen): Use new patcher functions
	(some of them were already commited accidentally in the last commit).

2006-08-28 13:05  twisti

	* src/vm/jit/emit.h (emit_verbosecall_enter): Added.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/powerpc/emit.c (vm/builtin.h): Added.
	(vm/jit/asmpart.h): Likewise.
	(vm/jit/replace.h): Likewise.
	(emit_exception_stubs): New method.
	(emit_patcher_stubs): Likewise.
	(emit_replacement_stubs): Likewise.
	(emit_verbosecall_enter): Likewise.
	(emit_verbosecall_exit): Likewise.
	
	* src/vm/jit/powerpc/codegen.c (vm/jit/abi-asm.h): Added.
	(codegen_trace_args): Removed.
	(codegen): Use cd->stackframesize instead of stackframesize, use emit
	functions to generate stubs and call trace code.
	(createnativestub): Likewise.

2006-08-25 11:55  tbfg

	* src/vm/jit/show.c (show_method): Stubs are printed green when
	using -debug-color.
	
	* src/vm/jit/powerpc64/linux/md-os.c (md_signal_handler_sigusr2):
	Moved into #ifdef ENABLE_THREADS conditional compile, as it depends
	on threadobject.
	
	* src/vm/jit/powerpc64/codegen.h: Added M_LADD_IMM and M_AADD_IMM
	for better reading of code. Fixed M_CLR.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Some fixes with ?RETURN,
	some fixes for -verbose:call (still defunc),
	(createnativestub): Lots of fixes in stackframe calculations.
	
	* src/vm/jit/powerpc64/patcher.c (patch_aconst): Correct asm comment.
	
	* src/vm/jit/powerpc64/disass.c (disassinstr): Display 64 bit
	addresses in disassembled code (-sa).
	
	* src/vm/jit/powerpc64/asmpart.S (L_asm_vm_call_method_return):
	Fixed path for methods returning a value.
	(L_asm_handle_exception): Fixed path for exception handling.
	(asm_patcher_wrapper): Fixed path for codepatching.

2006-08-25 07:54  twisti

	* src/vm/exceptions.c (new_illegalmonitorstateexception): Renamed to
	exceptions_new_illegalmonitorstateexception.
	(exceptions_throw_illegalmonitorstateexception): New method.
	* src/vm/exceptions.h: Likewise.
	
	* src/threads/native/lock.c (lock_monitor_exit): Use
	exceptions_throw_illegalmonitorstateexception instead of
	new_illegalmonitorstateexception.
	(lock_monitor_wait): Likewise.
	(lock_monitor_notify): Likewise.
	
	* src/cacaoh/headers.c (new_illegalmonitorstateexception): Renamed to
	exceptions_throw_illegalmonitorstateexception.

2006-08-25 07:29  twisti

	* src/vm/jit/alpha/emit.c (emit_exception_stubs): Bugfix when
	reallocating the code area.
	(emit_patcher_stubs): Reuse the asm_patcher_wrapper call code.
	(emit_replacement_stubs): Removed savedmcodeptr.

2006-08-25 07:14  twisti

	* src/vm/jit/alpha/emit.c (emit_exception_stubs): Bugfix when
	reallocating the code area.
	(emit_patcher_stubs): Likewise.

2006-08-24 18:42  twisti

	* src/vm/jit/codegen-common.h (codegendata): Added stackframesize. I
	think this is more obvious than in jitdata.
	
	* src/vm/jit/jit.h (jitdata): Removed stackframesize.
	
	* src/vm/jit/alpha/emit.c (emit_exception_stubs): Replaced
	jd->stackframesize with cd->stackframesize.
	
	* src/vm/jit/alpha/codegen.c (codegen): Likewise.
	(createnativestub): Likewise.
	
	* src/vm/jit/i386/emit.c (emit_exception_stubs): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	(createnativestub): Likewise.

2006-08-24 09:29  tbfg

	srv/vm/jit/powerpc/linux/md-os.c (md_signal_handler_sigusr2): Moved
	inside
	ENABLE_THREADS ifdef as is depends on threads.

2006-08-23 16:04  twisti

	* src/vm/jit/alpha/emit.c [ENABLE_THREADS] (threads/native/lock.h):
	Added.
	(vm/jit/asmpart.h): Likewise.
	(vm/jit/dseg.h): Likewise.
	(emit_exception_stubs): New function.
	(emit_patcher_stubs): Likewise.
	(emit_replacement_stubs): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Use jd->stackframesize, removed
	stub generation code.
	(createnativestub): Likewise.

2006-08-23 15:55  twisti

	* src/vm/jit/alpha/asmpart.S (asm_handle_exception): Fixed bug with
	maybe-leaf stack and use same registers as on MIPS.

2006-08-23 15:45  twisti

	* src/vm/jit/alpha/asmpart.S (asm_handle_exception): Use
	md_codegen_get_pv_from_pc.

2006-08-23 15:10  twisti

	* src/vm/jit/mips/asmpart.S (asm_handle_exception): Changed some
	comments.

2006-08-23 14:55  twisti

	* src/vm/jit/alpha/asmpart.S (L_asm_handle_exception_stack_loop):
	Don't save xpc.

2006-08-23 14:23  twisti

	* src/boehm-gc/configure.in (AC_C_INLINE): Set CFLAGS properly before.

2006-08-23 14:07  twisti

	* configure.ac (AC_CONFIG_SUBDIRS): Moved to the end of the file and
	export OPT_CFLAGS/ARCH_CFLAGS instead of CFLAGS.
	
	* src/boehm-gc/configure.in: Pass CFLAGS to Makefile's as for CACAO.
	* src/boehm-gc/Makefile.am (AM_CXXFLAGS, AM_CFLAGS): Commented.
	(AM_CPPFLAGS): Added.

2006-08-23 12:57  twisti

	* src/vm/jit/alpha/emit.c (config.h): Added.
	[ENABLE_THREADS] (threads/native/lock.h): Likewise.
	(vm/jit/asmpart.h): Likewise.
	(vm/jit/dseg.h): Likewise.
	(emit_exception_stubs): New function.
	(emit_patcher_stubs): Likewise.
	(emit_replacement_stubs): Likewise.
	
	* src/vm/jit/alpha/codegen.c (codegen): Use jd->stackframesize, use
	new desg_add_* functions, removed stub generation code.
	(createnativestub): Likewise.

2006-08-23 12:29  twisti

	* src/vm/vm.c (OPT_ALL, OPT_METHOD, OPT_SIGNATURE): #ifndef NDEBUG.
	(usage): Don't print -all, -m, -sig options.

2006-08-23 12:12  twisti

	* src/vm/jit/emit.h (emit_replacement_stubs): Added.

2006-08-22 20:48  twisti

	* src/vm/jit/i386/md-emit.h (vm/jit/codegen-common.h): Added.

2006-08-22 19:53  twisti

	* src/vm/jit/emit.h (emit_exception_stubs): Added.
	(emit_patcher_stubs): Likewise.
	
	* src/vm/jit/jit.h (jitdata): Added member stackframesize.

2006-08-22 15:49  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.h: Added PA_SIZE and
	PA_SIZE_IN_POINTERS defines.
	
	* src/vm/jit/powerpc64/arch.h: Enabled machine dependend
	compare_and_swap implementation for ppc64.
	
	* src/vm/jit/powerpc64/codegen.c (codegen): Remove lot of PACK_REGS
	usages, changed stack address calculations from *4 -> *8, added
	a M_NOP for debugging.
	
	* src/vm/jit/powerpc64/machine-instr.h (compare_and_swap): Ported
	for 64 bit.
	(atomic_add): Removed.
	
	* src/vm/jit/powerpc64/patcher.c (patcher_wrapper): Fixed stack
	calculations from *4 -> *8
	(patcher_aconst): Likewise.
	(patcher_athrow_areturn): Likewise.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_builtin_multianewarray): Likewise.
	(patcher_checkcast_class): Likewise.
	(patcher_checkcast_instanceof_flags): Likewise.
	(patcher_checkcast_instanceof_interf): Likewise.
	(patcher_clinit): Likewise.
	(patcher_get_putfield): Likewise.
	(patcher_get_putstatic): Likewise.
	(patcher_instanceof_class): Likewise.
	(patcher_invokeinterface): Likewise.
	(patcher_invokestatic_special): Likewise.
	(patcher_invokevirtual): Likewise.
	(patcher_resolve_native): Likewise.
	
	* src/vm/jit/powerpc64/asmpart.S (asm_patcher_wrapper): Fixed
	calling convetions, as we callback C. Fixed 32 bit issues.
	(asm_call_jit_compiler): PPC64 has additional PA_SIZE
	on stack - fixed that.

2006-08-22 14:39  twisti

	* src/native/vm/java_lang_VMThrowable.c (fillInStackTrace): Removed
	architecture #ifdef's.
	(getStackTrace): Likewise.

2006-08-22 12:43  twisti

	* src/native/native.c (dummynativetable): Made non-static, GCC 4.1
	optimized the table away.
	(native_init): Removed dummynativetable-hack.

2006-08-22 09:02  tbfg

	* src/vm/options.h: Renamed -verbosecolor to -debug-color,
	opt_colorverbose to opt_debugcolor and OPT_COLORVERBOSE to
	OPT_DEBUGCOLOR
	* src/vm/method.c: Same as above.
	* src/vm/jit/dseg.c: Same as above.
	* src/vm/vm.c: Same as above.
	* src/vm/options.c: Same as above.
	* src/vm/jit/Makefile.am: Removed options.h dependecy, as deps are
	tracked automatically.

2006-08-21 17:37  twisti

	* src/lib/vm/reference/gnu/classpath/VMStackWalker.java
	(firstNonNullClassLoader): Added and made native.
	
	* src/native/vm/gnu_classpath_VMStackWalker.c (getClassContext):
	Removed architecture #ifdef's, as most stacktrace stuff is
	architecture independent and the dependent stuff is very simple to
	implement.
	(getCallingClass): Likewise.
	(getCallingClassLoader): Likewise.
	(firstNonNullClassLoader): Added.

2006-08-21 15:25  twisti

	* src/vm/jit/i386/asmpart.S (L_asm_patcher_wrapper_exception): Removed
	duplicate add line.

2006-08-21 15:17  twisti

	* configure.ac (AC_CONFIG_FILES): Added
	src/vm/jit/i386/darwin/Makefile.
	
	* src/vm/jit/i386/codegen.c (createnativestub): Align stack to
	16-bytes.
	
	* src/vm/jit/i386/darwin/md-os.c: Darwin specific functions.
	* src/vm/jit/i386/darwin/md-asm.h: Darwin specific assembler defines.
	* src/vm/jit/i386/darwin/Makefile.am: New file.
	* src/vm/jit/i386/darwin/.cvsignore: Likewise.
	
	* src/vm/jit/i386/linux/md-asm.h: Linux specific assembler defines.
	* src/vm/jit/i386/freebsd/md-asm.h: FreeBSD specific assembler
	defines.
	
	* src/vm/jit/i386/md-asm.h: Removed.
	
	* src/vm/jit/i386/asmpart.S (asm_handle_exception): Align stack to
	16-bytes.
	(asm_abstractmethoderror): Likewise.
	(asm_patcher_wrapper): Likewise.
	(asm_builtin_f2i, asm_builtin_d2i, asm_builtin_f2l, asm_builtin_d2l):
	Likewise.
	
	* src/vm/jit/i386/Makefile.am (DIST_SUBDIRS): Added darwin.
	(AM_CPPFLAGS): Added OS_DIR as include.
	(noinst_HEADERS): Removed md-asm.h.
	
	* src/threads/native/threads.c (threads_cast_darwinstop): Use generic
	defines and machine dependent structures.

2006-08-21 14:52  twisti

	* src/vm/jit/powerpc/darwin/md-asm.h (asm_initialize_thread_stack):
	Define removed.
	(asm_perform_threadswitch): Likewise.
	(asm_switchstackandcall): Likewise.

2006-08-18 18:37  tbfg

	src/vm/options.h: Added the commandlineswitch --verbosecolor which
	enables
	colored output of show: -si prints method names in red -sd shows
	datasegment
	dump in blue. (use | less -R)
	
	src/vm/options.c (options_get): There is a nasty bug in there, read
	comment.

2006-08-18 13:07  twisti

	* src/toolbox/util.c (util_current_time_millis): Removed.
	* src/toolbox/util.h: Likewise.
	
	* src/vm/vm.c (vm_create): Use builtin_currenttimemillis instead of
	util_current_time_millis.

2006-08-18 13:01  twisti

	* src/vm/exceptions.c (new_arraystoreexception): Renamed to
	exceptions_new_arraystoreexception.
	(exceptions_throw_arraystoreexception): New function.
	* src/vm/exceptions.h: Likewise.
	
	* src/vm/builtin.c (builtintable_init): Reimplemented and added
	builtintable_function.
	(builtintable_replace_function): New function.
	(builtin_arraycopy): Likewise.
	(builtin_currenttimemillis): Likewise.
	
	* src/vm/builtin.h (builtintable_entry): Added some extra members.
	(builtin_asm_get_exceptionptrptr): Removed.
	(builtintable_replace_function): Added.
	(builtin_arraycopy): Likewise.
	(builtin_currenttimemillis): Likewise.
	
	* src/vm/builtintable.inc (builtintable_internal): Use new
	builtintable_entry structure.
	(builtintable_automatic): Likewise.
	(builtintable_function): Added.
	
	* src/vm/jit/stack.c (stack_analyse): Call
	builtintable_replace_function.
	
	* src/vm/jit/show.c (new_show_icmd): Print correct variable of builtin
	calls.
	(show_icmd): Likewise.
	
	* src/vm/jit/stacktrace.c (stacktrace_inline_arraystoreexception): Use
	exceptions_new_arraystoreexception.
	
	* src/native/vm/java_lang_VMSystem.c (arraycopy): Removed
	implementation and use builtin_arraycopy.
	
	* src/cacaoh/headers.c
	(exceptions_throw_arrayindexoutofboundsexception): Added.
	(exceptions_new_arraystoreexception): Likewise.
	(exceptions_throw_arraystoreexception): Likewise.

2006-08-18 12:24  twisti

	* src/vm/class.c (class_java_lang_VMSystem): Added.
	* src/vm/class.h: Likewise.
	* src/vm/loader.c (loader_init): Likewise.
	* src/vm/linker.c (linker_init): Likewise.

2006-08-18 10:22  tbfg

	src/vm/jit/powerpc64/linux/md-os.c: Ported signal handlers to ppc64
	ucontext.

2006-08-17 17:51  tbfg

	src/vm/jit/powerpc64/md.c (md_get_method_patch_address): Fixed
	opcodes in
	casetests.
	
	src/vm/jit/powerpc64/arch.h: Temporarily disabled all hardwarefeaturs
	to
	make porting easier.
	
	src/vm/jit/powerpc64/codegen.c: Started to fix 32/64 bit issues.
	
	src/vm/jit/powerpc64/codegen.h: Removing special long handling.
	
	src/vm/jit/powerpc64/patcher.c: Changed comment only.

2006-08-17 09:59  twisti

	* src/vm/jit/i386/asmpart.S (asm_patcher_wrapper): Restore REG_ITMP3
	from stub stack. I missed this when I did the last changes.

2006-08-17 09:26  twisti

	* src/vm/jit/optimizing: Added ignore property.

2006-08-16 15:35  christian

	* src/vm/jit/optimizing/.cvsignore: New file.

2006-08-16 12:21  christian

	* src/vm/jit/stack.c (stack_analyse): Use of real PEI data
	(op_data[opcode][PEI]) to prevent copy propagation to LOCALVAR with
	ICMD_XSTORE instead of just regarding INVOKES as PEI's.

2006-08-16 12:11  christian

	* src/toolbox/worklist.h: Comments added.

2006-08-16 12:10  christian

	* src/toolbox/bitvector.c: Comments added.
	
	* src/toolbox/bitvector.h: Comments added.
	
	* src/toolbox/worklist.c: Comments added.

2006-08-16 11:35  christian

	* src/toolbox/worklist.c: Corrected Header information.
	
	* src/toolbox/worklist.h: Likewise.
	
	* src/toolbox/bitvector.c: Likewise.
	
	* src/toolbox/bitvector.h: Likewise.

2006-08-16 11:31  christian

	* src/vm/jit/allocator/liveness.c: Corrected Header information.
	
	* src/vm/jit/allocator/liveness.h: Likewise.
	
	* src/vm/jit/allocator/lsra.c: Likewise.
	
	* src/vm/jit/allocator/lsra.h: Likewise.

2006-08-16 11:26  christian

	* src/vm/jit/optimizing/dominators.c: Corrected Header information.
	
	* src/vm/jit/optimizing/dominators.h: Likewise.
	
	* src/vm/jit/optimizing/graph.c: Likewise.
	
	* src/vm/jit/optimizing/graph.h: Likewise.
	
	* src/vm/jit/optimizing/lifetimes.c: Likewise.
	
	* src/vm/jit/optimizing/lifetimes.h: Likewise.
	
	* src/vm/jit/optimizing/lsra.c: Likewise.
	
	* src/vm/jit/optimizing/lsra.h: Likewise.
	
	* src/vm/jit/optimizing/ssa.c: Likewise.
	
	* src/vm/jit/optimizing/ssa.h: Likewise.

2006-08-16 11:18  christian

	* src/vm/jit/optimizing/ssa.c (ssa_print_phi): Printing now phi
	functions correctly for debug output.
	
	* src/vm/jit/optimizing/ssa.c (dead_code_elimination): No removal of
	potential exception throwing instructions (PEI) anymore.
	
	* src/vm/jit/jit.h: Renamed op_needs_saved[] to op_data[][NEEDS_SAVED]
	and introduced the new op_data[][PEI].
	
	* src/vm/jit/jit.c (jit_init): Added init of op_data[NEEDS_SAVED|PEI]
	
	* src/vm/jit/optimizing/lifetimes.c (LifeOutAtStatement): Renamed
	op_needs_saved[] to the new op_data[][NEEDS_SAVED]

2006-08-15 14:54  christian

	* src/vm/jit/optimizing/lifetimes.c (LifenessAnalysis): Ignore
	variables used in phi functions, if they define itself (x =
	phi(...,x,...)).
	
	* src/vm/jit/i386/codegen.c (codegen): Bugfix in code created for
	ICMD_IINC for SSA.
	
	* src/vm/jit/show.c (new_show_method): Regard ENABLE_SSA like
	ENABLE_LSRA to suppress output of interfaces.
	
	* src/vm/jit/show.c (show_method): likewise.
	
	* src/vm/jit/show.c (show_icmd): Regard special operand format for
	ICMD_IINC with SSA.

2006-08-14 18:14  christian

	* src/vm/jit/optimizing/: New directory for optimizing compiler (SSA
	by now - does not work by now, code merging with svn head introduced
	some hazardous faults).
	
	* src/vm/jit/optimizing/dominators.c: Computation of dominators and
	domination frontier for SSA.
	
	* src/vm/jit/optimizing/dominators.h: Include file for dominators.c.
	
	* src/vm/jit/optimizing/graph.c: CFG functions needed for SSA.
	
	* src/vm/jit/optimizing/graph.h: Include file for graph.c
	
	* src/vm/jit/optimizing/lifetimes.c: Scanning lifetimes for SSA.
	
	* src/vm/jit/optimizing/lifetimes.h: Include file for lifetimes.c
	
	* src/vm/jit/optimizing/lsra.c: LSRA based on SSA.
	
	* src/vm/jit/optimizing/lsra.h: Include file for lsra.c.
	
	* src/vm/jit/optimizing/Makefile.am: New Makefile.am for this
	directory.
	
	* src/vm/jit/optimizing/ssa.c: Computation of SSA form.
	
	* src/vm/jit/optimizing/ssa.h: Include File for ssa.c.

2006-08-14 18:10  christian

	* src/vm/jit/optimizing: New directory

2006-08-14 17:50  christian

	* src/vm/jit/optimizing/: New directory for optimizing compiler (SSA
	by now - does not work by now, code merging with svn head introduced
	some hazardous faults).
	
	* src/vm/jit/optimizing/dominators.c: Computation of dominators and
	domination frontier for SSA.
	
	* src/vm/jit/optimizing/dominators.h: Include file for dominators.c.
	
	* src/vm/jit/optimizing/graph.c: CFG functions needed for SSA.
	
	* src/vm/jit/optimizing/graph.h: Include file for graph.c
	
	* src/vm/jit/optimizing/lifetimes.c: Scanning lifetimes for SSA.
	
	* src/vm/jit/optimizing/lifetimes.h: Include file for lifetimes.c
	
	* src/vm/jit/optimizing/lsra.c: LSRA based on SSA.
	
	* src/vm/jit/optimizing/lsra.h: Include file for lsra.c.
	
	* src/vm/jit/optimizing/Makefile.am: New Makefile.am for this
	directory.
	
	* src/vm/jit/optimizing/ssa.c: Computation of SSA form.
	
	* src/vm/jit/optimizing/ssa.h: Include File for ssa.c.
	
	* src/vm/jit/allocator/lsra.c: Moved from src/vm/jit. Quite complete
	code change (including: no more allocation of unused reserved
	registers, possibility of exact lifetime analysis, removal of old
	lifetime test functions).
	
	* src/vm/jit/allocator/lsra.h: Moved from src/vm/jit.
	
	* src/vm/jit/allocator/liveness.c: New File. Exact lifetime analysis
	for LSRA.
	
	* src/vm/jit/allocator/liveness.h: New File. Include File for
	liveness.c. The #define LV enables by now the exact liveness analysis.
	
	* src/vm/jit/allocator/Makefile.am: Adopted for new/moved files in
	src/vm/jit/allocator.
	
	* sc/vm/jit/Makefile.am: Adopted for above new/moved files.
	
	* configure.ac: Introduced ENABLE_SSA: new option --enable-ssa.
	Changes for ENABLE_LSRA (--enable-lsra). New Makefile in
	src/vm/jit/optimizing added.
	
	* src/vm/jit/allocator/simplereg.c (reg_make_statistics): Support for
	ENABLE_SSA for statistics.
	
	* src/vm/options.h: opt_lsra is used with ENABLE_SSA like with
	ENABLE_LSRA.
	
	* src/vm/options.c: opt_lsra is used with ENABLE_SSA like with
	ENABLE_LSRA.
	
	* src/vm/global.h: New struct imm for union imm_union to get another
	operand for IINC in combination with SSA added.
	
	* src/vm/vm.c: opt_lsra and the option -lsra is used with ENABLE_SSA
	like with ENABLE_LSRA.
	
	* src/vm/jit/stack.c (stack_analyse): No stack element lifetimes
	counting anymore for lsra/ssa (m->maxlifetimes).
	
	* src/vm/jit/stack.h: No stack lifetime counting anymore for lsra/ssa
	(m->maxlifetimes).
	
	* src/vm/jit/i386/codegen.c: Support for ENABLE_SSA added.
	
	* src/vm/jit/i386/codegen.c (codegen_insert_phi_moves): New function
	to insert phi moves for SSA at the end of Basic Blocks.
	
	* src/vm/jit/i386/codegen.c (cg_move): New function to create the
	instructions for the actual move for codegen_insert_phi_moves).
	
	* src/vm/jit/i386/codegen.c (codegen): Logic and calls to use
	codegen_insert_phi_moves for SSA added. With SSA for parameters in
	memory this memory positions cannot be reused to avoid copying. Checks
	added to prevent moves to or from stackslots removed by the dead code
	elimination. Special handling for the new ICMD_IINC operand format
	used by SSA added.
	
	* src/vm/jit/i386/codegen.h (M_COPY): Checks added to prevent moves to
	or from stackslots removed by the dead code elimination. Original
	M_COPY renamed to _M_COPY.
	
	* src/vm/jit/jit.c (jit_init): Populate op_needs_saved. Regard
	ENABLE_SSA.
	
	* src/vm/jit/jit.h: Support for ENABLE_SSA added. Added an array which
	shows which ICMD's need a SAVEDVAR for SSA and the new LSRA with exact
	liveness analysis. src/toolbox/Makefile.am: Changed to include the
	following new files:
	
	* src/toolbox/bitvector.c: Bitvector implementation for SSA.
	
	* src/toolbox/bitvector.h: Include file for bitvector.c.
	
	* src/toolbox/worklist.c: Worklist implementation for SSA.
	
	* src/toolbox/worklist.h: Include file for worklist.c.

2006-08-14 10:59  twisti

	* src/vm/jit/codegen-common.c (codegen_findmethod): Renamed to
	codegen_get_pv_from_pc.
	
	* src/vm/jit/codegen-common.h (codegen_findmethod): Likewise.
	(md_codegen_findmethod): Renamed to md_codegen_get_pv_from_pc.
	
	* src/vm/jit/stacktrace.c (stacktrace_create_stackframeinfo):
	Likewise.
	(stacktrace_create_inline_stackframeinfo): Likewise.
	(stacktrace_create_extern_stackframe): Likewise.
	(stacktrace_create): Likewise.
	
	* src/vm/jit/alpha/md.c (md_codegen_findmethod): Renamed to
	md_codegen_get_pv_from_pc.
	* src/vm/jit/i386/md.c: Likewise.
	* src/vm/jit/mips/md.c: Likewise.
	* src/vm/jit/powerpc/md.c: Likewise.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/sparc64/md.c: Likewise.
	* src/vm/jit/x86_64/md.c: Likewise.
	
	* src/vm/jit/i386/asmpart.S: Likewise.
	* src/vm/jit/mips/asmpart.S: Likewise.
	* src/vm/jit/powerpc/asmpart.S: Likewise.
	* src/vm/jit/x86_64/asmpart.S: Likewise.
	* src/vm/jit/intrp/asmpart.c: Likewise.
	
	* src/vm/jit/i386/patcher.c (patcher_wrapper): Fixed comment.
	* src/vm/jit/x86_64/patcher.c: Likewise.

2006-08-11 13:11  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.h: LA_WORD_SIZE renamed to
	LA_SIZE_IN_POINTERS, value fixed
	* src/vm/jit/powerpc64/linux/md-abi.c: LA_SIZE_IN_POINTERS rename
	* src/vm/jit/powerpc64/linux/md.c (md_codegen_findmethod): PPC64 uses
	r14
	instead of r13 (as PPC) for PV so opcodes changed.
	* src/vm/jit/powerpc64/asmpart.S: Using LA_SIZE instead of
	LA_WORD_SIZE,
	LA_SIZE_IN_POINTERS for SAVE_*_REGISTERS macros only.

2006-08-11 10:13  twisti

	* src/vm/jit/powerpc/linux/md-abi.h (LA_WORD_SIZE): Renamed to
	LA_SIZE_IN_POINTERS.
	
	* src/vm/jit/powerpc/darwin/md-abi.h (LA_WORD_SIZE): Likewise.
	
	* src/vm/jit/powerpc/linux/md-abi.c (md_param_alloc): Use
	LA_SIZE_IN_POINTERS instead of LA_WORD_SIZE.
	
	* src/vm/jit/powerpc/darwin/md-abi.c (md_param_alloc): Likewise.
	
	* src/vm/jit/powerpc/asmpart.S: Likewise.
	
	* src/vm/jit/stack.c (new_stack_analyse): Likewise.
	(stack_analyse): Likewise.
	
	* src/vm/jit/reg.c (reg_setup): Likewise.

2006-08-10 19:45  tbfg

	* src/vm/jit/powerpc64/linux/md-abi.h: fixed linkage area defines for
	64bit abi.
	* src/vm/jit/powerpc64/linux/md-asm.h: fixed register name defines
	and
	SAVE/RESTORE macros.
	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method): fixed no
	argument method
	call path, coming back to C now.

2006-08-10 09:10  twisti

	* src/boehm-gc/darwin_stop_world.c: Updated to version 6.8.
	* src/boehm-gc/doc/README.changes: Likewise.
	* src/boehm-gc/doc/README: Likewise.
	* src/boehm-gc/include/gc.h: Likewise.
	* src/boehm-gc/include/gc_config_macros.h: Likewise.
	* src/boehm-gc/include/private/gcconfig.h: Likewise.
	* src/boehm-gc/configure.in: Likewise.
	* src/boehm-gc/version.h: Likewise.
	* src/boehm-gc/malloc.c: Likewise.
	* src/boehm-gc/pthread_support.c: Likewise.
	* src/boehm-gc/os_dep.c: Likewise.
	* src/boehm-gc/dyn_load.c: Likewise.

2006-08-09 15:11  twisti

	* src/vm/jit/i386/codegen.c (codegen): Fixed ICMD_LMUL bug.

2006-08-09 15:10  twisti

	* src/vm/jit/i386/emit.c (emit_load_s1): Coding style changes.
	(emit_load_s2): Likewise.
	(emit_load_s3): Likewise.
	(emit_load_s1_low): Likewise.
	(emit_load_s2_low): Likewise.
	(emit_load_s1_high): Likewise.
	(emit_store): Likewise.

2006-08-08 19:57  edwin

	* src/vm/jit/jit.c (stackreq): Initialize this table statically.
	(jit_init): Removed dynamic initialization of stackreq table.

2006-08-08 19:23  edwin

	* src/native/vm/java_lang_reflect_Method.c
	(Java_java_lang_reflect_Method_invokeNative): Removed unused
	variables.
	
	* src/native/vm/java_lang_reflect_Constructor.c (vm/access.h):
	Include to fix warning.

2006-08-08 19:18  edwin

	* src/native/vm/java_lang_reflect_Field.c (cacao_get_field_address):
	Use access_check_caller.

2006-08-08 16:21  edwin

	* src/vm/access.h, src/vm/access.c (access_check_caller): Added.
	
	* src/native/vm/java_lang_reflect_Method.c
	(Java_java_lang_reflect_Method_invokeNative): Use access_check_caller
	for the access check.
	
	* src/native/vm/java_lang_reflect_Constructor.c
	(Java_java_lang_reflect_Constructor_constructNative): Likewise. This
	should fix the mauve test case
	java.lang.reflect.AccessibleObject.security.
	
	* src/cacaoh/headers.c (stacktrace_getClassContext): Added dummy
	implementation.

2006-08-08 14:24  twisti

	* src/vm/jit/parse.h (new_block_insert): Renamed to
	NEW_MARK_BASICBLOCK.
	(block_insert): Renamed to MARK_BASICBLOCK.
	
	* src/vm/jit/parse.c (new_fillextable): Likewise.
	(fillextable): Likewise.
	(new_parse): Likewise.
	(parse): Likewise.

2006-08-08 13:25  twisti

	* src/vm/jit/stack.c (new_stack_analyse): Replaced debug_nr with nr.
	
	* src/vm/jit/verify/typecheck.c (typestate_reach): Likewise.
	(verify_basic_block): Likewise.
	
	* src/vm/jit/i386/codegen.c (codegen): Likewise.
	* src/vm/jit/powerpc/codegen.c (codegen): Likewise.
	* src/vm/jit/x86_64/codegen.c (codegen): Likewise.

2006-08-08 13:03  twisti

	* src/vm/jit/cfg.c (cfg_insert_predecessors): New method.
	(cfg_build): Use cfg_insert_predecessors for TABLESWITCH and
	LOOKUPSWITCH.

2006-08-08 13:01  edwin

	* src/vm/resolve.h, src/vm/resolve.c (new_resolve_method_lazy):
	Removed curstack parameter.
	(new_resolve_field_lazy): Likewise.
	(new_constrain_unresolved_field): New function.
	(new_constrain_unresolved_method): Likewise.
	
	* src/vm/jit/parse.c (new_parse): Use new_resolve_field_lazy and
	new_resolve_method_lazy.

2006-08-08 12:56  edwin

	* src/vm/jit/stack.c (new_stack_analyse): For INVOKE* instructions,
	store the live-through stack slots as additional arguments after
	the live-in slots. These live-through slots are needed by the
	verifier and by on-stack replacement in order to create a replacement
	point at the call site.
	NOTE: Currently the live-through slots are also stored for builtins.
	This should change in the final version.

2006-08-08 12:46  edwin

	* src/vm/jit/jit.h (NEW_INSTRUCTION_IS_RESOLVED): New macro.
	(NEW_INSTRUCTION_IS_UNRESOLVED): Likewise.
	(NEW_INSTRUCTION_MUST_CHECK): Likewise.

2006-08-08 12:45  twisti

	* src/vm/jit/cfg.h (CFG_UNKNOWN_PREDECESSORS): Defined.
	
	* src/vm/jit/stack.c (vm/jit/cfg.h): Added.
	(new_stack_analyse): Set predecessorcount for EXH blocks to
	CFG_UNKNOWN_PREDECESSORS.
	(stack_analyse): Likewise.
	
	* src/vm/jit/show.c (new_show_basicblock): Print predecessor block
	numbers.
	(show_basicblock): Likewise.

2006-08-07 16:10  twisti

	* src/vm/jit/reorder.c (reorder): Iterate to m->basicblockcount + 1,
	so we kind of set the last basic block too.

2006-08-07 15:30  twisti

	* src/vm/jit/jit.h (basicblock): Renamed debug_nr to nr.
	(BASICBLOCK_INIT): Likewise.
	
	* src/vm/jit/reorder.c (reorder_place_next_unplaced_block): Likewise.
	(reorder): Likewise.
	
	* src/vm/jit/show.c (new_show_method): Likewise.
	(show_method): Likewise.
	(new_show_basicblock): Likewise.
	(show_basicblock): Likewise.
	(SHOW_TARGET): Likewise.
	(show_icmd): Likewise.
	
	* src/vm/jit/ifconv/ifconv.c (check): Likewise.
	
	* src/vm/jit/loop/analyze.c (insert_exception): Likewise.
	(copy_handler): Likewise.
	(create_static_checks): Likewise.
	
	* src/vm/jit/verify/typecheck.c (verify_basic_block): Likewise.
	(typecheck_reset_flags): Likewise.
	(typecheck): Likewise.
	
	* src/vm/jit/verify/typeinfo.c (typeinfo_print): Likewise.
	(typeinfo_print_short): Likewise.
	(typeinfo_print_stacktype): Likewise.

2006-08-07 15:12  tbfg

	* src/vm/jit/powerpc64/asmpart.S (asm_vm_call_method, asm_cacheflush):
	ppc64 abi needs function descriptor for function called from other
	relocateable modules and uses direct calling for module intern calls.

2006-08-07 11:15  twisti

	* src/vm/jit/reorder.c (reorder): #ifdef debug output.

2006-08-07 11:12  twisti

	* src/vm/jit/Makefile.am (libjit_la_SOURCES): Add cfg.[ch] and
	reorder.[ch] for debugging.

2006-08-07 11:10  twisti

	* src/vm/jit/jit.c (vm/jit/cfg.h): Added.
	(vm/jit/reorder.h): Likewise.
	(jit_recompile): Set JITDATA_FLAG_REORDER flag.
	(jit_compile_intern): Call cfg_build and reorder.
	(jit_complement_condition): New function.
	
	* src/vm/jit/jit.h (basicblock): Changed type of predecessors and
	successors.
	(jit_complement_condition): Added.
	
	* src/vm/jit/cfg.c (cfg_allocate_predecessors): New method.
	(cfg_allocate_successors): Likewise.
	(cfg_build): Finished implementation.
	
	* src/vm/jit/reorder.c (reorder_place_next_unplaced_block): New
	function.
	(reorder): Improved, still not working.
	
	* src/vm/jit/show.c (new_show_method): Walk the basic block chain to
	find the last block, as this may change.
	(show_method): Likewise.

2006-08-04 14:50  twisti

	* src/vm/jit/reorder.c: New file.
	* src/vm/jit/reorder.h: Likewise.

2006-08-04 14:42  twisti

	* src/vm/jit/parse.c (new_parse): MZERO basicblock array.
	(parse): Likewise.
	
	* src/vm/jit/jit.h (JITDATA_FLAG_REORDER): Added.
	(JITDATA_HAS_FLAG_REORDER): Likewise.
	(basicblock): Removed pre_count and added predecessorcount,
